/*************************************************************************
 *
 *  $RCSfile: basobj.hxx,v $
 *
 *  $Revision: 1.11 $
 *
 *  last change: $Author: tbe $ $Date: 2001/07/25 14:57:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BASOBJ_HXX
#define _BASOBJ_HXX


#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif

#ifndef _COM_SUN_STAR_IO_XINPUTSTREAMPROVIDER_HXX_
#include <com/sun/star/io/XInputStreamProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XLIBRARYCONTAINER_HPP_
#include <com/sun/star/script/XLibraryContainer.hpp>
#endif

class SfxMDIFrame;
class SfxMacro;
class SbMethod;
class SbModule;
class SbxObject;
class SbxVariable;
class StarBASIC;
class BasicManager;
class SfxObjectShell;
class SvStrings;
class SfxViewFrame;
class SfxUInt16Item;
class SfxBindings;
struct BasicIDE_Impl;

extern "C" {
	rtl_uString* basicide_choose_macro( BOOL bExecute, BOOL bChooseOnly, rtl_uString* pMacroDesc );
}

class BasicIDE: public SfxListener
{

#if SUPD > 626
	BasicIDE_Impl*		pBasicIDE_Impl;
#endif

protected:
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType );
	SfxViewFrame*		ImplGetViewFrame() const;

public:
						BasicIDE();
						~BasicIDE();

	void				Create();
	void				Destroy();
	static void			Appear();

	BOOL				IsCreated() const;
	static String		GetStdTitle()	{ return String( RTL_CONSTASCII_USTRINGPARAM( "BASIC" ) ); }

	static SfxMacro*	CreateMacro();
    static void			Organize();

	static USHORT		GetBasicDialogCount();
	static void			IncBasicDialogCount();
	static void			DecBasicDialogCount();


	// Hilfsmethoden fuer den allg. Gebrauch:
    static SbMethod*	FindMacro( SbModule* pModule, const String& rMacroName );
    static SbMethod*	CreateMacro( SbModule* pModule, const String& rMacroName );
	static void			RunMethod( SbMethod* pMethod );

	static StarBASIC*	FindBasic( const SbxVariable* pVar );
	static void			StopBasic();
	static void			HandleBasicError();
	static void			BasicStopped( BOOL* pbAppWindowDisabled = 0, BOOL* pbDispatcherLocked = 0, USHORT* pnWaitCount = 0,
							SfxUInt16Item** ppSWActionCount = 0, SfxUInt16Item** ppSWLockViewCount = 0 );

	static BOOL			IsValidSbxName( const String& rName );

	static void			 		UpdateModuleInLibrary( SbModule* pMod );
	static BasicManager* 		FindBasicManager( StarBASIC* pLib );
	static BasicManager* 		FindBasicManager( const String& rMgrName );
	static String 				FindTitle( BasicManager* pBascMgr, USHORT nSFXTitleType = 0 );
	static SfxObjectShell* 		FindDocShell( BasicManager* pBasMgr );
	static void 				MarkDocShellModified( StarBASIC* pBasic );

	static SfxBindings& 		GetBindings();

	static SvStrings*			CreateBasicLibBoxEntries();

	static void			InvalidateDebuggerSlots();

	// new methods for macros

    static ::rtl::OUString		ChooseMacro( BOOL bExecute = TRUE, BOOL bChooseOnly = FALSE, const ::rtl::OUString& rMacroDesc = ::rtl::OUString() );

	static ::com::sun::star::uno::Sequence< ::rtl::OUString > GetMethodsFromModule(
		SfxObjectShell* pShell, const String& rLibName, const String& rModName )
		throw( ::com::sun::star::container::NoSuchElementException );

	// new methods for modules

	static ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > GetModuleLibrary( 
		SfxObjectShell* pShell, const String& rLibName, BOOL bLoadLibrary = FALSE )
		throw( ::com::sun::star::container::NoSuchElementException );

	static BOOL					HasModule(
		SfxObjectShell* pShell, const String& rLibName, const String& rModName );

	static ::rtl::OUString		GetModule(
		SfxObjectShell* pShell, const String& rLibName, const String& rModName )
		throw( ::com::sun::star::container::NoSuchElementException );

	static String				CreateModuleName( SfxObjectShell* pShell, const String& rLibName );

	static ::rtl::OUString		CreateModule( 
		SfxObjectShell* pShell, const String& rLibName, const String& rModName, BOOL bCreateMain = FALSE )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	static void					RenameModule( 
		SfxObjectShell* pShell, const String& rLibName, const String& rOldName, const String& rNewName )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	static void					RemoveModule( 
		SfxObjectShell* pShell, const String& rLibName, const String& rModName )
		throw( ::com::sun::star::container::NoSuchElementException );

	static void					InsertModule( 
		SfxObjectShell* pShell, const String& rLibName, const String& rModName, ::rtl::OUString& aModule )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	// new methods for dialogs

	static ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > GetDialogLibrary( 
		SfxObjectShell* pShell, const String& rLibName, BOOL bLoadLibrary = FALSE )
		throw( ::com::sun::star::container::NoSuchElementException );

	static BOOL					HasDialog(
		SfxObjectShell* pShell, const String& rLibName, const String& rDlgName );

	static ::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStreamProvider > GetDialog(
		SfxObjectShell* pShell, const String& rLibName, const String& rDlgName )
		throw( ::com::sun::star::container::NoSuchElementException );

	static String				CreateDialogName( SfxObjectShell* pShell, const String& rLibName );

	static ::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStreamProvider > CreateDialog( 
		SfxObjectShell* pShell, const String& rLibName, const String& rDlgName )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	static void					RenameDialog( 
		SfxObjectShell* pShell, const String& rLibName, const String& rOldName, const String& rNewName )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	static void					RemoveDialog( 
		SfxObjectShell* pShell, const String& rLibName, const String& rDlgName )
		throw( ::com::sun::star::container::NoSuchElementException );

	static void					InsertDialog( 
		SfxObjectShell* pShell, const String& rLibName, const String& rDlgName,
		const com::sun::star::uno::Reference< com::sun::star::io::XInputStreamProvider >& xISP )
		throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::container::NoSuchElementException );

	static void 				MarkDocShellModified( SfxObjectShell* pShell );
};

#endif	// _BASOBJ_HXX
