#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.9 $
#
#   last change: $Author: kso $ $Date: 2001/07/17 08:43:29 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=chaos
TARGET=unotypes
.INCLUDE :  $(PRJ)$/util$/makefile.pmk
AUTOSEG=true

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=$(OUT)$/inc

UNOTYPES=\
	com.sun.star.beans.PropertyAttribute \
	com.sun.star.beans.PropertySetInfoChange \
	com.sun.star.beans.PropertyValue \
	com.sun.star.beans.XPropertiesChangeNotifier \
	com.sun.star.beans.XPropertyAccess \
	com.sun.star.beans.XPropertyChangeListener \
	com.sun.star.beans.XPropertyContainer \
	com.sun.star.beans.XPropertySetInfoChangeNotifier \
	com.sun.star.container.XChild \
	com.sun.star.frame.XConfigManager \
	com.sun.star.io.XActiveDataSink \
	com.sun.star.io.XInputStream \
        com.sun.star.io.XOutputStream \
	com.sun.star.io.XSeekable \
	com.sun.star.lang.Locale \
	com.sun.star.lang.XComponent \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XServiceInfo \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.lang.XTypeProvider \
	com.sun.star.registry.XRegistryKey \
	com.sun.star.registry.XSimpleRegistry \
	com.sun.star.script.XTypeConverter \
	com.sun.star.sdbc.XCloseable \
	com.sun.star.sdbc.XColumnLocate \
	com.sun.star.sdbc.XResultSetMetaData \
	com.sun.star.sdbc.XResultSetMetaDataSupplier \
	com.sun.star.sdbc.XRow \
	com.sun.star.task.XInteractionAbort \
	com.sun.star.task.XInteractionApprove \
	com.sun.star.task.XInteractionDisapprove \
	com.sun.star.task.XInteractionRetry \
	com.sun.star.ucb.AuthenticationRequest \
	com.sun.star.ucb.Command \
	com.sun.star.ucb.CommandInfoChange \
	com.sun.star.ucb.ContentAction \
	com.sun.star.ucb.ContentInfoAttribute \
	com.sun.star.ucb.CrossReference \
	com.sun.star.ucb.CHAOSProgressStart \
	com.sun.star.ucb.DocumentHeaderField \
	com.sun.star.ucb.ExportStreamInfo \
	com.sun.star.ucb.FolderList \
	com.sun.star.ucb.HandleCookiesRequest \
	com.sun.star.ucb.InsertCommandArgument \
	com.sun.star.ucb.InteractiveBadTransferURLException \
	com.sun.star.ucb.InteractiveCHAOSException \
	com.sun.star.ucb.InteractiveIOException \
	com.sun.star.ucb.InteractiveNetworkConnectException \
	com.sun.star.ucb.InteractiveNetworkGeneralException \
	com.sun.star.ucb.InteractiveNetworkOffLineException \
	com.sun.star.ucb.InteractiveNetworkReadException \
	com.sun.star.ucb.InteractiveNetworkResolveNameException \
	com.sun.star.ucb.InteractiveNetworkWriteException \
	com.sun.star.ucb.ListActionType \
	com.sun.star.ucb.OpenCommandArgument2 \
	com.sun.star.ucb.OpenMode \
	com.sun.star.ucb.PostCommandArgument \
	com.sun.star.ucb.PropertyValueInfo \
	com.sun.star.ucb.RecipientInfo \
	com.sun.star.ucb.RememberAuthentication \
	com.sun.star.ucb.ResultSetException \
	com.sun.star.ucb.RuleSet \
	com.sun.star.ucb.SearchCommandArgument \
	com.sun.star.ucb.SendInfo \
	com.sun.star.ucb.SendMediaTypes \
	com.sun.star.ucb.SortingInfo \
	com.sun.star.ucb.TransferInfo \
	com.sun.star.ucb.TransferResult \
        com.sun.star.ucb.UnsupportedDataSinkException \
        com.sun.star.ucb.UnsupportedOpenModeException \
	com.sun.star.ucb.WelcomeDynamicResultSetStruct \
	com.sun.star.ucb.XCachedDynamicResultSetStubFactory \
	com.sun.star.ucb.XCommandInfo \
	com.sun.star.ucb.XCommandInfoChangeNotifier \
	com.sun.star.ucb.XContentAccess \
	com.sun.star.ucb.XContentCreator \
	com.sun.star.ucb.XContentIdentifierFactory \
	com.sun.star.ucb.XContentProvider \
	com.sun.star.ucb.XContentProviderManager \
	com.sun.star.ucb.XContentTransmitter \
	com.sun.star.ucb.XDataContainer \
	com.sun.star.ucb.XDynamicResultSet \
	com.sun.star.ucb.XInteractionCookieHandling \
	com.sun.star.ucb.XInteractionHandlerSupplier \
	com.sun.star.ucb.XInteractionSupplyAuthentication \
	com.sun.star.ucb.XPropertyMatcherFactory \
	com.sun.star.ucb.XPropertySetRegistry \
	com.sun.star.ucb.XPropertySetRegistryFactory \
	com.sun.star.ucb.XRecycler \
	com.sun.star.ucb.XSourceInitialization \
	com.sun.star.uno.TypeClass \
	com.sun.star.uno.XAggregation \
	com.sun.star.uno.XInterface \
	com.sun.star.uno.XWeak \
	com.sun.star.util.DateTime \
	com.sun.star.util.DateTimeRange \
	com.sun.star.util.XModifyBroadcaster \
	com.sun.star.util.XTextSearch

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

