/*************************************************************************
 *
 *  $RCSfile: pathhelper.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: lla $ $Date: 2001/06/01 06:55:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CONFIGMGR_PATHHELPER_HXX_
#define CONFIGMGR_PATHHELPER_HXX_
#include <rtl/ustring.hxx>

namespace configmgr
{
	
	class OEnsureDirectory;

class PathHelper
{
	rtl::OUString m_sPath;						 // f:/office/(share|user)/config/registry
	rtl::OUString m_sInstance;					 // (instance|template|cache)
	rtl::OUString m_sModule;					 // org/openoffice/...

	bool          m_bUseNewFileStructure; // if false, use files with name org.openoffice.xxx

	OEnsureDirectory *m_pDirectoryGuarantee;

	void checkDirStructure();
	rtl::OUString getFileURL(rtl::OUString const& _aModuleName, rtl::OUString const& _aFullPath, rtl::OUString const& _aExtraDirectory, rtl::OUString const& _sExtension) const;
	void ensure_DirectoryGuarantee();

	PathHelper(PathHelper const&);
	PathHelper& operator=(PathHelper const&);
	rtl::OUString createDirectory(rtl::OUString const& _sExtraDirectory) const;
public:

	PathHelper();
	~PathHelper();

	rtl::OUString createFileURL() const;
	rtl::OUString createBinaryFileURL() const;
	rtl::OUString createFileUpdateURL() const;
	rtl::OUString createDirectory() const;
	rtl::OUString createBinaryDirectory() const;

 	// rtl::OUString getFileURL();

	void setPath(rtl::OUString const& _sPath);
	void setModule(rtl::OUString const& _sModule);
	void setInstance(rtl::OUString const& _sInstance) 
		{
			if (m_sPath.getLength() == 0) return;    // SetupSession
			if (!m_sInstance.equals(_sInstance))
			{
				m_sInstance = _sInstance;
				if (m_bUseNewFileStructure == false)
					checkDirStructure();			 // check for other Structure only if old mode
			}
		}
	
	rtl::OUString getModule() const {return m_sModule;}
	rtl::OUString getPath() const {return m_sPath;}
	
	void checkDirectory(rtl::OUString const& _sDirectoryURL);

	bool isNewFileStructure() {return m_bUseNewFileStructure;}
	void setNewFileStructure(bool _bValue) {m_bUseNewFileStructure = _bValue;}

	static rtl::OUString convertFilenameToDirectory(rtl::OUString const& _sFilename);
};

} // namespace

#endif
