/*************************************************************************
 *
 *  $RCSfile: MABTables.cxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: csaba $ $Date: 2001/07/13 17:30:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Darren Kenny, Willem van Dorp
 *
 *
 ************************************************************************/

#include <stdio.h>
#ifndef _CONNECTIVITY_MAB_TABLES_HXX_
#include "mozaddressbook/MABTables.hxx"
#endif
#ifndef _CONNECTIVITY_MAB_TABLE_HXX_
#include "mozaddressbook/MABTable.hxx"
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XRESULTSET_HPP_
#include <com/sun/star/sdbc/XResultSet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_COLUMNVALUE_HPP_
#include <com/sun/star/sdbc/ColumnValue.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_KEYRULE_HPP_
#include <com/sun/star/sdbc/KeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_KEYTYPE_HPP_
#include <com/sun/star/sdbcx/KeyType.hpp>
#endif
#ifndef _CONNECTIVITY_FILE_CATALOG_HXX_
#include "file/FCatalog.hxx"
#endif
#ifndef _CONNECTIVITY_FILE_BCONNECTION_HXX_
#include "file/FConnection.hxx"
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _CONNECTIVITY_MAB_CATALOG_HXX_
#include "mozaddressbook/MABCatalog.hxx"
#endif
#ifndef _COMPHELPER_TYPES_HXX_
#include <comphelper/types.hxx>
#endif

#include <MABDebug.hxx>

 
using namespace connectivity::mozaddressbook;
using namespace connectivity::file;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::container;


namespace starutil		= ::com::sun::star::util;

Reference< XNamed > OMozabTables::createObject(const ::rtl::OUString& _rName)
{
	//OSL_TRACE( "IN OMozabTables::createObject( %s )\n", OUtoCStr( _rName )?OUtoCStr( _rName ):"NULL" );
	::rtl::OUString aName,aSchema;
	OMozabTable* pRet = new OMozabTable((OMozabConnection*)static_cast<OFileCatalog&>(m_rParent).getConnection(),
										_rName,::rtl::OUString::createFromAscii("TABLE"));

	Reference< XNamed > xRet = pRet;
//	if(!pRet->isValid())
//	{
//		::comphelper::disposeComponent(xRet);
//		throw SQLException(::rtl::OUString::createFromAscii("Invalid DBase file found!"),m_rParent,_rName,1000,Any());
//	}

	OSL_TRACE( "\tOUT OMozabTables::createObject()\n" );
	return xRet;
}
// -------------------------------------------------------------------------
void OMozabTables::impl_refresh(  ) throw(RuntimeException)
{
	OSL_TRACE( "IN/OUT OMozabTables::impl_refresh()\n" );
	static_cast<OMozabCatalog*>(&m_rParent)->refreshTables();
}
// -------------------------------------------------------------------------
Reference< XPropertySet > OMozabTables::createEmptyObject()
{
	OSL_TRACE( "IN OMozabTables::createEmptyObject()\n" );
	OMozabTable* pRet = new OMozabTable((OMozabConnection*)static_cast<OFileCatalog&>(m_rParent).getConnection());
	Reference< XPropertySet > xRet = pRet;
	OSL_TRACE( "\tOUT OMozabTables::createEmptyObject()\n" );
	return xRet;
}
typedef connectivity::sdbcx::OCollection OMozabTables_BASE_BASE;
// -------------------------------------------------------------------------
// XAppend
void SAL_CALL OMozabTables::appendByDescriptor( const Reference< XPropertySet >& descriptor ) throw(SQLException, ElementExistException, RuntimeException)
{
	OSL_TRACE( "IN OMozabTables::appendByDescriptor()\n" );
	::osl::MutexGuard aGuard(m_rMutex);

	::rtl::OUString aName = ::comphelper::getString(descriptor->getPropertyValue(OMetaConnection::getPropMap().getNameByIndex(PROPERTY_ID_NAME)));
	ObjectMap::iterator aIter = m_aNameMap.find(aName);
	if( aIter != m_aNameMap.end())
		throw ElementExistException(aName,*this);

	Reference<XUnoTunnel> xTunnel(descriptor,UNO_QUERY);
	if(xTunnel.is())
	{
		OMozabTable* pTable = (OMozabTable*)xTunnel->getSomething(OMozabTable::getUnoTunnelImplementationId());
		if(pTable && pTable->CreateImpl())
		{
			OMozabTables_BASE_BASE::appendByDescriptor(Reference< XPropertySet >(createObject(aName),UNO_QUERY));
		}
	}
	OSL_TRACE( "\tOUT OMozabTables::appendByDescriptor()\n" );
}
// -------------------------------------------------------------------------
// XDrop
void SAL_CALL OMozabTables::dropByName( const ::rtl::OUString& elementName ) throw(SQLException, NoSuchElementException, RuntimeException)
{
	OSL_TRACE( "IN OMozabTables::dropByName()\n" );
	::osl::MutexGuard aGuard(m_rMutex);

	ObjectMap::iterator aIter = m_aNameMap.find(elementName);
	if( aIter == m_aNameMap.end())
		throw NoSuchElementException(elementName,*this);

	Reference< XUnoTunnel> xTunnel(aIter->second.get(),UNO_QUERY);
	if(xTunnel.is())
	{
		OMozabTable* pTable = (OMozabTable*)xTunnel->getSomething(OMozabTable::getUnoTunnelImplementationId());
		if(pTable && pTable->DropImpl())
			OMozabTables_BASE_BASE::dropByName(elementName);
	}
	OSL_TRACE( "\tOUT OMozabTables::dropByName()\n" );

}
// -------------------------------------------------------------------------
void SAL_CALL OMozabTables::dropByIndex( sal_Int32 index ) throw(SQLException, IndexOutOfBoundsException, RuntimeException)
{
	OSL_TRACE( "IN OMozabTables::dropByIndex()\n" );
	::osl::MutexGuard aGuard(m_rMutex);
	if (index < 0 || index >= getCount())
                throw IndexOutOfBoundsException();

	dropByName((*m_aElements[index]).first);
	OSL_TRACE( "\tOUT OMozabTables::dropByIndex()\n" );
}
// -------------------------------------------------------------------------
//------------------------------------------------------------------
Any SAL_CALL OMozabTables::queryInterface( const Type & rType ) throw(RuntimeException)
{
	OSL_TRACE( "IN OMozabTables::queryInterface()\n" );
	typedef sdbcx::OCollection OTables_BASE;
	OSL_TRACE( "\tOUT OMozabTables::queryInterface()\n" );
	return OTables_BASE::queryInterface(rType);
}

