#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.11 $
#
#   last change: $Author: mh $ $Date: 2001/07/31 10:25:59 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..
PRJINC=..$/..
PRJNAME=connectivity
TARGET=mozab

.IF "$(BUILD_SOSL)"!=""
all: 
	@echo "		Not building the addressbook driver in OpenOffice.org build"
	@echo "		dependency to Mozilla developer snapshots not feasable at the moment"
.ENDIF

#mozilla specific stuff.
#.IF "$(GUI)" == "WNT"
MOZ_LIB=$(SOLARVERSION)$/$(INPATH)$/lib$(UPDMINOREXT)
MOZ_INC=$(SOLARVERSION)$/$(INPATH)$/inc$(UPDMINOREXT)/$/mozilla
#.ELSE
#MOZ_INC=
#MOZ_LIB=
#.ENDIF
.IF "$(OS)"=="WNT" 
LIB += $(MOZ_LIB)
MOZ_LIB_XPCOM= $(MOZ_LIB)$/baseembed_s.lib $(MOZ_LIB)$/nspr4.lib $(MOZ_LIB)$/mozreg.lib $(MOZ_LIB)$/xpcom.lib
.ELSE
MOZ_LIB_XPCOM= -L$(MOZ_LIB) -lembed_base_s -lnspr4 -lmozreg_s -lxpcom
.ENDIF
#End of mozilla specific stuff.


ENABLE_EXCEPTIONS=TRUE

# --- Settings ----------------------------------
.IF "$(DBGUTIL_OJ)"!=""
ENVCFLAGS+=/FR$(SLO)$/
.ENDIF

.INCLUDE : settings.mk
.INCLUDE :  $(PRJ)$/version.mk

# --- Recursiveness  ---------------------------------------------------

RC_SUBDIRS = mozillasrc


# --- Files -------------------------------------

MOZSLOFILES = \
	$(SLO)$/MABNSInit.obj			            \
	$(SLO)$/MABQueryHelper.obj			        \
	$(SLO)$/MABQuery.obj			            \
	$(SLO)$/MABDatabaseMetaDataHelper.obj	    \
	$(SLO)$/MABTypeConverter.obj                \
	$(SLO)$/MABNameMapper.obj

SLOFILES=\
	$(SLO)$/MABDatabaseMetaData.obj	    \
	$(SLO)$/MABResultSet.obj			\
	$(SLO)$/MABStatement.obj			\
	$(SLO)$/MABPreparedStatement.obj	\
	$(SLO)$/MABCatalog.obj			    \
	$(SLO)$/MABColumns.obj			    \
	$(SLO)$/MABTable.obj				\
	$(SLO)$/MABTables.obj				\
	$(SLO)$/MABConnection.obj			\
	$(SLO)$/MABColumnAlias.obj			\
	$(SLO)$/MABservices.obj			    \
	$(SLO)$/MABDriver.obj               \
    $(MOZSLOFILES)


# SCO and MACOSX: the linker does know about weak symbols, but we can't ignore multiple defined symbols
.IF "$(OS)"=="SCO" || "$(OS)$(COM)"=="OS2GCC" || "$(OS)"=="MACOSX" 
SLOFILES+=$(SLO)$/staticmbmozab.obj
.ENDIF

SHL1VERSIONMAP= $(TARGET).map
# --- Library -----------------------------------

SHL1TARGET=$(TARGET)$(UPD)$(DLLPOSTFIX)
#SHL1OBJS=$(SLOFILES) $(MOZSLOFILES)
SHL1OBJS=$(SLOFILES)
SHL1STDLIBS=\
	$(CPPULIB)					\
	$(CPPUHELPERLIB)			\
	$(VOSLIB)					\
	$(OSLLIB)					\
	$(SVLLIB)					\
	$(TOOLSLIB)					\
	$(SVTOOLLIB)				\
	$(UCBHELPERLIB)				\
	$(SALLIB)					\
	$(DBTOOLSLIB)				\
	$(DBFILELIB)				\
	$(UNOTOOLSLIB)				\
	$(COMPHELPERLIB)			\
	$(MOZ_LIB_XPCOM)

.IF "$(DBFILELIB)" == ""
SHL1LIBS= $(SLB)$/file.lib
.ENDIF

SHL1DEPN=
SHL1IMPLIB=	i$(TARGET)

SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

DEF1NAME=	$(SHL1TARGET)
DEF1EXPORTFILE=	exports.dxp


# --- Targets ----------------------------------

.INCLUDE : target.mk


