#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.13 $
#
#   last change: $Author: mh $ $Date: 2001/07/31 10:26:29 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
CALL_CDECL=TRUE

#mozilla specific stuff.
#.IF "$(GUI)" == "WNT"
MOZ_LIB=$(SOLARVERSION)$/$(INPATH)$/lib$(UPDMINOREXT)
MOZ_INC=$(SOLARVERSION)$/$(INPATH)$/inc$(UPDMINOREXT)/$/mozilla
#.ELSE
#MOZ_INC=
#MOZ_LIB=
#.ENDIF
#End of mozilla specific stuff.

PRJ=..$/..$/..$/..
PRJINC=..$/..$/..
PRJNAME=connectivity
TARGET=mozab

ENABLE_EXCEPTIONS=TRUE

# --- Settings ----------------------------------
.IF "$(DBGUTIL_OJ)"!=""
ENVCFLAGS+=/FR$(SLO)$/
.ENDIF

.INCLUDE : settings.mk
.INCLUDE :  $(PRJ)$/version.mk

.IF "$(BUILD_SOSL)"!=""
all: 
	echo "		Not building the addressbook driver in OpenOffice.org build"
	echo "		dependency to Mozilla developer snapshots not feasable at the moment"
.ENDIF

#mozilla specific stuff.
# --- Files -------------------------------------

SLOFILES = \
	$(SLO)$/MABNSInit.obj			            \
	$(SLO)$/MABQueryHelper.obj			        \
	$(SLO)$/MABDatabaseMetaDataHelper.obj		\
	$(SLO)$/MABQuery.obj			            \
	$(SLO)$/MABTypeConverter.obj                \
	$(SLO)$/MABNameMapper.obj


# SCO and MACOSX: the linker does know about weak symbols, but we can't ignore multiple defined symbols
#.IF "$(OS)"=="SCO" || "$(OS)$(COM)"=="OS2GCC" || "$(OS)"=="MACOSX" 
#SLOFILES+=$(SLO)$/staticmbmozab.obj
#.ENDIF

# SHL1VERSIONMAP= $(TARGET).map
# --- Library -----------------------------------

#INCPRE +=   -I$(MOZ_INC) -DDEBUG -DMOZILLA_CLIENT 
#            -include $(MOZ)/config-defs.h \
#            -fno-rtti -fno-exceptions -pthread 
# -Wall = Enable all warnings
# -Wconversion = Warn in case of illegal type conversion
# -Wpointer-arith = warns about sizeof or void use
# -Wbad-function-cast = self explanatory
# -Wcast-align = ditto
# -Woverloaded-virtual = warn if derived functions are not correctly defined
# -Wsynth = warn when g++ behaviour differs from cfront
# -Wno-long-long = do no warn in case of type long long
# -fno-rtti = -GR-
# -fPIC = Generate position independant code
# -fno-exception = disable exception handling
# -pthread = ???
# -g = produce debugging information
# -include = direct preprocessor to compile this file first


.IF "$(GUI)" == "WNT"
.IF "$(DEBUG)" == ""
INCPRE +=   -I.. -I$(MOZ_INC)  -I$(MOZ_INC)$/nspr
CDEFS +=    -DWINVER=0x400 -DMOZILLA_CLIENT \
	    -DNS_NET_FILE -DCookieManagement -DSingleSignon -DClientWallet \
            -DTRACING -DXP_PC -DXP_WIN -DXP_WIN32 -DHW_THREADS \
            -DDMSVC4 -DNS_MT_SUPPORTED -DNETLIB_THREAD \
            -DOJI -DWIN32 -D_X86_ -D_WINDOWS \
	    -DMOZ_XUL -DMOZ_REFLOW_PERF -DMOZ_REFLOW_PERF_DSP \
	    -DNSPR20 -DOS_HAS_DLL -DNO_JNI_STUBS \
	    -DNETSCAPE -DMOZILLA_CLIENT -DJS_THREADSAFE -DNECKO -DINCLUDE_XUL 
CFLAGS +=   -Zi -GR- -W3 -Gy -MD -UDEBUG
.ELSE
INCPRE +=   -I.. -I$(MOZ_INC)   -I$(MOZ_INC)$/nspr
CDEFS +=    -DDEBUG -DWINVER=0x400 -DMOZILLA_CLIENT \
	    -DNS_NET_FILE -DCookieManagement -DSingleSignon -DClientWallet \
            -DTRACING -DXP_PC -DXP_WIN -DXP_WIN32 -DHW_THREADS \
            -DDMSVC4 -DDEVELOPER_DEBUG -DNS_MT_SUPPORTED -DNETLIB_THREAD \
            -DOJI -D_DEBUG -DWIN32 -D_X86_ -D_WINDOWS \
	    -DMOZ_XUL -DMOZ_REFLOW_PERF -DMOZ_REFLOW_PERF_DSP \
	    -DDEBUG_Administrator -DNSPR20 -DOS_HAS_DLL -DNO_JNI_STUBS \
	    -DNETSCAPE -DMOZILLA_CLIENT -DJS_THREADSAFE -DNECKO -DINCLUDE_XUL 
CFLAGS +=   -Zi -GR- -W3 -Gy -MDd -UNDEBUG
.ENDIF
.ENDIF
.IF "$(GUI)" == "UNX"
INCPRE +=   -I.. -I$(MOZ_INC) -I$(MOZ_INC)$/nspr -DMOZILLA_CLIENT \
            -DOSTYPE=\"Linux2.2.14-5\" -DOJI
.IF "$(OS)" == "LINUX"
# INCPRE +=   -I.. -I$(MOZ_INC) -DDEBUG -DMOZILLA_CLIENT 
INCPRE +=   -fPIC \
            -fno-rtti -fno-exceptions -Wall -Wconversion -Wpointer-arith \
            -Wbad-function-cast -Wcast-align -Woverloaded-virtual -Wsynth \
            -Wno-long-long -pthread  -DTRACING -g 
.ENDIF
.ENDIF

#c++ -o WebBrowserChrome.o -c -DOSTYPE=\"Linux2.2.14-5\" -DOJI   
#-I../../../dist/include -I../../../dist/include     -I/usr/X11R6/include
#-fPIC 
# -fno-rtti -fno-exceptions -Wall -Wconversion -Wpointer-arith 
# -Wbad-function-cast -Wcast-align -Woverloaded-virtual -Wsynth -pedantic 
# -Wno-long-long -pthread  -DDEBUG -DDEBUG_buildso -DTRACING -g 
# -I/usr/lib/glib/include -I/usr/X11R6/include -DMOZILLA_CLIENT -include 
# ../../../config-defs.h -Wp,-MD,.deps/WebBrowserChrome.pp WebBrowserChrome.cpp
# main.cpp

# SHL1TARGET=$(TARGET)$(UPD)$(DLLPOSTFIX)
SHL1TARGET_NAME=$(TARGET)$(UPD)$(DLLPOSTFIX)
# SHL1OBJS=$(MOZSLOFILES)
#SHL1STDLIBS=\
#	$(CPPULIB)					\
#	$(CPPUHELPERLIB)			\
#	$(VOSLIB)					\
#	$(OSLLIB)					\
#	$(SVLLIB)					\
#	$(SVLIB)					\
#	$(TOOLSLIB)					\
#	$(SVTOOLLIB)				\
#	$(UCBHELPERLIB)				\
#	$(SALLIB)					\
#	$(DBTOOLSLIB)				\
#	$(UNOTOOLSLIB)				\
#	$(COMPHELPERLIB)			\
#	$(MOZ_LIB_XPCOM)

#.IF "$(COMPHELPERLIB)" == ""
#SHL1STDLIBS+= icomphelp2.lib
#.ENDIF

#SHL1DEPN=
#SHL1IMPLIB=	i$(TARGET)
#SHL1LIBS=	$(SLB)$/file.lib

#SHL1DEF=$(MISC)$/$(SHL1TARGET_NAME).def

#DEF1NAME=	$(SHL1TARGET_NAME)
#DEF1EXPORTFILE=	exports.dxp


# --- Targets ----------------------------------

.INCLUDE : target.mk


