/*************************************************************************
 *
 *  $RCSfile: genericcontroller.hxx,v $
 *
 *  $Revision: 1.9 $
 *
 *  last change: $Author: fs $ $Date: 2001/06/21 17:42:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the License); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an AS IS basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef DBAUI_GENERICCONTROLLER_HXX
#define DBAUI_GENERICCONTROLLER_HXX

#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMEACTIONLISTENER_HPP_
#include <com/sun/star/frame/XFrameActionListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTOR_HPP_
#include <com/sun/star/frame/XDispatchProviderInterceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XMODIFYLISTENER_HPP_
#include <com/sun/star/util/XModifyListener.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _CPPUHELPER_COMPBASE6_HXX_
#include <cppuhelper/compbase6.hxx>
#endif
#ifndef _CPPUHELPER_COMPBASE1_HXX_
#include <cppuhelper/compbase1.hxx>
#endif
#ifndef _CPPUHELPER_INTERFACECONTAINER_H_
#include <cppuhelper/interfacecontainer.h>
#endif
#ifndef _COMPHELPER_STLTYPES_HXX_
#include <comphelper/stl_types.hxx>
#endif
#ifndef DBAUI_ASYNCRONOUSLINK_HXX
#include "AsyncronousLink.hxx"
#endif
#ifndef _DBAUI_MODULE_DBU_HXX_
#include "moduledbu.hxx"
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_ 
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XCONNECTION_HPP_ 
#include <com/sun/star/sdbc/XConnection.hpp>
#endif
#ifndef _DBHELPER_DBEXCEPTION_HXX_
#include <connectivity/dbexception.hxx>
#endif
#ifndef _COMPHELPER_BROADCASTHELPER_HXX_
#include <comphelper/broadcasthelper.hxx>
#endif


class Window;
class ToolBox;
class VCLXWindow;
namespace dbaui
{
	class ODataView;

	typedef ::cppu::WeakComponentImplHelper6	<	::com::sun::star::frame::XDispatch
												,	::com::sun::star::frame::XDispatchProviderInterceptor
												,	::com::sun::star::util::XModifyListener
												,	::com::sun::star::frame::XFrameActionListener
												,	::com::sun::star::lang::XInitialization
												,	::com::sun::star::lang::XServiceInfo
												>	OGenericUnoController_BASE;
	typedef ::cppu::ImplHelper1	<	::com::sun::star::frame::XController
								>	OGenericUnoController_BASE2;

	// a smaller version of the FeatureEvent to be broadcasted by an ::com::sun::star::frame::XController
	// -------------------------------------------------------------------------
	struct FeatureState
	{
		::com::sun::star::uno::Any	aState;
		sal_Bool					bEnabled;
		sal_Bool					bRequery;

		FeatureState() : bEnabled(sal_False), bRequery(sal_False) { }
	};

	class OGenericUnoController	:public ::comphelper::OBaseMutex
								,public OGenericUnoController_BASE
								,public OGenericUnoController_BASE2
								,public dbaui::OModuleClient
	{
	protected:
		// structs
		// ------------------
		struct DispatchTarget
		{
			::com::sun::star::util::URL					aURL;
			::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > 	xListener;

			DispatchTarget() { }
			DispatchTarget(const ::com::sun::star::util::URL& rURL, const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener >  xRef) : aURL(rURL), xListener(xRef) { }
		};
		// std type declaration
		DECLARE_STL_MAP(::rtl::OUString, sal_Int32, ::std::less< ::rtl::OUString >, SupportedFeatures);
		DECLARE_STL_MAP(sal_uInt16,FeatureState,::std::less<sal_uInt16> ,StateCache);
		DECLARE_STL_VECTOR(DispatchTarget,Dispatch);
		typedef struct FeatureStruct 
		{
			sal_Int32 nId;
			::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > xListener;
			sal_Bool bForceBroadcast;
		} FeaturePair;
		::std::deque< FeaturePair > m_aFeaturesToInvalidate;

		::osl::Mutex			m_aAsyncLoadSafety;		// for multi-thread access to our members
		::osl::Mutex			m_aPropertyMutex;		// use for the m_aDisposeListeners
		::osl::Mutex			m_aFeatureMutex;		// locked when features are append to or remove from deque
		SupportedFeatures		m_aSupportedFeatures;	// look at the name
		StateCache				m_aStateCache;			// save the current status of feature state
		Dispatch				m_arrStatusListener;	// all our listeners where we dispatch status changes
		OAsyncronousLink		m_aAsyncInvalidateAll;

		::com::sun::star::uno::Reference< ::com::sun::star::util::XURLTransformer > 		m_xUrlTransformer;		// needed sometimes
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >	m_xMultiServiceFacatory;
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >					m_xCurrentFrame;// the frame we're residing in
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider > 		m_xSlaveDispatcher;		// for intercepting dispatches
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider > 		m_xMasterDispatcher;	// dito
		::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >		m_xDatabaseContext;

		ODataView*				m_pView;				// our (VCL) "main window"
		sal_Int32				m_nInInvalidate;

		sal_Bool				m_bFrameUiActive		: 1;		// updated in ::frameAction
		sal_Bool				m_bSuspending			: 1;
		sal_Bool				m_bCurrentlyModified	: 1;
		sal_Bool				m_bCurrentlyInConnect	: 1;
		sal_Bool				m_bDisposed				: 1;
		

		OGenericUnoController(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rM);

		// closes the task when possible
		void closeTask();
		// returns a string which contains the resource number of the menu
		virtual String			getMenu() const;
		// if getMenu returns a non empty string than this will be dispatched at the frame
		void					loadMenu(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >& _xFrame);
		// all the features which should be handled by this class
		virtual void			AddSupportedFeatures();
			// the features have to be sorted alphabetically !
			// (and please keep in mind that a _reference_ to a sequence is returned !)

		// state of a feature. 'feature' may be the handle of a ::com::sun::star::util::URL somebody requested a dispatch interface for OR a toolbar slot.
		virtual FeatureState	GetState(sal_uInt16 nId);
		// execute a feature
		virtual void			Execute(sal_uInt16 nId) = 0;

		virtual void InvalidateAll();
		virtual void EmptyWindow(); // dispatch with an empty url object
		virtual sal_Bool SaveModified(sal_Bool bCommit = sal_True); // the baseclas only invalidate the features
		// save all data if modified, eventually ask the user
		virtual sal_uInt16 SaveData(sal_Bool bUI = sal_True, sal_Bool bForBrowsing = sal_False);
		// gets the URL which the given id is assigned to
		::com::sun::star::util::URL getURLForId(sal_Int32 _nId) const;
		// If you want a toolbar to be displayed at the top of the grid overload this function.
		// The ToolBox returned here has to be fully initialized (you get no further chance ;)
		virtual ToolBox* CreateToolBox(Window* pParent) { return NULL; }

		// connect to the datasource connection
		::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection> connect(const ::rtl::OUString& _rsDataSourceName, sal_Bool _bStartListening = sal_False);

		void startConnectionListening(const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection >& _rxConnection);
		void stopConnectionListening(const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection >& _rxConnection);

	private:
			// invalidate features - implementation
		void InvalidateAll_Impl();
		void InvalidateFeature_Impl();

		sal_Bool ImplInvalidateTBItem(sal_uInt16 nId, const FeatureState& rState);
		void ImplBroadcastFeatureState(const ::rtl::OUString& _rFeature, const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xListener, sal_Bool _bIgnoreCache);
		// link methods
		DECL_LINK(OnAsyncInvalidateAll, void*);
		// click a TB slot
		DECL_LINK(OnToolBoxSelected, ToolBox*);
	public:
		~OGenericUnoController(){}

		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > getORB() const { return m_xMultiServiceFacatory; }
		ODataView* getView() const { return m_pView; }
		// shows a error box if the SQLExceptionInfo is valid
		void showError(const ::dbtools::SQLExceptionInfo& _rInfo);
		// temp
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > getComponentWindow();
		// if xListener is NULL the change will be forwarded to all listeners to the given ::com::sun::star::util::URL
		// if _bForceBroadcast is sal_True, the current feature state is broadcasted no matter if it is the same as the cached state
		virtual void InvalidateFeature(const ::rtl::OUString& rURLPath, const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xListener = ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > (), sal_Bool _bForceBroadcast = sal_False);
			
		// if there is an ::com::sun::star::util::URL translation for the id ('handle') the preceding InvalidateFeature is used.
		// if there is a toolbar slot with the given id it is updated (the new state is determined via GetState)
		// if _bForceBroadcast is sal_True, the current feature state is broadcasted no matter if it is the same as the cached state
		virtual void InvalidateFeature(sal_uInt16 nId, const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xListener = ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > (), sal_Bool _bForceBroadcast = sal_False);
			
		// late construction
		virtual sal_Bool Construct(Window* pParent);

		// ::com::sun::star::lang::XEventListener
		virtual void SAL_CALL disposing(const ::com::sun::star::lang::EventObject& Source) throw( ::com::sun::star::uno::RuntimeException );

		// ::com::sun::star::util::XModifyListener
		virtual void SAL_CALL modified(const ::com::sun::star::lang::EventObject& aEvent) throw( ::com::sun::star::uno::RuntimeException );

		// XInterface
		virtual ::com::sun::star::uno::Any	SAL_CALL queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException);
		virtual void SAL_CALL acquire(  ) throw ();
		virtual void SAL_CALL release(  ) throw ();

		// XTypeProvider
		virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes(  ) throw (::com::sun::star::uno::RuntimeException);
		virtual ::com::sun::star::uno::Sequence< sal_Int8 > SAL_CALL getImplementationId(  ) throw (::com::sun::star::uno::RuntimeException);

		// ::com::sun::star::frame::XController
		virtual void SAL_CALL attachFrame(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame) throw( ::com::sun::star::uno::RuntimeException );
		virtual sal_Bool SAL_CALL attachModel(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > & xModel) throw( ::com::sun::star::uno::RuntimeException ){ return sal_False; };
		virtual sal_Bool SAL_CALL suspend(sal_Bool bSuspend) throw( ::com::sun::star::uno::RuntimeException ) = 0;
		virtual ::com::sun::star::uno::Any SAL_CALL getViewData(void) throw( ::com::sun::star::uno::RuntimeException ){ return ::com::sun::star::uno::Any(); };
		virtual void SAL_CALL restoreViewData(const ::com::sun::star::uno::Any& Data) throw( ::com::sun::star::uno::RuntimeException ){};
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel >  SAL_CALL getModel(void) throw( ::com::sun::star::uno::RuntimeException ){ return ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > (); };
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  SAL_CALL getFrame(void) throw( ::com::sun::star::uno::RuntimeException ){ return m_xCurrentFrame; };

		// ::com::sun::star::frame::XDispatch
		virtual void 		SAL_CALL dispatch(const ::com::sun::star::util::URL& aURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>& aArgs);
		virtual void 		SAL_CALL addStatusListener(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & aListener, const ::com::sun::star::util::URL& aURL);
		virtual void 		SAL_CALL removeStatusListener(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & aListener, const ::com::sun::star::util::URL& aURL);

		// ::com::sun::star::frame::XDispatchProviderInterceptor
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  SAL_CALL getSlaveDispatchProvider(void) throw( ::com::sun::star::uno::RuntimeException );
		virtual void SAL_CALL setSlaveDispatchProvider(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider > & _xNewProvider) throw( ::com::sun::star::uno::RuntimeException );
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  SAL_CALL getMasterDispatchProvider(void) throw( ::com::sun::star::uno::RuntimeException );
		virtual void SAL_CALL setMasterDispatchProvider(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider > & _xNewProvider) throw( ::com::sun::star::uno::RuntimeException );

		// ::com::sun::star::frame::XDispatchProvider
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  SAL_CALL queryDispatch(const ::com::sun::star::util::URL& aURL, const ::rtl::OUString& aTargetFrameName, sal_Int32 nSearchFlags) throw( ::com::sun::star::uno::RuntimeException );
		virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  > SAL_CALL queryDispatches(const ::com::sun::star::uno::Sequence< ::com::sun::star::frame::DispatchDescriptor >& aDescripts) throw( ::com::sun::star::uno::RuntimeException );

		// ::com::sun::star::lang::XComponent
		virtual void SAL_CALL dispose(){OGenericUnoController_BASE::dispose(); }
		virtual void SAL_CALL disposing();
		virtual void SAL_CALL addEventListener(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener);
		virtual void SAL_CALL removeEventListener(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener);

		// ::com::sun::star::frame::XFrameActionListener
		virtual void		SAL_CALL frameAction(const ::com::sun::star::frame::FrameActionEvent& aEvent) throw( ::com::sun::star::uno::RuntimeException );
		// lang::XInitialization
		virtual void SAL_CALL initialize( const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& aArguments ) throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException);
		// XServiceInfo
		virtual ::rtl::OUString SAL_CALL getImplementationName() throw(::com::sun::star::uno::RuntimeException) = 0;
		virtual sal_Bool SAL_CALL supportsService(const ::rtl::OUString& ServiceName) throw(::com::sun::star::uno::RuntimeException);
		virtual ::com::sun::star::uno::Sequence< ::rtl::OUString> SAL_CALL getSupportedServiceNames() throw(::com::sun::star::uno::RuntimeException) = 0;
	};
}

#endif //DBAUI_GENERICCONTROLLER_HXX


