/*************************************************************************
 *
 *  $RCSfile: browserpage.cxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: fs $ $Date: 2001/01/12 11:25:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_PROPCTRLR_BROWSERPAGE_HXX_
#include "browserpage.hxx"
#endif

//............................................................................
namespace pcr
{
//............................................................................
	//==================================================================
	// class OBrowserPage
	//==================================================================
	//------------------------------------------------------------------
	OBrowserPage::OBrowserPage(Window* pParent,WinBits nWinStyle)
			:TabPage(pParent,nWinStyle)
			,m_aListBox(this)
	{
		m_aListBox.SetBackground(GetBackground());
		Point aPos(3,3);
		m_aListBox.SetPosPixel(aPos);
		m_aListBox.Show();
	}

	//------------------------------------------------------------------
	void OBrowserPage::Resize()
	{
		Size aSize(GetOutputSizePixel());
		aSize.Width() -= 6;
		aSize.Height() -= 6;

		m_aListBox.SetSizePixel(aSize);
	}

	//------------------------------------------------------------------
	OBrowserListBox* OBrowserPage::getListBox()
	{
		return &m_aListBox;
	}

	//------------------------------------------------------------------
	void OBrowserPage::StateChanged(StateChangedType nType)
	{
		Window::StateChanged( nType);
		if (STATE_CHANGE_VISIBLE == nType)
			m_aListBox.Activate(IsVisible());
	}

//............................................................................
} // namespace pcr
//............................................................................

/*************************************************************************
 * history:
 *	$Log: browserpage.cxx,v $
 *	Revision 1.1  2001/01/12 11:25:49  fs
 *	initial checkin - outsourced the form property browser
 *	
 *
 *	Revision 1.0 08.01.01 17:09:37  fs
 ************************************************************************/

