/*************************************************************************
 *
 *  $RCSfile: filtercache.cxx,v $
 *
 *  $Revision: 1.39 $
 *
 *  last change: $Author: rt $ $Date: 2001/08/01 12:56:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

// If you wish to enable this memory measure macros ... you need "windows.h"
// But it's not agood idea to include it in your header!!! Because it's not compatible to VCL header .-(
// So you must include it here ... in cxx, where you whish to use it.
#ifdef ENABLE_MEMORYMEASURE
    #define VCL_NEED_BASETSD
    #include <tools/presys.h>
    #include <windows.h>
    #include <tools/postsys.h>
    #undef  VCL_NEED_BASETSD
#endif

#ifndef __FRAMEWORK_MACROS_DEBUG_MEMORYMEASURE_HXX_
#include <macros/debug/memorymeasure.hxx>
#endif

#ifndef __FRAMEWORK_CLASSES_FILTERCACHE_HXX_
#include <classes/filtercache.hxx>
#endif

#ifndef __FRAMEWORK_CLASSES_WILDCARD_HXX_
#include <classes/wildcard.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_GENERIC_HXX_
#include <macros/generic.hxx>
#endif

#ifndef __FRAMEWORK_THREADHELP_TRANSACTIONGUARD_HXX_
#include <threadhelp/transactionguard.hxx>
#endif

#ifndef __FRAMEWORK_THREADHELP_WRITEGUARD_HXX_
#include <threadhelp/writeguard.hxx>
#endif

#ifndef __FRAMEWORK_THREADHELP_READGUARD_HXX_
#include <threadhelp/readguard.hxx>
#endif

#ifndef __FRAMEWORK_FILTERFLAGS_H_
#include <filterflags.h>
#endif

#ifndef __FRAMEWORK_QUERIES_H_
#include <queries.h>
#endif

#ifndef __FRAMEWORK_SERVICES_H_
#include <services.h>
#endif

#ifdef ENABLE_FILTERCACHEDEBUG
	#ifndef __FRAMEWORK_CLASSES_ARGUMENTANALYZER_HXX_
	#include <classes/argumentanalyzer.hxx>
	#endif
#endif // ENABLE_FILTERCACHEDEBUG

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_XMULTIPROPERTYSET_HPP_
#include <com/sun/star/beans/XMultiPropertySet.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_XCHANGESBATCH_HPP_
#include <com/sun/star/util/XChangesBatch.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

using namespace ::utl						;
using namespace ::osl						;
using namespace ::rtl						;
using namespace ::std						;
using namespace ::comphelper				;
using namespace ::com::sun::star::uno		;
using namespace ::com::sun::star::registry	;
using namespace ::com::sun::star::lang		;
using namespace ::com::sun::star::beans		;
using namespace ::com::sun::star::container	;
using namespace ::com::sun::star::util		;

//_________________________________________________________________________________________________________________
//	non exported const
//_________________________________________________________________________________________________________________


//_________________________________________________________________________________________________________________
//	non exported definitions
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

// initialize static member with default values!
sal_Int32       FilterCache::m_nRefCount    = 0                             ;
DataContainer*  FilterCache::m_pData        = NULL                          ;
sal_Int32       FilterCache::m_nVersion     = DEFAULT_FILTERCACHE_VERSION   ;
sal_Int16       FilterCache::m_nMode        = DEFAULT_FILTERCACHE_MODE      ;

/*-****************************************************************************************************//**
    @short      standard constructor
    @descr      This will initialize the cache automaticly ... but at first call only!
                These class use a refcount mechanism to share cache between different ownern.

    @attention  We must use a global lock instead of a normal one ... because we work on static member!

    @seealso    -

    @param      "nVersion"
    @return     -

    @onerror    An assertion is thrown and the cache will be empty!
                Method isValid() returns false then.
*//*-*****************************************************************************************************/

FilterCache::FilterCache( sal_Int32 nVersion ,
                          sal_Int16 nMode    )
	// initialize base classes first
    :   ThreadHelpBase  ()
    ,   TransactionBase ()
	// initialize member then
{
    // ------------------------------------------------------------------------------------------------------------
    // Global access, must be guarded (multithreading!).
	// We must protect our static member creation!
	// But we use a ref count mechanism too ...
    // This ctor can be called more then ones at same time!
    // What can we do?

    // We should set a write lock first (is an exclusiv lock!).
    // Nobody can disturb us then! Next we must look for current
    // working mode of our transaction manager (available by baseclass TransactionBase).
    // a)   If we detect an E_INIT we know => this is the first call.
    //      It's neccessary to fill our cache then an set working mode to E_WORK.
    //      The write lock blocks all further instances of this class due to
    //      we finished this fill-operation.
    // b)   If current working mode different from E_INIT, e.g. it's E_WORK ...
    //      then we must increase our ref count only. Cache was already initialized.
    // c)   Mode should never be E_BEFORECLOSE ... because this state is set by calling
    //      of our dtor. Of course - it could be that a new instance should be created during
    //      release of last instance ... but our dtor must set a write lock too!
    //      I think => it's enough to protect us against sharing of ctor/dtor ...
    // d)   But we can detect E_CLOSE as current working mode. This says: Last instance
    //      was gone sometimes before ... this is a new one ... we must fill our cache again.
    //      It's not a good idea to fill this cache more then ones during life time of our office
    //      ... but it could be :-( That's live! We should avoid this case by clever using of this class.

    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

    // ------------------------------------------------------------------------------------------------------------
    // d)   We must change working mode to E_INIT if we detect E_CLOSE
    //      before we check for E_INIT ... because both modes must fill
    //      our cache. But it's not clever to write same code twice!
    if( TransactionManager::getGlobalTransactionManager().getWorkingMode() == E_CLOSE )
    {
        // Please make shure that no current transaction is active in THIS ctor metod!
        // Otherwise call of setWorkingMode() will block for waiting of that transaction ...
        TransactionManager::getGlobalTransactionManager().setWorkingMode( E_INIT );
    }

    // ------------------------------------------------------------------------------------------------------------
    // a,d) Don't combine it with scope before by using "else"!
    if( TransactionManager::getGlobalTransactionManager().getWorkingMode() == E_INIT )
    {
		RTL_LOGFILE_CONTEXT( aLog, "framework (as) ::FilterCache::FilterCache" );

        m_nVersion = nVersion           ;
        m_nMode    = nMode              ;
        m_pData    = new DataContainer  ;

        RTL_LOGFILE_CONTEXT_TRACE2( aLog, "{ creation ConfigItem [file=standard, version=%d, mode=%d]", m_nVersion, m_nMode );
            FilterCFGAccess aAccess( PACKAGENAME_TYPEDETECTION_STANDARD, m_nVersion, m_nMode );
        RTL_LOGFILE_CONTEXT_TRACE( aLog, "} creation ConfigItem" );

        RTL_LOGFILE_CONTEXT_TRACE( aLog, "{ reading TypeDetection.xml" );
            aAccess.read( *m_pData );
        RTL_LOGFILE_CONTEXT_TRACE( aLog, "} reading TypeDetection.xml" );

        // Register this instance.
        ++m_nRefCount;

        // Don't forget to open object for further calls!
        TransactionManager::getGlobalTransactionManager().setWorkingMode( E_WORK );
    }
    else
    // ------------------------------------------------------------------------------------------------------------
    // b)
    if( TransactionManager::getGlobalTransactionManager().getWorkingMode() == E_WORK )
    {
        ++m_nRefCount;
    }
}

/*-****************************************************************************************************//**
    @short      standard destructor to delete instance
    @descr      This will clear the cache if last owner release it.

    @seealso    -

    @param      -
    @return     -

    @onerror    -
*//*-*****************************************************************************************************/
FilterCache::~FilterCache()
{
    // ------------------------------------------------------------------------------------------------------------
    // Global access, must be guarded (multithreading!).
    // We must protect our static member deletion!
	// But we use a ref count mechanism too ...
    // This dtor can be called more then ones at same time!
    // What can we do?

    // We should set a write lock first (is an exclusiv lock!).
    // Nobody can disturb us then! Next we must look for current
    // working mode of our transaction manager (available by baseclass TransactionBase).
    // a)   E_INIT          :   This case never should occure! We set it in ctor and change it to E_WORK too!
    // b)   E_WORK          :   We must decrease our ref count. If it will be 0 ...
    //                          we must change working mode to E_BEFORECLOSE; release internal data and change mode to E_CLOSE.
    // c)   E_BEFORECLOSE   :
    //      E_CLOSE         :   This cases never should occure too! b) must be a complete transaction!

    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

    --m_nRefCount;
    if( m_nRefCount == 0 )
    {
        // Attention: This call blocks till all current transactions are gone!
        TransactionManager::getGlobalTransactionManager().setWorkingMode( E_BEFORECLOSE );

/*TODO: It's to late to save my values ... because used config manager is already dead!
        I can't write my values ... user must have called flush before ...
*/
        LOG_ASSERT2( m_pData->m_bIsModified==sal_True, "FilterCache::dtor()", "Who forgot to flush my data? I can't do it now - ConfigManager already dead ... uno dead ... I have no fun to live anylonger .-)!" )

        m_pData->free();
        delete m_pData;
        m_pData = NULL;

        TransactionManager::getGlobalTransactionManager().setWorkingMode( E_CLOSE );
	}
}

//*****************************************************************************************************************
void FilterCache::flush()
{
    // UNSAFE AREA ---------------------------------------------------------------------------------------------
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    // SAFE AREA -----------------------------------------------------------------------------------------------
    // Safe complete flushing with a exclusiv writelock!
    // Use global lock ... it's static member ...
    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

	RTL_LOGFILE_CONTEXT( aLog, "framework (as) ::FilterCache::flush" );

    RTL_LOGFILE_CONTEXT_TRACE2( aLog, "{ creation ConfigItem [file=standard, version=%d, mode=%d]", m_nVersion, m_nMode );
        FilterCFGAccess aAccess( PACKAGENAME_TYPEDETECTION_STANDARD, m_nVersion, m_nMode );
    RTL_LOGFILE_CONTEXT_TRACE( aLog, "} creation ConfigItem" );
    RTL_LOGFILE_CONTEXT_TRACE( aLog, "{ writing TypeDetection.xml" );
        aAccess.write( *m_pData );
    RTL_LOGFILE_CONTEXT_TRACE( aLog, "} writing TypeDetection.xml" );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::isValid() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // If we have all caches filled ... our object is valid.
    // Other way ... invalid.
    // Attention:   We don't need a list of detectors or loaders everytime!
    //              Our configuration know a default detector and a generic loader too!

    LOG_ASSERT2( m_pData->m_aTypeCache.size()                     < 1, "FilterCache::isValid()", "No types found!"                       )
    LOG_ASSERT2( m_pData->m_aPreferredTypesCache.size()           < 1, "FilterCache::isValid()", "No preferred types found!"             )
    LOG_ASSERT2( m_pData->m_aFilterCache.size()                   < 1, "FilterCache::isValid()", "No filters found!"                     )
    LOG_ASSERT2( m_pData->m_aFastFilterCache.size()               < 1, "FilterCache::isValid()", "Optimism for filter search don't work!")
    LOG_ASSERT2( m_pData->m_aDefaultDetector.sName.getLength()    < 1, "FilterCache::isValid()", "No default detect service found!"      )
    LOG_ASSERT2( m_pData->m_aGenericLoader.sName.getLength()      < 1, "FilterCache::isValid()", "No generic loader service found!"      )
    LOG_ASSERT2( m_pData->m_sLocale.getLength()                   < 1, "FilterCache::isValid()", "No locale found!"                      )

    return  (
                (   m_pData->m_aTypeCache.size()                  >   0   )   &&
                (   m_pData->m_aPreferredTypesCache.size()        >   0   )   &&
                (   m_pData->m_aFilterCache.size()                >   0   )   &&
                (   m_pData->m_aFastFilterCache.size()            >   0   )   &&
                (   m_pData->m_aDefaultDetector.sName.getLength() >   0   )   &&
                (   m_pData->m_aGenericLoader.sName.getLength()   >   0   )   &&
                (   m_pData->m_sLocale.getLength()                >   0   )
            );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasTypes() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aTypeCache.size() > 0 );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasFilters() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aFilterCache.size() > 0 );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasDetectors() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // If we have a registered default detector (normaly must exist!)
    // we can return true ... otherwise we should check our cache for
    // other registered detect services.
    return  (
                ( m_pData->m_aDetectorCache.size()                > 0 )   &&
                ( m_pData->m_aDefaultDetector.sName.getLength()   > 0 )
            );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasLoaders() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // If we have a registered default loader (normaly must exist!)
    // we can return true ... otherwise we should check our cache for
    // other registered loader services.
    return  (
                ( m_pData->m_aLoaderCache.size()              >   0   )   &&
                ( m_pData->m_aGenericLoader.sName.getLength() >   0   )
            );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasContentHandlers() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aContentHandlerCache.size() > 0 );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::hasProtocolHandlers() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aProtocolHandlerCache.size() > 0 );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchType(	const	OUString&				sURL				,
									const	OUString*				pMediaType			,
									const	OUString*				pClipboardFormat	,
								   			CheckedTypeIterator&	aStartEntry			,
											OUString&				sResult				) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Check for wrong parameters.
	LOG_ASSERT2( implcp_searchType( sURL, pMediaType, pClipboardFormat, aStartEntry, sResult ), "FilterCache::searchType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
                    sResult     = OUString()                      ;
    sal_Bool        bFound      = sal_False                       ;

    // Parse URL and extract extensions. Is neccessary for matching type!
    INetURLObject   aParser     ( sURL );
    OUString        sExtension  = aParser.getExtension( INetURLObject::LAST_SEGMENT                         ,
                                                        sal_True                                            ,
                                                        INetURLObject::DECODE_WITH_CHARSET );
                    sExtension  = sExtension.toAsciiLowerCase();

    // Check for start of new search first!
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // Initialize "step"-parameter then!
        aStartEntry.initialize( m_pData->m_aTypeCache );

        // If user give URL only - we will have some problems.
        // Sometimes exist more types registered for the same extension.
        // Then we must look for preferred entries.
        // Please do that at first call only!
        // Attention: If no extension exist ... "find()" will find anything!
        // Filter this case!
        if  (
                ( sExtension.getLength()    >   0       )   &&
                ( pMediaType                ==  NULL    )   &&
                ( pClipboardFormat          ==  NULL    )
            )
        {
            // Search a preferred type and set return value if some one was found.
            ConstPreferredIterator  pPreferredType  = m_pData->m_aPreferredTypesCache.find( sExtension );
            if( pPreferredType != m_pData->m_aPreferredTypesCache.end() )
            {
                sResult = pPreferredType->second    ;
                bFound  = sal_True                  ;
            }
        }
    }

    /* NO "ELSE" HERE! */

    // If no preferred type match given parameter start normal search.
    while   (
                ( aStartEntry.isEnd()   ==  sal_False   )   &&
                ( bFound                ==  sal_False   )
            )
    {
        ConstTypeIterator pTypeIterator = aStartEntry.getEntry();

        //---------------------------------------------------------------------------------------------------------
        // 1)   If media type was given (no NULL pointer!) ...
        //      ... and no result exist yet ...
        if( pMediaType != NULL )
        {
            //  ... and given value match current list item ...
            //  Save these state - the return value is later set!
            bFound = ( *pMediaType == pTypeIterator->second.sMediaType );
        }

        //---------------------------------------------------------------------------------------------------------
        // 2)   If clipboard formt was given (no NULL pointer!) ...
        //      ... and no result exist yet ...
        if  (
                ( bFound            ==  sal_False   )   &&
                ( pClipboardFormat  !=  NULL        )
            )
        {
            //  ... and given value match current list item ...
            //  Save these state - the return value is later set!
            bFound = ( *pClipboardFormat == pTypeIterator->second.sClipboardFormat );
        }

        //---------------------------------------------------------------------------------------------------------
        // 3)   If URL was given ...
        //      ... and no result exist yet ...
        if  (
                ( bFound            ==  sal_False   )   &&
                ( sURL.getLength()  >   0           )
            )
        {
            // ... then we can use our internal URL-pattern and extension lists.
            //-----------------------------------------------------------------------------------------------------
            // 3a)  Use URL-pattern first.
            for(    ConstStringListIterator pPatternIterator=pTypeIterator->second.lURLPattern.begin()  ;
                    pPatternIterator!=pTypeIterator->second.lURLPattern.end()                       ;
                    ++pPatternIterator                                                              )
            {
                bFound = Wildcard::match( sURL, *pPatternIterator );
                if( bFound == sal_True )
                {
                    break;
                }
            }

            //-----------------------------------------------------------------------------------------------------
            // 3b)  If no pattern match given URL, use extension list.
            if( bFound == sal_False )
            {
                for(    ConstStringListIterator pExtensionIterator=pTypeIterator->second.lExtensions.begin()    ;
                        pExtensionIterator!=pTypeIterator->second.lExtensions.end()                         ;
                        ++pExtensionIterator                                                                )
                {
                    bFound = ( sExtension == *pExtensionIterator );
                    if( bFound == sal_True )
                    {
                        break;
                    }
                }
            }
        }

        // If given parameter match an existing element in our type list
        // we can set right return values.
        if( bFound == sal_True )
        {
            sResult = pTypeIterator->first  ;   // Set return value.
            ++aStartEntry                   ;   // Set start point of next search to NEXT element after these found one!
        }
        else
        {
            // Otherwise ...
            // Step to next item in type list.
            ++aStartEntry;
        }
    }

	// Return result of search.
	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchFilterForType(	const	OUString&					sInternalTypeName	,
													CheckedStringListIterator&	aStartEntry			,
													OUString&					sResult				) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Check wrong parameter.
    LOG_ASSERT2( implcp_searchFilterForType( sInternalTypeName, aStartEntry, sResult ), "FilterCache::searchFilterForType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
    sal_Bool bFound  = sal_False ;
             sResult = OUString();

    // I)   This is the first call of this method.
    //      ... because "StartEntry" isn't right initialized.
    //      Do it now.
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // I.I) Search list of registered filter for given type.
        //      If you found some one set it on "StartEntry"
        //      for further searches!
        //      Return value is set at later time!
        ConstPerformanceIterator pFilter = m_pData->m_aFastFilterCache.find( sInternalTypeName );
        if( pFilter != m_pData->m_aFastFilterCache.end() )
        {
            aStartEntry.initialize( pFilter->second );
        }
        else
        // I.II)    We couldn't find any registered filter for given type name.
        //          We must break all further searches by disable "StartEntry"!
        //          Use method "setAfterEnd()" to do that ...
        {
            aStartEntry.setAfterEnd();
        }
    }

    /* NO "ELSE" HERE! */

    // II)  This isn't the first call (or we have initialized aStartEntry in I)!).
    //      "StartEntry" is already initialized. Look for end of list and
    //      set current element for return.
    if( aStartEntry.isEnd() == sal_False )
    {
        sResult = *(aStartEntry.getEntry()) ;
        bFound  = sal_True                  ;
        ++aStartEntry;
    }

	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchDetectorForType(	const	OUString&					sInternalTypeName	,
										   				CheckedStringListIterator&	aStartEntry			,
														OUString&					sResult				) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_searchDetectorForType( sInternalTypeName, aStartEntry, sResult ), "FilterCache::searchDetectorForType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
             sResult = OUString();
    sal_Bool bFound  = sal_False ;

    // I)   This is the first call of this method ... because given "StartEntry" isn't right initialized!
    //      Do it now ...
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // I.I)     Search for type to get list of registered detect services.
        //          If you found someone initialize "StartEntry".
        //          At next calls of this method you don't must search in "m_pData->m_aFastDetectorCache" anymore ...
        //          because you set and hold list of registered services in "StartEntry".
        //          User should not change that!
        ConstPerformanceIterator pDetector = m_pData->m_aFastDetectorCache.find( sInternalTypeName );
        if( pDetector != m_pData->m_aFastDetectorCache.end() )
        {
            aStartEntry.initialize( pDetector->second );
        }
        else
        // I.II)    We couldn't find any registered detect service for given type name.
        //          We must break all further searches by disable "StartEntry"!
        //          Use method "setEnd()" to do that ...
        //          NOT "setAfterEnd()" !!! ... because we must return our default detector first
        //          before we stop all further searches! see III)
        {
            aStartEntry.setEnd();
        }
    }

    /* NO "ELSE" HERE! */

    //  II) This must be the second, third ... call of this search method! (or first call after successful initalizing of aStartEntry!)
    //      And we haven't reached the end of set list of registered services.
    //      Set next elemenet for return and step to the next one.
    if( aStartEntry.isEnd() == sal_False )
    {
        sResult = *(aStartEntry.getEntry()) ;
        bFound  = sal_True                  ;
        ++aStartEntry;
    }
    else
    //  III)    Last registered service was returned at last call.
    //          We reached the end of set list ...
    //          (II=true => isEnd() is reached!)
    //          ... but we have a default detect service.
    //          Set it for return and break further searches! Disable
    //          "StartEntry" by calling "setAfterEnd()".
    if( aStartEntry.isAfterEnd() == sal_False )
    {
        aStartEntry.setAfterEnd();
        sResult = m_pData->m_aDefaultDetector.sName ;
        bFound  = sal_True                          ;
    }

	// Return result of operation.
	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchLoaderForType(	const	OUString&					sInternalTypeName	,
										  			CheckedStringListIterator&	aStartEntry			,
													OUString&					sResult				) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_searchLoaderForType( sInternalTypeName, aStartEntry, sResult ), "FilterCache::searchLoaderForType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
             sResult = OUString();
    sal_Bool bFound  = sal_False ;

    // I)   This is the first call of this method ... because given "StartEntry" isn't right initialized!
    //      Do it now ...
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // I.I)     Search for type to get list of registered loader services.
        //          If you found someone initialize "StartEntry".
        //          At next calls of this method you don't must search in "m_pData->m_aFastLoaderCache" anymore ...
        //          because you set and hold list of registered services in "StartEntry".
        //          User should not change that!
        ConstPerformanceIterator pLoader = m_pData->m_aFastLoaderCache.find( sInternalTypeName );
        if( pLoader != m_pData->m_aFastLoaderCache.end() )
        {
            aStartEntry.initialize( pLoader->second );
        }
        else
        // I.II)    We couldn't find any registered loader service for given type name.
        //          We must break all further searches by disable "StartEntry"!
        //          Use method "setEnd()" to do that ...
        //          NOT "setAfterEnd()" !!! ... because we must return our generic loader first
        //          before we stop all further searches! see III)
        {
            aStartEntry.setEnd();
        }
    }

    /* NO "ELSE" HERE! */

    //  II)     This must be the second, third ... call of this search method! (or first call after successful initalizing of aStartEntry!)
    //          And we haven't reached the end of set list of registered services.
    //          Set next elemenet for return and step to the next one.
    if( aStartEntry.isEnd() == sal_False )
    {
        sResult = *(aStartEntry.getEntry()) ;
        bFound  = sal_True                  ;
        ++aStartEntry;
    }
    else
    //  III)    Last registered service was returned at last call.
    //          We reached the end of set list ...
    //          (II=true => isEnd() is reached!)
    //          ... but we have a default loader service.
    //          Set it for return and break further searches! Disable
    //          "StartEntry" by calling "setAfterEnd()".
    if( aStartEntry.isAfterEnd() == sal_False )
    {
        aStartEntry.setAfterEnd();
        sResult = m_pData->m_aGenericLoader.sName ;
        bFound  = sal_True                        ;
    }

	// Return result of operation.
	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchContentHandlerForType(  const   OUString&                   sInternalTypeName   ,
                                                            CheckedStringListIterator&  aStartEntry         ,
                                                            OUString&                   sResult             ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_searchContentHandlerForType( sInternalTypeName, aStartEntry, sResult ), "FilterCache::searchContentHandlerForType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
             sResult = OUString();
    sal_Bool bFound  = sal_False ;

    // I)   This is the first call of this method ... because given "StartEntry" isn't right initialized!
    //      Do it now ...
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // I.I)     Search for type to get list of registered handler services.
        //          If you found someone initialize "StartEntry".
        //          At next calls of this method you don't must search in "m_pData->m_aFastHandlerCache" anymore ...
        //          because you set and hold list of registered services in "StartEntry".
        //          User should not change that!
        ConstPerformanceIterator pHandler = m_pData->m_aFastContentHandlerCache.find( sInternalTypeName );
        if( pHandler != m_pData->m_aFastContentHandlerCache.end() )
        {
            aStartEntry.initialize( pHandler->second );
        }
        else
        // I.II)    We couldn't find any registered handler service for given type name.
        //          We must break all further searches by disable "StartEntry"!
        //          Use method "setAfterEnd()" to do that ...
        {
            aStartEntry.setAfterEnd();
        }
    }

    /* NO "ELSE" HERE! */

    //  II)     This must be the second, third ... call of this search method! (or first call after successful initalizing of aStartEntry!)
    //          And we haven't reached the end of set list of registered services.
    //          Set next elemenet for return and step to the next one.
    if( aStartEntry.isEnd() == sal_False )
    {
        sResult = *(aStartEntry.getEntry()) ;
        bFound  = sal_True                  ;
        ++aStartEntry;
    }

	// Return result of operation.
	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::searchProtocolHandler(  const  OUString&                   sProtocolURL   ,
                                                     CheckedStringListIterator&  aStartEntry    ,
                                                     OUString&                   sResult        ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_searchProtocolHandler( sProtocolURL, aStartEntry, sResult ), "FilterCache::searchProtocolHandlerForType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Set defaults if search failed.
             sResult = OUString();
    sal_Bool bFound  = sal_False ;

    // I)   This is the first call of this method ... because given "StartEntry" isn't right initialized!
    //      Do it now ...
    if( aStartEntry.isUninitialized() == sal_True )
    {
        // Search list of registered handler, which match given protocol URL.
        // If any list could be found - set it on our checked iterator.
        // Otherwise disable search by set iterator to the end!
        ConstPerformanceIterator pHandlerList = m_pData->m_aFastProtocolHandlerCache.begin();
        if( m_pData->m_aFastProtocolHandlerCache.findPatternKey( sProtocolURL, pHandlerList ) == sal_True )
        {
            aStartEntry.initialize( pHandlerList->second );
        }
        else
        {
            aStartEntry.setAfterEnd();
        }
    }

    /* NO "ELSE" HERE! */

    //  II)     This must be the second, third ... call of this search method! (or first call after successful initalizing of aStartEntry!)
    //          And we haven't reached the end of set list of registered services.
    //          Set next elemenet for return and step to the next one.
    if( aStartEntry.isEnd() == sal_False )
    {
        sResult = *(aStartEntry.getEntry()) ;
        bFound  = sal_True                  ;
        ++aStartEntry;
    }

	// Return result of operation.
	return bFound;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllTypeNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Algorithm:
    //      a) initialize return sequence with right size.
    //      b) copy all values from hash to temp. vector! (neccessary to return list in alphabetic order)
    //      c) sort list
    //      d) convert vector to return sequence

    /*TODO
        May be - we can make it better!
        We could create a static pointer to a return list at first call of this method.
        All other requests works on this created result set ... till something was changed
        in our m_pData->m_aTypeCache! Then we must delete this static list and create a new one.
     */

    // a)
    sal_uInt32           nCount     = (sal_uInt32)(m_pData->m_aTypeCache.size());
    Sequence< OUString > lReturnList( nCount )                                  ;
    sal_uInt32           nItem      = 0                                         ;
    StringList           lTempList                                              ;

    // b)
    for( ConstTypeIterator pHashIterator=m_pData->m_aTypeCache.begin(); pHashIterator!=m_pData->m_aTypeCache.end(); ++pHashIterator )
    {
        lTempList.push_back( pHashIterator->first );
    }

    // c)
    ::std::stable_sort( lTempList.begin(), lTempList.end() );

    // d)
    for( ConstStringListIterator pListIterator=lTempList.begin(); pListIterator!=lTempList.end(); ++pListIterator )
    {
        lReturnList[nItem] = *pListIterator;
        ++nItem;
    }

    return lReturnList;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllFilterNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    RTL_LOGFILE_CONTEXT( aMeasure, "framework (as) ::FilterCache::getAllFilterNames" );

    // Algorithm:
    //      a) initialize return sequence with right size.
    //      b) copy all values from hash to temp. vector! (neccessary to return list in alphabetic order)
    //      c) sort list
    //      d) convert vector to return sequence

    /*TODO
        May be - we can make it better!
        We could create a static pointer to a return list at first call of this method.
        All other requests works on this created result set ... till something was changed
        in our m_pData->m_aTypeCache! Then we must delete this static list and create a new one.
     */

    // a)
    Sequence< OUString > lReturnList( m_pData->m_aFilterCache.size() );
    StringList           lTempList                                    ;

    // b)
    for( ConstFilterIterator pHashIterator=m_pData->m_aFilterCache.begin(); pHashIterator!=m_pData->m_aFilterCache.end(); ++pHashIterator )
    {
        lTempList.push_back( pHashIterator->first );
    }

    // c)
    ::std::stable_sort( lTempList.begin(), lTempList.end() );

    // d)
    DataContainer::convertStringVectorToSequence( lTempList, lReturnList );

    return lReturnList;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllDetectorNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    // Attention: Don't return our default detector! Do that in right method getAllDetectorNamesWithDefault() ...
    Sequence< OUString > lNames ( m_pData->m_aDetectorCache.size() );
    sal_uInt32           nItem  = 0;
    for( ConstDetectorIterator aIterator=m_pData->m_aDetectorCache.begin(); aIterator!=m_pData->m_aDetectorCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllLoaderNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    // Attention: Don't return our default loader! Do that in right method getAllLoaderNamesWithDefault() ...
    Sequence< OUString > lNames ( m_pData->m_aLoaderCache.size() );
    sal_uInt32           nItem  = 0;
    for( ConstLoaderIterator aIterator=m_pData->m_aLoaderCache.begin(); aIterator!=m_pData->m_aLoaderCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllContentHandlerNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    Sequence< OUString > lNames ( m_pData->m_aContentHandlerCache.size() );
    sal_uInt32           nItem  = 0;
    for( ConstContentHandlerIterator aIterator=m_pData->m_aContentHandlerCache.begin(); aIterator!=m_pData->m_aContentHandlerCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllProtocolHandlerNames() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    Sequence< OUString > lNames ( m_pData->m_aProtocolHandlerCache.size() );
    sal_uInt32           nItem  = 0;
    for( ConstProtocolHandlerIterator aIterator=m_pData->m_aProtocolHandlerCache.begin(); aIterator!=m_pData->m_aProtocolHandlerCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllDetectorNamesWithDefault() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    // Attention: Don't forget our default detector ... => +1 ...!
    Sequence< OUString > lNames ( m_pData->m_aDetectorCache.size()+1 );
    sal_uInt32           nItem  = 0;
    for( ConstDetectorIterator aIterator=m_pData->m_aDetectorCache.begin(); aIterator!=m_pData->m_aDetectorCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
    lNames[nItem] = m_pData->m_aDefaultDetector.sName;
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::getAllLoaderNamesWithDefault() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // a) Initialize return sequence with right size.
    // b) Step over all cache items and copy names to return list.
    // Attention: Don't forget our default loader ... => +1 ...!
    Sequence< OUString > lNames ( m_pData->m_aLoaderCache.size()+1 );
    sal_uInt32           nItem  = 0;
    for( ConstLoaderIterator aIterator=m_pData->m_aLoaderCache.begin(); aIterator!=m_pData->m_aLoaderCache.end(); ++aIterator )
    {
        lNames[nItem] = aIterator->first;
        ++nItem;
    }
    lNames[nItem] = m_pData->m_aGenericLoader.sName;
	return lNames;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
::rtl::OUString FilterCache::getDefaultDetector() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return m_pData->m_aDefaultDetector.sName;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
::rtl::OUString FilterCache::getDefaultLoader() const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return m_pData->m_aGenericLoader.sName;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getTypeProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getTypeProperties( sName ), "FilterCache::getTypeProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >   lProperties                                      ;
    ConstTypeIterator           pItem       = m_pData->m_aTypeCache.find( sName );
    if( pItem != m_pData->m_aTypeCache.end() )
    {
        DataContainer::convertFileTypeToPropertySequence( pItem->second, lProperties, m_pData->m_sLocale );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getFilterProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getFilterProperties( sName ), "FilterCache::getFilterProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >   lProperties                                         ;
    ConstFilterIterator         pItem       = m_pData->m_aFilterCache.find( sName ) ;
    if( pItem != m_pData->m_aFilterCache.end() )
    {
        DataContainer::convertFilterToPropertySequence( pItem->second, lProperties, m_pData->m_sLocale );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getDetectorProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getDetectorProperties( sName ), "FilterCache::getDetectorProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >   lProperties                                          ;
    ConstDetectorIterator       pItem       = m_pData->m_aDetectorCache.find( sName );
    if( pItem != m_pData->m_aDetectorCache.end() )
    {
        DataContainer::convertDetectorToPropertySequence( pItem->second, lProperties );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getLoaderProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getLoaderProperties( sName ), "FilterCache::getLoaderProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >   lProperties                                        ;
    ConstLoaderIterator         pItem       = m_pData->m_aLoaderCache.find( sName );
    if( pItem != m_pData->m_aLoaderCache.end() )
    {
        DataContainer::convertLoaderToPropertySequence( pItem->second, lProperties, m_pData->m_sLocale );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getContentHandlerProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_getContentHandlerProperties( sName ), "FilterCache::getContentHandlerProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >    lProperties                                                ;
    ConstContentHandlerIterator  pItem       = m_pData->m_aContentHandlerCache.find( sName );
    if( pItem != m_pData->m_aContentHandlerCache.end() )
    {
        DataContainer::convertContentHandlerToPropertySequence( pItem->second, lProperties );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Sequence< PropertyValue > FilterCache::getProtocolHandlerProperties( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_getProtocolHandlerProperties( sName ), "FilterCache::getProtocolHandlerProperties()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element. If it could be found - pack his properties for return.
    Sequence< PropertyValue >     lProperties                                                 ;
    ConstProtocolHandlerIterator  pItem       = m_pData->m_aProtocolHandlerCache.find( sName );
    if( pItem != m_pData->m_aProtocolHandlerCache.end() )
    {
        DataContainer::convertProtocolHandlerToPropertySequence( pItem->second, lProperties );
    }
	return lProperties;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
FileType FilterCache::getType( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getType( sName ), "FilterCache::getType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    FileType            aType                                       ;
    ConstTypeIterator   pItem = m_pData->m_aTypeCache.find( sName ) ;
    if( pItem != m_pData->m_aTypeCache.end() )
    {
        aType = pItem->second;
    }
	return aType;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Filter FilterCache::getFilter( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getFilter( sName ), "FilterCache::getFilter()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    Filter              aFilter                                        ;
    ConstFilterIterator pItem   = m_pData->m_aFilterCache.find( sName );
    if( pItem != m_pData->m_aFilterCache.end() )
    {
        aFilter = pItem->second;
    }
	return aFilter;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Detector FilterCache::getDetector( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getDetector( sName ), "FilterCache::getDetector()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    Detector              aDetector                                          ;
    ConstDetectorIterator pItem     = m_pData->m_aDetectorCache.find( sName );
    if( pItem != m_pData->m_aDetectorCache.end() )
    {
        aDetector = pItem->second;
    }
	return aDetector;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Loader FilterCache::getLoader( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_getLoader( sName ), "FilterCache::getLoader()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    Loader              aLoader                                        ;
    ConstLoaderIterator pItem   = m_pData->m_aLoaderCache.find( sName );
    if( pItem != m_pData->m_aLoaderCache.end() )
    {
        aLoader = pItem->second;
    }
	return aLoader;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
ContentHandler FilterCache::getContentHandler( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_getContentHandler( sName ), "FilterCache::getContentHandler()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    ContentHandler              aHandler                                               ;
    ConstContentHandlerIterator pItem   = m_pData->m_aContentHandlerCache.find( sName );
    if( pItem != m_pData->m_aContentHandlerCache.end() )
    {
        aHandler = pItem->second;
    }
    return aHandler;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
ProtocolHandler FilterCache::getProtocolHandler( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_getProtocolHandler( sName ), "FilterCache::getProtocolHandler()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Search for element and return his properties.
    ProtocolHandler              aHandler                                                ;
    ConstProtocolHandlerIterator pItem   = m_pData->m_aProtocolHandlerCache.find( sName );
    if( pItem != m_pData->m_aProtocolHandlerCache.end() )
    {
        aHandler = pItem->second;
    }
    return aHandler;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsType( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_existsType( sName ), "FilterCache::existsType()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aTypeCache.find( sName ) != m_pData->m_aTypeCache.end() );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsFilter( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_existsFilter( sName ), "FilterCache::existsFilter()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aFilterCache.find( sName ) != m_pData->m_aFilterCache.end() );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsDetector( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_existsDetector( sName ), "FilterCache::existsDetector()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return  (
                ( m_pData->m_aDetectorCache.find( sName )   !=  m_pData->m_aDetectorCache.end()     )   ||
                ( sName                                     ==  m_pData->m_aDefaultDetector.sName   )
            );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsLoader( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_existsLoader( sName ), "FilterCache::existsLoader()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return  (
                ( m_pData->m_aLoaderCache.find( sName ) !=  m_pData->m_aLoaderCache.end()   )   ||
                ( sName                                 ==  m_pData->m_aGenericLoader.sName )
            );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsContentHandler( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_existsContentHandler( sName ), "FilterCache::existsContentHandler()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aContentHandlerCache.find( sName ) != m_pData->m_aContentHandlerCache.end() );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
sal_Bool FilterCache::existsProtocolHandler( const OUString& sName ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
    LOG_ASSERT2( implcp_existsProtocolHandler( sName ), "FilterCache::existsProtocolHandler()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    return( m_pData->m_aProtocolHandlerCache.find( sName ) != m_pData->m_aProtocolHandlerCache.end() );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
Any FilterCache::queryFilters( const OUString& sQuery ) const
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_queryFilters( sQuery ), "FilterCache::queryFilters()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /*ATTENTION
        Don't use any rw-lock here ... because used impl methods are threadsafe himself!
     */
    Any aResultSet;

    if( sQuery == FILTERQUERY_TEXTDOCUMENT                      ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_TEXTDOCUMENT        ); } else
    if( sQuery == FILTERQUERY_WEBDOCUMENT                       ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_WEBDOCUMENT         ); } else
    if( sQuery == FILTERQUERY_GLOBALDOCUMENT                    ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_GLOBALDOCUMENT      ); } else
    if( sQuery == FILTERQUERY_CHARTDOCUMENT                     ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_CHARTDOCUMENT       ); } else
    if( sQuery == FILTERQUERY_SPREADSHEETDOCUMENT               ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_SPREADSHEETDOCUMENT ); } else
    if( sQuery == FILTERQUERY_PRESENTATIONDOCUMENT              ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_PRESENTATIONDOCUMENT); } else
    if( sQuery == FILTERQUERY_DRAWINGDOCUMENT                   ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_DRAWINGDOCUMENT     ); } else
    if( sQuery == FILTERQUERY_FORMULARPROPERTIES                ) { aResultSet <<= implts_queryFilter_ByDocumentService( DETECTPROPERTY_FORMULARPROPERTIES  ); } else

    if( sQuery == FILTERQUERY_TEXTDOCUMENT_WITHDEFAULT          ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_TEXTDOCUMENT        ); } else
    if( sQuery == FILTERQUERY_WEBDOCUMENT_WITHDEFAULT           ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_WEBDOCUMENT         ); } else
    if( sQuery == FILTERQUERY_GLOBALDOCUMENT_WITHDEFAULT        ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_GLOBALDOCUMENT      ); } else
    if( sQuery == FILTERQUERY_CHARTDOCUMENT_WITHDEFAULT         ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_CHARTDOCUMENT       ); } else
    if( sQuery == FILTERQUERY_SPREADSHEETDOCUMENT_WITHDEFAULT   ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_SPREADSHEETDOCUMENT ); } else
    if( sQuery == FILTERQUERY_PRESENTATIONDOCUMENT_WITHDEFAULT  ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_PRESENTATIONDOCUMENT); } else
    if( sQuery == FILTERQUERY_DRAWINGDOCUMENT_WITHDEFAULT       ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_DRAWINGDOCUMENT     ); } else
    if( sQuery == FILTERQUERY_FORMULARPROPERTIES_WITHDEFAULT    ) { aResultSet <<= implts_queryFilter_ByDocumentService_WithDefault( DETECTPROPERTY_FORMULARPROPERTIES  ); } else

    if( sQuery == FILTERQUERY_GRAPHICFILTERS                    ) { aResultSet <<= implts_queryFilter_ByFirstUserData( DETECTPROPERTY_GRAPHICFILTERS      ); } else
    if( sQuery == FILTERQUERY_DEFAULTFILTERS                    ) { aResultSet <<= implts_queryFilter_ByFlags        ( DETECTPROPERTY_DEFAULTFILTERS      ); }

    return aResultSet;
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
void FilterCache::addFilter( const OUString& sName, const Sequence< PropertyValue >& lProperties ) throw( ElementExistException )
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_addFilter( sName, lProperties ), "FilterCache::addFilter()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

    // We throw an exception if element already exist!
    // Why? Because user can't write threadsafe code by using "existsFilter()" AND "addFilter()" realy ...
    // It's better we throw this exception for him automaticly ...
    // These cache implementation is used by services which must throw an exception in this case!!!
    // If you don't whish that ... write another add-method ...
    if( m_pData->m_aFilterCache.find( sName ) != m_pData->m_aFilterCache.end() )
    {
        OUStringBuffer sMessage( 256 );
        sMessage.appendAscii( "FilterCache::addFilter()\nFilter \"" );
        sMessage.append     ( sName                                 );
        sMessage.appendAscii( "\" already exist!"                   );
        throw ElementExistException( sMessage.makeStringAndClear(), Reference< XInterface >() );
    }

    // Add new filter to internal structures only!
    // User must call "flush()" or release this cache to write data to disk.
    Filter aFilter;
    DataContainer::convertPropertySequenceToFilter( lProperties, aFilter, m_pData->m_sLocale );
    aFilter.sName = sName;
    m_pData->addFilter( aFilter, sal_True );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
void FilterCache::replaceFilter( const OUString& sName, const Sequence< PropertyValue >& lProperties ) throw( NoSuchElementException )
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_replaceFilter( sName, lProperties ), "FilterCache::replaceFilter()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ----------------------------------------------------------------------------------------------- */
    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

    // We throw an exception if element not exist!
    // Why? Because user can't write threadsafe code by using "existsFilter()" AND "replaceFilter()" realy ...
    // It's better we throw this exception for him automaticly ...
    // These cache implementation is used by services which must throw an exception in this case!!!
    // If you don't whish that ... write another replace-method ...
    if( m_pData->m_aFilterCache.find( sName ) == m_pData->m_aFilterCache.end() )
    {
        OUStringBuffer sMessage( 256 );
        sMessage.appendAscii( "FilterCache::replaceFilter()\nFilter \"" );
        sMessage.append     ( sName                                     );
        sMessage.appendAscii( "\" not exist!"                           );
        throw NoSuchElementException( sMessage.makeStringAndClear(), Reference< XInterface >() );
    }

    // Change filter data at internal structures only!
    // User must call "flush()" or release this cache to write data to disk.
    Filter aFilter;
    DataContainer::convertPropertySequenceToFilter( lProperties, aFilter, m_pData->m_sLocale );
    aFilter.sName = sName;
    m_pData->replaceFilter( aFilter, sal_True );
}

//*****************************************************************************************************************
//	interface method
//*****************************************************************************************************************
void FilterCache::removeFilter( const OUString& sName ) throw( NoSuchElementException )
{
	/* UNSAFE AREA --------------------------------------------------------------------------------------------- */
	LOG_ASSERT2( implcp_removeFilter( sName ), "FilterCache::removeFilter()", "Invalid parameter detected!" )
    // Register transaction and reject wrong calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

	/* SAFE AREA ------------------------------------------------------------------------------------------- */
    WriteGuard aWriteLock( LockHelper::getGlobalLock() );

    // We throw an exception if element not exist!
    // Why? Because user can't write threadsafe code by using "existsFilter()" AND "removeFilter()" realy ...
    // It's better we throw this exception for him automaticly ...
    // These cache implementation is used by services which must throw an exception in this case!!!
    // If you don't whish that ... write another remove-method ...
    if( m_pData->m_aFilterCache.find( sName ) == m_pData->m_aFilterCache.end() )
    {
        OUStringBuffer sMessage( 256 );
        sMessage.appendAscii( "FilterCache::removeFilter()\nFilter \""  );
        sMessage.append     ( sName                                     );
        sMessage.appendAscii( "\" not exist!"                           );
        throw NoSuchElementException( sMessage.makeStringAndClear(), Reference< XInterface >() );
    }

    // Remove filter from internal structures only!
    // User must call "flush()" or release this cache to write data to disk.
    m_pData->removeFilter( sName, sal_True );
}

//*****************************************************************************************************************
class CompareOrder
{
    public:
        inline CompareOrder( const DataContainer& rData )
            : m_rData( rData )
        {
        }

        inline int operator() ( const ::rtl::OUString& sFilter1, const ::rtl::OUString& sFilter2 ) const
        {
            ConstFilterIterator p1 = m_rData.m_aFilterCache.find( sFilter1 );
            ConstFilterIterator p2 = m_rData.m_aFilterCache.find( sFilter2 );
            return( p1->second.nOrder < p2->second.nOrder );
        }

    private:
        const DataContainer& m_rData;
};

class PredicatOrder
{
    public:
        inline PredicatOrder( const DataContainer& rData )
            : m_rData( rData )
        {
        }

        inline bool operator() ( const ::rtl::OUString& sFilter ) const
        {
            ConstFilterIterator pFilter = m_rData.m_aFilterCache.find( sFilter );
            return( pFilter->second.nOrder != 0 );
        }

    private:
        const DataContainer& m_rData;
};

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************

/* TODO
	Check different algorithm to collect needed informations at follow methods.
	May be its better to create a stl-vector with all result items and convert it into a sequence ...
	or it's faster to reallocate a sequence at every new found item ...!?
 */

Sequence< OUString > FilterCache::implts_queryFilter_ByDocumentService( const OUString& sService ) const
{
    // Look for rejected calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

	// Step over all filters. Search for right "DocumentService".

    // Algoritm:
    //      a) copy all filter names from hash to temp. vector, which match our search parameter
    //      b) copy all filters, which have a right set "nOrder" property to the front of this vector (right set means: nOrder != 0)
    //      c) sort {0..n} with [n=last] filter with [nOrder!=0] by using this order
    //      d) sort {n+1..m} by name in alphabetical order
    //      e) convert vector to sequence and return it

    // Attention: Use stable versions of stl-functions to maintain order of elements if attributs are the same!

    // a)
    StringList lTempVector;
    for( ConstFilterIterator pFilter=m_pData->m_aFilterCache.begin(); pFilter!=m_pData->m_aFilterCache.end(); ++pFilter )
	{
		if( pFilter->second.sDocumentService == sService )
		{
            lTempVector.push_back( pFilter->first );
        }
	}

    // b)
    // pOrderEnd points to [n+1] or the end of vector, if {n+1..m} is empty!
    StringListIterator pOrderEnd = ::std::stable_partition( lTempVector.begin(), lTempVector.end(), PredicatOrder( *m_pData ) );
    // c)
    // Use helper class CompareOrder() to compare by property "nOrder" ... and not by filter name as default!
    ::std::stable_sort( lTempVector.begin(), pOrderEnd, CompareOrder( *m_pData ) );
    // d)
    // But here we must sort by filter name ... don't use special compare class!
    ::std::stable_sort( pOrderEnd, lTempVector.end() );

    // e)
    Sequence< OUString > lResults;
    DataContainer::convertStringVectorToSequence( lTempVector, lResults );
	return lResults;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::implts_queryFilter_ByDocumentService_WithDefault( const OUString& sService ) const
{
    // Look for rejected calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

	// Step over all filters. Search for right "DocumentService".
	// If found filter is the default => insert it at first one ...
    // all other are inserted at least. Look for ordinal number too.

    // Algoritm:
    //      a  ) copy all filter names from hash to temp. vector, which match our search parameter
    //      a.i) save the default filter for later inserting as first item!
    //      b  ) copy all filters, which have a right set "nOrder" property to the front of this vector (right set means: nOrder != 0)
    //      c  ) sort {0..n} with [n=last] filter with [nOrder!=0] by using this order
    //      d  ) sort {n+1..m} by name in alphabetical order
    //      e  ) insert safed default filter as first one
    //      f  ) convert vector to sequence and return it

    // Attention: Use stable versions of stl-functions to maintain order of elements if attributs are the same!

    // a)
    StringList      lTempVector     ;
    ::rtl::OUString sDefaultFilter  ;
    for( ConstFilterIterator pFilter=m_pData->m_aFilterCache.begin(); pFilter!=m_pData->m_aFilterCache.end(); ++pFilter )
	{
		if( pFilter->second.sDocumentService == sService )
		{
            // a.i)
            if( pFilter->second.nFlags & FILTERFLAG_DEFAULT )
			{
                // Warn programmer if more then one default filter exist!
                LOG_ASSERT2( sDefaultFilter.getLength()>0, "FilterCache::implts_queryFilter_ByDocumentService_WithDefault()", "More then one default filter for same modul detected!" )
                sDefaultFilter = pFilter->first;
			}
            else
            {
                lTempVector.push_back( pFilter->first );
            }
		}
	}

    // b)
    // pOrderEnd points to [n+1] or the end of vector, if {n+1..m} is empty!
    StringListIterator pOrderEnd = ::std::stable_partition( lTempVector.begin(), lTempVector.end(), PredicatOrder( *m_pData ) );
    // c)
    // Use helper class CompareOrder() to compare by property "nOrder" ... and not by filter name as default!
    ::std::stable_sort( lTempVector.begin(), pOrderEnd, CompareOrder( *m_pData ) );
    // d)
    // But here we must sort by filter name ... don't use special compare class!
    ::std::stable_sort( pOrderEnd, lTempVector.end() );

    // e)
    // Warn programmer if no default filter was found ...
    #ifdef ENABLE_ASSERTIONS
    ::rtl::OUStringBuffer _sBuffer( 256 );
    _sBuffer.appendAscii( "Missing default filter for modul \"" );
    _sBuffer.append     ( sService                              );
    _sBuffer.appendAscii( "\""                                  );
    LOG_ASSERT2( sDefaultFilter.getLength()<1, "FilterCache::implts_queryFilter_ByDocumentService_WithDefault()", U2B(_sBuffer.makeStringAndClear()) )
    #endif
    // ... and we can't set it then!
    if( sDefaultFilter.getLength() > 0 )
    {
        lTempVector.push_front( sDefaultFilter );
    }

    // f)
    Sequence< OUString > lResults;
    DataContainer::convertStringVectorToSequence( lTempVector, lResults );
	return lResults;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::implts_queryFilter_ByFlags( sal_Int32 nFlags ) const
{
    // Look for rejected calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Step over all filters, searched by given flags
    // and copy her names to return list.

    StringList lFilters;
    for( ConstFilterIterator pFilter=m_pData->m_aFilterCache.begin(); pFilter!=m_pData->m_aFilterCache.end(); ++pFilter )
	{
		if( pFilter->second.nFlags & nFlags )
		{
			lFilters.push_back( pFilter->first );
		}
	}

	Sequence< OUString > lResults;
    DataContainer::convertStringVectorToSequence( lFilters, lResults );
	return lResults;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
Sequence< OUString > FilterCache::implts_queryFilter_ByFirstUserData( const OUString& sIdentifier ) const
{
    // Look for rejected calls.
    TransactionGuard aTransaction( TransactionManager::getGlobalTransactionManager(), E_HARDEXCEPTIONS );

    /* SAFE AREA ----------------------------------------------------------------------------------------------- */
    ReadGuard aReadLock( LockHelper::getGlobalLock() );

    // Step over all filters, searched by given identifier at first entry of user data
    // and copy her names to return list.

    // Algoritm:
    //      a  ) copy all filter names from hash to temp. vector, which match our search parameter
    //      b  ) copy all filters, which have a right set "nOrder" property to the front of this vector (right set means: nOrder != 0)
    //      c  ) sort {0..n} with [n=last] filter with [nOrder!=0] by using this order
    //      d  ) sort {n+1..m} by name in alphabetical order
    //      e  ) convert vector to sequence and return it

    // Attention: Use stable versions of stl-functions to maintain order of elements if attributs are the same!

    // a)
    StringList lTempVector;
    for( ConstFilterIterator pFilter=m_pData->m_aFilterCache.begin(); pFilter!=m_pData->m_aFilterCache.end(); ++pFilter )
	{
        ConstStringListIterator pFirstUserData=pFilter->second.lUserData.begin();
        if  (
                ( pFirstUserData  != pFilter->second.lUserData.end() ) &&
                ( *pFirstUserData == DETECTPROPERTY_GRAPHICFILTERS   )
            )
		{
            lTempVector.push_back( pFilter->first );
		}
	}

    // b)
    // pOrderEnd points to [n+1] or the end of vector, if {n+1..m} is empty!
    StringListIterator pOrderEnd = ::std::stable_partition( lTempVector.begin(), lTempVector.end(), PredicatOrder( *m_pData ) );
    // c)
    // Use helper class CompareOrder() to compare by property "nOrder" ... and not by filter name as default!
    ::std::stable_sort( lTempVector.begin(), pOrderEnd, CompareOrder( *m_pData ) );
    // d)
    // But here we must sort by filter name ... don't use special compare class!
    ::std::stable_sort( pOrderEnd, lTempVector.end() );

    // e)
    Sequence< OUString > lResults;
    DataContainer::convertStringVectorToSequence( lTempVector, lResults );
	return lResults;
}

//_________________________________________________________________________________________________________________
//	debug methods
//_________________________________________________________________________________________________________________

/*-----------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact the autor or add it himself !(?)
		But ... look for right testing! See using of this methods!
-----------------------------------------------------------------------------------------------------------------*/

#ifdef ENABLE_ASSERTIONS

//*****************************************************************************************************************
// Given pointer mark optional parameter. But a call without search parameter is superflous!
// One of them must valid - I think.
// The start entry parameter must be valid!
sal_Bool FilterCache::implcp_searchType(	const	OUString&	  			sURL				,
								   			const	OUString*	  			pMediaType			,
								   			const	OUString*	  			pClipboardFormat	,
								   			const	CheckedTypeIterator&	aStartEntry			,
											const	OUString&				sResult				)
{
	return	(
				( &aStartEntry	==	NULL	)						||
 				( &sURL			==	NULL	)						||
				( &sResult		==	NULL	)						||
				(
					( pMediaType					!=	NULL	)	&&
					( pMediaType->getLength()		<	1		)
				)													||
				(
					( pClipboardFormat				!=	NULL	)	&&
					( pClipboardFormat->getLength()	<	1		)
				)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer!
sal_Bool FilterCache::implcp_searchFilterForType(	const	OUString&					sInternalTypeName	,
								   					const	CheckedStringListIterator&	aStartEntry			,
													const	OUString&					sResult				)
{
	return	(
				( &sInternalTypeName			==	NULL	)	||
				( sInternalTypeName.getLength()	<	1		)	||
				( &aStartEntry					==	NULL	)	||
				( &sResult						==	NULL	)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer!
sal_Bool FilterCache::implcp_searchDetectorForType(	const	OUString&					sInternalTypeName	,
								   					const	CheckedStringListIterator&	aStartEntry			,
													const	OUString&					sResult				)
{
	return	(
				( &sInternalTypeName			==	NULL	)	||
				( sInternalTypeName.getLength()	<	1		)	||
				( &aStartEntry					==	NULL	)	||
				( &sResult						==	NULL	)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer!
sal_Bool FilterCache::implcp_searchLoaderForType(	const	OUString&					sInternalTypeName	,
								   					const	CheckedStringListIterator&	aStartEntry			,
													const	OUString&					sResult				)
{
	return	(
				( &sInternalTypeName			==	NULL	)	||
				( sInternalTypeName.getLength()	<	1		)	||
				( &aStartEntry					==	NULL	)	||
				( &sResult						==	NULL	)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getTypeProperties( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getFilterProperties( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getDetectorProperties( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getLoaderProperties( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getType( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getFilter( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getDetector( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_getLoader( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_existsType( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_existsFilter( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_existsDetector( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
// We don't accept NULL pointer and can't search for empty entries in hash maps!
sal_Bool FilterCache::implcp_existsLoader( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_addFilter(	const	OUString&					sName		,
								   		const	Sequence< PropertyValue >&	lProperties	)
{
	return	(
				( &sName	  				==	NULL				)	||
				( &lProperties				==	NULL				)	||
				( sName.getLength()			<	1					)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_replaceFilter(	const	OUString&					sName		,
								   			const	Sequence< PropertyValue >&	lProperties	)
{
	return	(
				( &sName	  				==	NULL				)	||
				( &lProperties				==	NULL				)	||
				( sName.getLength()			<	1					)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_removeFilter( const OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_queryFilters( const OUString& sQuery )
{
	return	(
				( &sQuery				==	NULL	)	||
				( sQuery.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_searchContentHandlerForType( const ::rtl::OUString&           sInternalTypeName,
                                                          const CheckedStringListIterator& aStartEntry      ,
                                                          const ::rtl::OUString&           sResult          )
{
	return	(
				( &sInternalTypeName			==	NULL	)	||
				( sInternalTypeName.getLength()	<	1		)	||
				( &aStartEntry					==	NULL	)	||
				( &sResult						==	NULL	)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_searchProtocolHandler( const ::rtl::OUString&           sProtocolURL ,
                                                    const CheckedStringListIterator& aStartEntry  ,
                                                    const ::rtl::OUString&           sResult      )
{
	return	(
                ( &sProtocolURL            ==  NULL    )   ||
                ( sProtocolURL.getLength() <   1       )   ||
                ( &aStartEntry             ==  NULL    )   ||
                ( &sResult                 ==  NULL    )
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_getContentHandlerProperties( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_getProtocolHandlerProperties( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_getContentHandler( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_getProtocolHandler( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_existsContentHandler( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

//*****************************************************************************************************************
sal_Bool FilterCache::implcp_existsProtocolHandler( const ::rtl::OUString& sName )
{
	return	(
				( &sName			==	NULL	)	||
				( sName.getLength()	<	1		)
			);
}

#endif  //  #ifdef ENABLE_ASSERTIONS

}		//	namespace framework
