/*************************************************************************
 *
 *  $RCSfile: ostatusindicatorfactory.cxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: as $ $Date: 2001/06/11 10:31:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRUNTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRUNTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#include <string>		// prevent clash between STLport 3.2.1 and C50 compiler includes
#include <algorithm>

#ifndef __FRAMEWORK_HELPER_OSTATUSINDICATORFACTORY_HXX_
#include <helper/ostatusindicatorfactory.hxx>
#endif

#ifndef __FRAMEWORK_HELPER_OSTATUSINDICATOR_HXX_
#include <helper/ostatusindicator.hxx>
#endif

#ifndef __FRAMEWORK_THREADHELP_RESETABLEGUARD_HXX_
#include <threadhelp/resetableguard.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_AWT_RECTANGLE_HPP_
#include <com/sun/star/awt/Rectangle.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XCONTROLS_HPP_
#include <com/sun/star/awt/XControl.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XLAYOUTCONSTRAINS_HPP_
#include <com/sun/star/awt/XLayoutConstrains.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_DEVICEINFO_HPP_
#include <com/sun/star/awt/DeviceInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_WINDOWATTRIBUTE_HPP_
#include <com/sun/star/awt/WindowAttribute.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

using namespace ::com::sun::star::task			;
using namespace ::com::sun::star::lang			;
using namespace ::com::sun::star::uno			;
using namespace ::cppu							;
using namespace ::osl							;
using namespace ::rtl							;
using namespace ::std							;

//_________________________________________________________________________________________________________________
//	non exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	non exported definitions
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
OStatusIndicatorFactory::OStatusIndicatorFactory(	const	Reference< XMultiServiceFactory >&	xFactory		,
                                                    const   Reference< css::awt::XWindow >&     xParentWindow   )
		//	Init baseclasses first
        :   ThreadHelpBase  ( &Application::GetSolarMutex() )
        ,   OWeakObject     (                               )
        // Init member
        ,   m_xFactory      ( xFactory                      )
        ,   m_xParentWindow ( xParentWindow                 )
{
    try
    {

	// Safe impossible cases
	LOG_ASSERT( impldbg_checkParameter_OStatusIndicatorFactory( xFactory, xParentWindow ), "OStatusIndicatorFactory::OStatusIndicatorFactory()\nInvalid parameter detected!\n" )
/*
	// Create a floating window as child of given parent and parent of indicator window!
	// It's neccessary for right repaint order. We will the top window every time!
    Reference< css::awt::XWindowPeer >    xParentPeer ( xParentWindow, UNO_QUERY ) ;
	Reference< XToolkit >		xToolkit	= xParentPeer->getToolkit();

	WindowDescriptor aDescriptor;
	aDescriptor.Type				=	WindowClass_TOP					;
	aDescriptor.WindowServiceName	=	DECLARE_ASCII("floatingwindow")	;
	aDescriptor.ParentIndex			=	-1								;
	aDescriptor.Parent				=	xParentPeer						;
	aDescriptor.Bounds				=	Rectangle(0,0,300,50)			;
	aDescriptor.WindowAttributes	=	WindowAttribute::BORDER			|
										WindowAttribute::MOVEABLE		|
										WindowAttribute::SIZEABLE		|
										WindowAttribute::CLOSEABLE		;
    Reference< css::awt::XWindowPeer > xFloatingPeer = xToolkit->createWindow( aDescriptor );
    m_xParentWindow = Reference< css::awt::XWindow >( xFloatingPeer, UNO_QUERY );
	m_xParentWindow->setEnable( sal_True );
	m_xParentWindow->setVisible( sal_False );
*/
	// Take parent, set it on status window, add us as listener and calculate position and size of controls.
	m_xParentWindow->addWindowListener( this );

	// Create status indicator window to shared it for all created indictaor objects by this factory.
	m_xSharedStatusIndicator = Reference< XStatusIndicator >( xFactory->createInstance( DECLARE_ASCII("com.sun.star.task.XStatusIndicator") ), UNO_QUERY );
	// Don't forget to set parent window on it!
    Reference< css::awt::XControl >       xControl    ( m_xSharedStatusIndicator  , UNO_QUERY ) ;
    Reference< css::awt::XWindowPeer >    xParentPeer ( xParentWindow, UNO_QUERY ) ;
    Reference< css::awt::XToolkit >       xToolkit    = xParentPeer->getToolkit();
    xControl->createPeer( xToolkit, xParentPeer );
    m_xIndicatorWindow = Reference< css::awt::XWindow >( m_xSharedStatusIndicator, UNO_QUERY );
	m_xIndicatorWindow->setVisible( sal_False );

    }
    catch( RuntimeException& )
    {
    }
}

//*****************************************************************************************************************
//	destructor
//*****************************************************************************************************************
OStatusIndicatorFactory::~OStatusIndicatorFactory()
{
    try
    {

	// Clear stack and other member before destroy.
	m_aStack.clear();
	m_xFactory					= Reference< XMultiServiceFactory >();
	m_xActiveIndicator			= Reference< XStatusIndicator >();
    Reference< css::awt::XControl >( m_xSharedStatusIndicator, UNO_QUERY )->dispose();
	m_xSharedStatusIndicator	= Reference< XStatusIndicator >();
    m_xParentWindow             = Reference< css::awt::XWindow >();
    m_xIndicatorWindow          = Reference< css::awt::XWindow >();

    }
    catch( RuntimeException& )
    {
    }
}

//*****************************************************************************************************************
//	XInterface
//*****************************************************************************************************************
DEFINE_XINTERFACE_2		(	OStatusIndicatorFactory						,
							OWeakObject					  				,
							DIRECT_INTERFACE(XStatusIndicatorFactory	),
                            DIRECT_INTERFACE(css::awt::XWindowListener            )
						)

//*****************************************************************************************************************
//	XStatusIndicatorFactory
//*****************************************************************************************************************
Reference< XStatusIndicator > SAL_CALL OStatusIndicatorFactory::createStatusIndicator() throw( RuntimeException )
{
	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );

	// Create a new indicator, initialize and add it to our stack ...
    OStatusIndicator* pIndicator = new OStatusIndicator( m_aLock.getShareableOslMutex(), this );
	Reference< XStatusIndicator > xIndicator( static_cast< OWeakObject* >(pIndicator), UNO_QUERY );
	// ... but do it only, if created indicator is valid.
	// Invalid objects are ignored!
	LOG_ASSERT( !(xIndicator.is()==sal_False), "OStatusIndicatorFactory::createStatusIndicator()\nCould not create status indicator(!) ... whats wrong?\n" )
	if( xIndicator.is() == sal_True )
	{
		m_aStack.push_back( xIndicator );
		m_xActiveIndicator = xIndicator;
	}

	// ... and return it as result.
	return xIndicator;
}

//*****************************************************************************************************************
//  css::awt::XWindowListener
//*****************************************************************************************************************
void SAL_CALL OStatusIndicatorFactory::windowResized( const css::awt::WindowEvent& aEvent ) throw( RuntimeException )
{
	impl_recalcLayout();
}

//*****************************************************************************************************************
//  css::awt::XWindowListener
//*****************************************************************************************************************
void SAL_CALL OStatusIndicatorFactory::windowMoved( const css::awt::WindowEvent& aEvent ) throw( RuntimeException )
{
	impl_recalcLayout();
}

//*****************************************************************************************************************
//  css::awt::XWindowListener
//*****************************************************************************************************************
void SAL_CALL OStatusIndicatorFactory::windowShown( const EventObject& aEvent ) throw( RuntimeException )
{
}

//*****************************************************************************************************************
//  css::awt::XWindowListener
//*****************************************************************************************************************
void SAL_CALL OStatusIndicatorFactory::windowHidden( const EventObject& aEvent ) throw( RuntimeException )
{
}

//*****************************************************************************************************************
//	XEventListener
//*****************************************************************************************************************
void SAL_CALL OStatusIndicatorFactory::disposing( const EventObject& aEvent ) throw( RuntimeException )
{
}

//*****************************************************************************************************************
//	public shared method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::start(	const	Reference< XStatusIndicator >&	xChildIndicator	,
										const	OUString&						sText			,
												sal_Int32						nRange			)
{

	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );
	// Safe impossible cases
	// Method not defined for all incoming parameter
	LOG_ASSERT( impldbg_checkParameter_start( xChildIndicator, sText, nRange ), "OStatusIndicatorFactory::start()\nInvalid parameter detected!\n" )

	// Forward operation to shared indicator window, if child the most active one!
	if( xChildIndicator == m_xActiveIndicator )
	{
        try
        {
		m_xIndicatorWindow->setVisible( sal_True );
		m_xSharedStatusIndicator->start( sText, nRange );
        }
        catch( RuntimeException& )
        {
        }
	}
}

//*****************************************************************************************************************
//	public shared method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::end( const Reference< XStatusIndicator >&	xChildIndicator	)
{
    try
    {

	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );
	// Safe impossible cases
	// Method not defined for all incoming parameter
	LOG_ASSERT( impldbg_checkParameter_end( xChildIndicator ), "OStatusIndicatorFactory::end()\nInvalid parameter detected!\n" )

	// Forward operation to shared indicator window, if child the most active one!
	if( xChildIndicator == m_xActiveIndicator )
	{
		m_xSharedStatusIndicator->end();
	}
	// These child indicator has finished his operations.
	// We can remove it from our stack ... even this was not the most active one!
	// Search object and remove it from container if it exist.
	IMPL_TIndicatorStack::iterator aSearchedItem = find( m_aStack.begin(), m_aStack.end(), xChildIndicator );
	if( aSearchedItem != m_aStack.end() )
	{
		m_aStack.erase( aSearchedItem );
		// If removed indicator the current active one - set last item of stack as new active.
		// If stack is empty, reset variable and hide window.
		if( xChildIndicator == m_xActiveIndicator )
		{
			if( m_aStack.size() > 0 )
			{
				m_xActiveIndicator = *m_aStack.rbegin();
				OStatusIndicator* pIndicator = static_cast< OStatusIndicator* >( m_xActiveIndicator.get() );
				pIndicator->impl_activate();
			}
			else
			{
				m_xIndicatorWindow->setVisible( sal_False );
				m_xActiveIndicator = Reference< XStatusIndicator >();
			}
		}
	}

    }
    catch( RuntimeException& )
    {
    }
}

//*****************************************************************************************************************
//	public shared method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::reset( const Reference< XStatusIndicator >& xChildIndicator	)
{
	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );
	// Safe impossible cases
	// Method not defined for all incoming parameter
	LOG_ASSERT( impldbg_checkParameter_reset( xChildIndicator ), "OStatusIndicatorFactory::reset()\nInvalid parameter detected!\n" )

	// Forward operation to shared indicator window, if child the most active one!
	if( xChildIndicator == m_xActiveIndicator )
	{
        try
        {
		m_xSharedStatusIndicator->reset();
        }
        catch( RuntimeException& )
        {
        }
	}
}

//*****************************************************************************************************************
//	public shared method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::setText(	const	Reference< XStatusIndicator >&	xChildIndicator	,
										const	OUString&						sText			)
{
	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );
	// Safe impossible cases
	// Method not defined for all incoming parameter
	LOG_ASSERT( impldbg_checkParameter_setText( xChildIndicator, sText ), "OStatusIndicatorFactory::setText()\nInvalid parameter detected!\n" )

	// Forward operation to shared indicator window, if child the most active one!
	if( xChildIndicator == m_xActiveIndicator )
	{
        try
        {
		m_xSharedStatusIndicator->setText( sText );
        }
        catch( RuntimeException& )
        {
        }
	}
}

//*****************************************************************************************************************
//	public shared method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::setValue(	const	Reference< XStatusIndicator >&	xChildIndicator	,
												sal_Int32						nValue			)
{
	// Ready for multithreading
	ResetableGuard aGuard( m_aLock );
	// Safe impossible cases
	// Method not defined for all incoming parameter
	LOG_ASSERT( impldbg_checkParameter_setValue( xChildIndicator, nValue ), "OStatusIndicatorFactory::setValue()\nInvalid parameter detected!\n" )

	// Forward operation to shared indicator window, if child the most active one!
	if( xChildIndicator == m_xActiveIndicator )
	{
        try
        {
		m_xSharedStatusIndicator->setValue( nValue );
        }
        catch( RuntimeException& )
        {
        }
	}
}

//*****************************************************************************************************************
//	private method!
//*****************************************************************************************************************
void OStatusIndicatorFactory::impl_recalcLayout()
{
    try
    {

	// Collect some informations about preferred sizes of dialog controls
	// and calculate his new values.
	// We use the deviceinfo to calculate new indicator size with border and title bar of parent window!
    css::awt::Rectangle   aParentSize     = m_xParentWindow->getPosSize();
    css::awt::Size        aIndicatorSize  = (Reference< css::awt::XLayoutConstrains >( m_xSharedStatusIndicator, UNO_QUERY ))->getPreferredSize();

	m_xIndicatorWindow->setPosSize(	(aParentSize.Width/2 )-(aIndicatorSize.Width/2 )	,
									(aParentSize.Height/2)-(aIndicatorSize.Height/2)	,
									aIndicatorSize.Width								,
									aIndicatorSize.Height								,
                                    css::awt::PosSize::POSSIZE                          );

    }
    catch( RuntimeException& )
    {
    }
}

//_________________________________________________________________________________________________________________
//	debug methods
//_________________________________________________________________________________________________________________

/*-----------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact the autor or add it himself !(?)
		But ... look for right testing! See using of this methods!
-----------------------------------------------------------------------------------------------------------------*/

#ifdef ENABLE_ASSERTIONS

//*****************************************************************************************************************
// We need a valid servicemanager (xFactory) to create our shared indicator object and a parent window to initialize the indicator peer!
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_OStatusIndicatorFactory(	const	Reference< XMultiServiceFactory >&	xFactory		,
                                                                                    const   Reference< css::awt::XWindow >&     xParentWindow   )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &xFactory				==	NULL		)	||
			( &xParentWindow		==	NULL		)	||
			( xFactory.is()			==	sal_False	)	||
			( xParentWindow.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We can test for null pointer only. I can't say if an integer of 0 is valid or not ...
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_windowResized( const css::awt::WindowEvent& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aEvent == NULL )
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We can test for null pointer only. I can't say if an integer of 0 is valid or not ...
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_windowMoved( const css::awt::WindowEvent& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aEvent == NULL )
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and look for a valid source of this event. We will know who send us these message!
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_windowShown( const EventObject& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&aEvent				==	NULL		)	||
			(	aEvent.Source.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and look for a valid source of this event. We will know who send us these message!
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_windowHidden( const EventObject& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&aEvent				==	NULL		)	||
			(	aEvent.Source.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and look for a valid source of this event. We will know who send us these message!
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_disposing( const EventObject& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&aEvent				==	NULL		)	||
			(	aEvent.Source.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and need a valid child indicator .. because we must compare it it with our current active
// indicator. And these compare is not defined for NULL references! See wrapper methods of XStatusIndicator for further informations.
// Look for a valid range too. We support positiv values only.
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_start(	const	Reference< XStatusIndicator >&	xChildIndicator	,
																const	OUString&						sText			,
																		sal_Int32						nRange			)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&xChildIndicator		==	NULL		)	||
			(	&sText					==	NULL		)	||
			(	xChildIndicator.is()	==	sal_False	)	||
			(	nRange					<	0			)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and need a valid child indicator .. because we must compare it it with our current active
// indicator. And these compare is not defined for NULL references! See wrapper methods of XStatusIndicator for further informations.
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_end( const Reference< XStatusIndicator >& xChildIndicator )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&xChildIndicator		==	NULL		)	||
			(	xChildIndicator.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and need a valid child indicator .. because we must compare it it with our current active
// indicator. And these compare is not defined for NULL references! See wrapper methods of XStatusIndicator for further informations.
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_reset( const Reference< XStatusIndicator >& xChildIndicator )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&xChildIndicator		==	NULL		)	||
			(	xChildIndicator.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and need a valid child indicator .. because we must compare it it with our current active
// indicator. And these compare is not defined for NULL references! See wrapper methods of XStatusIndicator for further informations.
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_setText(	const	Reference< XStatusIndicator >&	xChildIndicator	,
																	const	OUString&						sText			)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&xChildIndicator		==	NULL		)	||
			(	&sText					==	NULL		)	||
			(	xChildIndicator.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// We check for null pointer and need a valid child indicator .. because we must compare it it with our current active
// indicator. And these compare is not defined for NULL references! See wrapper methods of XStatusIndicator for further informations.
// We look for a valid value too. It must between 0 and range ... but at this point we cant control the range!
sal_Bool OStatusIndicatorFactory::impldbg_checkParameter_setValue(	const	Reference< XStatusIndicator >&	xChildIndicator	,
																			sal_Int32					  	nValue			)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			(	&xChildIndicator		==	NULL		)	||
			(	xChildIndicator.is()	==	sal_False	)	||
			(	nValue					<	0			)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

#endif	//	#ifdef ENABLE_ASSERTIONS

}		//	namespace framework
