/*************************************************************************
 *
 *  $RCSfile: transliteration.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: er $ $Date: 2001/08/16 12:06:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef INCLUDED_I18N_TRANSLITERATION_HXX
#define INCLUDED_I18N_TRANSLITERATION_HXX

#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#include <com/sun/star/uno/Reference.h>
#include <com/sun/star/i18n/XTransliteration.hpp>

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#include <cppuhelper/implbase1.hxx>


class International;

class Transliteration : public cppu::WeakImplHelper1< ::com::sun::star::i18n::XTransliteration >
{
public:
                                Transliteration();
                                ~Transliteration();

    virtual ::rtl::OUString SAL_CALL getName(  ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Int16 SAL_CALL getType(  ) throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL loadModule( ::com::sun::star::i18n::TransliterationModules modType, const ::com::sun::star::lang::Locale& rLocale ) throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL loadModuleNew( const ::com::sun::star::uno::Sequence< ::com::sun::star::i18n::TransliterationModulesNew >& modType, const ::com::sun::star::lang::Locale& rLocale ) throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL loadModuleByImplName( const ::rtl::OUString& implName, const ::com::sun::star::lang::Locale& rLocale ) throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL loadModulesByImplNames( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& implNamelist, const ::com::sun::star::lang::Locale& rLocale ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getAvailableModules( const ::com::sun::star::lang::Locale& rLocale, sal_Int16 sType ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL transliterate( const ::rtl::OUString& inStr, sal_Int32 startPos, sal_Int32 nCount, ::com::sun::star::uno::Sequence< sal_Int32 >& offset ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL folding( const ::rtl::OUString& inStr, sal_Int32 startPos, sal_Int32 nCount, ::com::sun::star::uno::Sequence< sal_Int32 >& offset ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL equals( const ::rtl::OUString& str1, sal_Int32 pos1, sal_Int32 nCount1, sal_Int32& nMatch1, const ::rtl::OUString& str2, sal_Int32 pos2, sal_Int32 nCount2, sal_Int32& nMatch2 ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL transliterateRange( const ::rtl::OUString& str1, const ::rtl::OUString& str2 ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Int32 SAL_CALL compareSubstring( const ::rtl::OUString& s1, sal_Int32 off1, sal_Int32 len1, const ::rtl::OUString& s2, sal_Int32 off2, sal_Int32 len2 ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Int32 SAL_CALL compareString( const ::rtl::OUString& s1, const ::rtl::OUString& s2 ) throw (::com::sun::star::uno::RuntimeException);

private:

            International*          mpInternational;
            sal_uInt16              mnCompFlags;
            sal_uInt16              mnCaseConv;     // 0:=none, 1:=tolower, 2:=toupper

            void                SwitchInternational( const ::com::sun::star::lang::Locale& rLocale );
};

#endif // INCLUDED_I18N_TRANSLITERATION_HXX
