PRJ=..
PRJNAME=product
TARGET=udk

# ------------------------------------------------------------------
.INCLUDE: settings.mk
# ------------------------------------------------------------------

PRODUCT_NAME=$(TARGET)$(UDK_MAJOR).$(UDK_MINOR).$(UDK_MICRO)
PRODUCT_ZIPPREFIX=$(PRODUCT_NAME)

DESTDIR=$(OUT)$/bin$/$(PRODUCT_NAME)
DESTDIRINC=$(DESTDIR)$/include
DESTDIRIDL=$(DESTDIR)$/idl
DESTDIRXML=$(DESTDIR)$/xml
DESTDIREXAMPLES=$(DESTDIR)$/examples
DESTDIREXAMPLESCPP=$(DESTDIREXAMPLES)$/cpp
DESTDIRJAR=$(DESTDIR)$/classes
DESTDIRSETTINGS=$(DESTDIR)$/settings

BINOUT=$(SOLARBINDIR)
INCOUT=$(SOLARINCDIR)
IDLOUT=$(SOLARIDLDIR)
.IF "$(SOLXMLDIR)" == ""
XMLOUT=$(SOLARBINDIR)$/..$/xml
.ELSE
XMLOUT=$(SOLARXMLDIR)
.ENDIF
LIBOUT=$(SOLARLIBDIR)

.IF "$(GUI)"=="WNT"
#####################
# WNT ONLY
#####################
MY_DLLPREFIX=
MY_DLLPOSTFIX=.dll
MY_VERSION_DLLPOSTFIX=.dll
MY_VERSION_LINKPOSTFIX=
MY_VERSION_LINKTARGETPOSTFIX=
MY_MAJOR=$(UDK_MAJOR)
EXEPOSTFIX=.exe
DLLOUT=$(SOLARBINDIR)

# bugs in 16-bit tools
MY_DELETE_RECURSIVE=del /sxyf
MY_TEXTCOPY=cat
.ELSE
#####################
# UNX ONLY
#####################
DLLOUT=$(SOLARLIBDIR)
MY_DLLPOSTFIX=.so
MY_VERSION_DLLPOSTFIX=.so.$(UDK_MAJOR).$(UDK_MINOR).$(UDK_MICRO)
MY_VERSION_LINKPOSTFIX=.so.$(UDK_MAJOR)
MY_VERSION_LINKTARGETPOSTFIX=.$(UDK_MINOR).$(UDK_MICRO)
MY_MAJOR=
MY_DLLPREFIX=lib
EXEPOSTFIX=
MY_DELETE_RECURSIVE=rm -rf
MY_TEXTCOPY= tr -d "\015"
.ENDIF
MY_TEXTCOPY_SOURCEPRE=<
MY_TEXTCOPY_TARGETPRE=>

.IF "$(OS)$(CPU)"=="SOLARISS"
##############
# SOLARIS SPARC
##############
DESTDIRBIN=$(DESTDIR)$/solsparc$/bin
DESTDIRLIB=$(DESTDIR)$/solsparc$/lib
DESTDIRDLL=$(DESTDIRLIB)
.IF "$(COM)"=="GCC"
BINDINGDLL=gcc2_uno
STLPORTLIBNAME=libstlport_gcc.so
.ELSE
BINDINGDLL=sunpro5_uno
STLPORTLIBNAME=libstlport_sunpro.so
.ENDIF

.ELIF "$(OS)$(CPU)"=="SOLARISI"
##########
# SOLARIS INTEL
##########
DESTDIRBIN=$(DESTDIR)$/solia$/bin
DESTDIRLIB=$(DESTDIR)$/solia$/lib
DESTDIRDLL=$(DESTDIRLIB)
STLPORTLIBNAME=libstlport_sunpro.so
.IF "$(COM)"=="GCC"
BINDINGDLL=gcc2_uno
.ELSE
BINDINGDLL=sunpro5_uno
.ENDIF

.ELIF "$(OS)"=="LINUX"
###########
# LINUX
###########
DESTDIRBIN=$(DESTDIR)$/linux$/bin
DESTDIRLIB=$(DESTDIR)$/linux$/lib
DESTDIRDLL=$(DESTDIRLIB)
STLPORTLIBNAME=libstlport_gcc.so
BINDINGDLL=gcc2_uno

.ELIF "$(OS)"=="WNT"
###############
# WINDOWS
DESTDIRBIN=$(DESTDIR)$/windows$/bin
DESTDIRLIB=$(DESTDIR)$/windows$/lib
DESTDIRDLL=$(DESTDIRBIN)
BINDINGDLL=msci_uno
ADDITIONAL_DLLS= \
	$(DESTDIRDLL)$/w9xucwrp.dll
.ENDIF

.IF "$(STLPORTLIBNAME)" != ""
STLPORTDEST=$(DESTDIRDLL)$/$(STLPORTLIBNAME)
ADDITIONAL_DLLS=$(STLPORTDEST)
.IF "$(STLPORT4)" != ""
# in OOo build environment
STLPORTOUT=$(STLPORT4)$/lib$/$(STLPORTLIBNAME)
.ELSE
# hamburg build environment
STLPORTOUT=$(DLLOUT)$/$(STLPORTLIBNAME)
.ENDIF
.ENDIF

INCLUDETOPDIRLIST= \
	$(INCOUT)$/sal 		\
	$(INCOUT)$/salhelper	\
	$(INCOUT)$/rtl 		\
	$(INCOUT)$/osl 		\
	$(INCOUT)$/store 	\
	$(INCOUT)$/typelib 	\
	$(INCOUT)$/uno 		\
	$(INCOUT)$/com 		\
	$(INCOUT)$/cppu 	\
	$(INCOUT)$/cppuhelper 	\
	$(INCOUT)$/bridges 	

INCLUDEFILELIST=\
	$(INCOUT)$/udkversion.mk
    
INCLUDEDIRLIST={$(subst,/,$/ $(shell $(FIND) $(INCLUDETOPDIRLIST) -type d -print))}
# IDLDIRLIST={$(subst,/,$/ $(shell $(FIND) $(IDLOUT) -type d -print))}
IDLDIRLIST=\
	{$(subst,/,$/ $(shell $(FIND) \
	$(IDLOUT)$/com$/sun$/star$/beans \
	$(IDLOUT)$/com$/sun$/star$/bridge \
	$(IDLOUT)$/com$/sun$/star$/connection \
	$(IDLOUT)$/com$/sun$/star$/container \
	$(IDLOUT)$/com$/sun$/star$/io \
	$(IDLOUT)$/com$/sun$/star$/java \
	$(IDLOUT)$/com$/sun$/star$/lang \
	$(IDLOUT)$/com$/sun$/star$/loader \
	$(IDLOUT)$/com$/sun$/star$/reflection \
	$(IDLOUT)$/com$/sun$/star$/registry \
	$(IDLOUT)$/com$/sun$/star$/script \
	$(IDLOUT)$/com$/sun$/star$/test \
	$(IDLOUT)$/com$/sun$/star$/uno \
	-type d -print))}

DIRLIST = \
	$(DESTDIR) 				\
	$(DESTDIRBIN)  				\
	$(DESTDIRLIB) 				\
	$(DESTDIRJAR) 				\
	$(DESTDIRXML) 				\
	$(DESTDIRINC) 				\
	$(DESTDIRSETTINGS) 			\
	$(DESTDIREXAMPLESCPP) 			\
	$(DESTDIREXAMPLESCPP)$/remoteclient 	\
	$(DESTDIREXAMPLESCPP)$/counter		\
	{$(subst,$(INCOUT),$(DESTDIRINC) $(INCLUDEDIRLIST))} \
	{$(subst,$(IDLOUT),$(DESTDIRIDL) $(IDLDIRLIST))}


EXELIST = \
	$(DESTDIRBIN)$/cppumaker$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/regcomp$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/regmerge$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/regview$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/rdbmaker$(EXEPOSTFIX)	\
	$(DESTDIRBIN)$/idlcpp$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/idlc$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/javamaker$(EXEPOSTFIX) 	\
	$(DESTDIRBIN)$/xml2cmp$(EXEPOSTFIX)	\
	$(DESTDIRBIN)$/uno$(EXEPOSTFIX)

COMPONENTLIST = \
	acceptor	\
	brdgfctr	\
	connectr	\
	corefl		\
	cpld		\
	defreg		\
	dynamicloader	\
	impreg		\
	insp		\
	inv		\
	invadp		\
	jen		\
	namingservice	\
	proxyfac	\
	rdbtdp		\
	remotebridge	\
	simreg		\
	smgr		\
	stm		\
	tcv		\
	tdmgr		\
	uuresolver
	
DLLLIST = \
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)rmcxt$(MY_MAJOR)$(MY_VERSION_DLLPOSTFIX) 		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)sal$(MY_MAJOR)$(MY_VERSION_DLLPOSTFIX)  		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)store$(MY_MAJOR)$(MY_VERSION_DLLPOSTFIX) 		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)reg$(MY_MAJOR)$(MY_VERSION_DLLPOSTFIX)   		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)cppu$(MY_MAJOR)$(MY_VERSION_DLLPOSTFIX)  		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)cppuhelper$(UDK_MAJOR)$(COM)$(MY_DLLPOSTFIX) 	\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)salhelper$(UDK_MAJOR)$(COM)$(MY_DLLPOSTFIX)	\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)javaloader$(MY_DLLPOSTFIX)          		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)juh$(MY_DLLPOSTFIX)                   		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)$(BINDINGDLL)$(MY_DLLPOSTFIX)           		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)java_uno$(MY_DLLPOSTFIX)            		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)prot_uno_uno$(MY_DLLPOSTFIX)            		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)iiop_uno$(MY_DLLPOSTFIX)                		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)urp_uno$(MY_DLLPOSTFIX)                 		\
	$(ADDITIONAL_DLLS)

DLLLIST+= \
	$(foreach,c,$(COMPONENTLIST) $(DESTDIRDLL)$/$(MY_DLLPREFIX)$c$(MY_DLLPOSTFIX))

.IF "$(GUI)"=="UNX"
LINKLIST = \
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)rmcxt$(MY_VERSION_LINKPOSTFIX)		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)sal$(MY_VERSION_LINKPOSTFIX)  		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)store$(MY_VERSION_LINKPOSTFIX)		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)reg$(MY_VERSION_LINKPOSTFIX) 		\
	$(DESTDIRDLL)$/$(MY_DLLPREFIX)cppu$(MY_VERSION_LINKPOSTFIX)
.ENDIF

JARLIST = \
	$(DESTDIRJAR)$/sandbox.jar 	\
	$(DESTDIRJAR)$/jurt.jar 	\
	$(DESTDIRJAR)$/ridl.jar 	\
	$(DESTDIRJAR)$/jut.jar 		\
	$(DESTDIRJAR)$/juh.jar 		\
	$(DESTDIRJAR)$/java_uno.jar

.IF "$(GUI)"=="WNT"  
LIBLIST = \
	$(DESTDIRLIB)$/istore.lib 	\
	$(DESTDIRLIB)$/ireg.lib 	\
	$(DESTDIRLIB)$/isal.lib 	\
	$(DESTDIRLIB)$/isalhelper.lib 	\
	$(DESTDIRLIB)$/icppu.lib 	\
	$(DESTDIRLIB)$/icppuhelper.lib 	\
	$(DESTDIRLIB)$/irmcxt.lib 	
.ENDIF

SETTINGSLIST= \
	$(DESTDIRSETTINGS)$/win_microcxx_settings.mk \
	$(DESTDIRSETTINGS)$/linux_gcc_settings.mk \
	$(DESTDIRSETTINGS)$/solaris_workshopcxx_settings.mk \
	$(DESTDIRSETTINGS)$/std.mk \
	$(DESTDIRSETTINGS)$/stdtarget.mk \
	$(DESTDIRSETTINGS)$/dk.mk

EXAMPLESLIST= \
	$(DESTDIREXAMPLES)$/README \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/remoteclient.cxx \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/remoteclientsample.xml \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/README           \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/makefile.mk      \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/Makefile         \
	$(DESTDIREXAMPLESCPP)$/remoteclient$/exports.dxp      \
	$(DESTDIREXAMPLESCPP)$/counter$/XCountable.idl	   \
	$(DESTDIREXAMPLESCPP)$/counter$/counter.xml	   \
	$(DESTDIREXAMPLESCPP)$/counter$/counter.cxx	   \
	$(DESTDIREXAMPLESCPP)$/counter$/countermain.cxx    \
	$(DESTDIREXAMPLESCPP)$/counter$/README      	   \
	$(DESTDIREXAMPLESCPP)$/counter$/makefile.mk 	   \
	$(DESTDIREXAMPLESCPP)$/counter$/Makefile    	   \
	$(DESTDIREXAMPLESCPP)$/counter$/exports.dxp 	   
	
XMLLIST= \
	$(foreach,c,$(COMPONENTLIST) $(DESTDIRXML)$/$c.xml) \
	$(DESTDIRXML)$/module-description.dtd
		
#--------------------------------------------------
# TARGETS
#--------------------------------------------------
INCLUDELIST=\
	{$(subst,/,$/ $(shell $(FIND) $(INCLUDETOPDIRLIST) -type f -print))} \
    $(INCLUDEFILELIST)

DESTINCLUDELIST={$(subst,$(SOLARINCDIR),$(DESTDIRINC) $(INCLUDELIST))}

IDLLIST={$(subst,/,$/ $(shell $(FIND) $(IDLDIRLIST) -type f -print))}
DESTIDLLIST={$(subst,$(IDLOUT),$(DESTDIRIDL) $(IDLLIST))}

ALLTARGETS = \
	$(MISC)$/deltree.txt 	\
	$(DIRLIST) 		\
	$(EXELIST) 		\
	$(DLLLIST) 		\
	$(LINKLIST)		\
	$(JARLIST) 		\
	$(XMLLIST) 		\
	$(DESTDIRBIN)$/udkapi.rdb \
	$(LIBLIST) 		\
	$(SETTINGSLIST) 	\
	$(EXAMPLESLIST)		\
	$(DESTINCLUDELIST)	\
	$(DESTIDLLIST)		\
	zipit

.IF "$(depend)" == ""
ALL: $(ALLTARGETS) 
.ELSE
ALL:
.ENDIF

$(MISC)$/deltree.txt : deltree.txt
	+-$(RM) $(DESTDIR)$/..$/$(PRODUCT_ZIPPREFIX).zip >& $(NULLDEV)
	+-$(RM) $(DESTDIR)$/..$/$(PRODUCT_ZIPPREFIX).tar >& $(NULLDEV)
	+-$(RM) $(DESTDIR)$/..$/$(PRODUCT_ZIPPREFIX).tar.gz >& $(NULLDEV)
	+-$(MY_DELETE_RECURSIVE) $(DESTDIR) >& $(NULLDEV)
	touch $(MISC)$/deltree.txt

$(DIRLIST) : $(MISC)$/deltree.txt
	$(MKDIRHIER)	$@

$(DESTDIRBIN)$/udkapi.rdb : $(BINOUT)$/udkapi.rdb $(DESTDIRBIN)
	$(GNUCOPY) -p $(BINOUT)$/udkapi.rdb $@

$(DESTDIRBIN)$/%$(EXEPOSTFIX) : $(BINOUT)$/%$(EXEPOSTFIX) $(DIRLIST)
	$(GNUCOPY) -p $(BINOUT)$/$(@:f) $@


.IF "$(STLPORTDEST)" != ""
#OOo build environment
$(STLPORTDEST) : $(STLPORTOUT) $(DIRLIST)
 	$(GNUCOPY) -p $(STLPORTOUT) $@
.ENDIF

$(DESTDIRDLL)$/%$(MY_DLLPOSTFIX) : $(DLLOUT)$/%$(MY_DLLPOSTFIX) $(DIRLIST)
	$(GNUCOPY) -p $(DLLOUT)$/$(@:f) $@

$(DESTDIRDLL)$/%$(MY_VERSION_DLLPOSTFIX) : $(DLLOUT)$/%$(MY_VERSION_DLLPOSTFIX) $(DIRLIST)
	$(GNUCOPY) -p $(DLLOUT)$/$(@:f) $@

$(DESTDIRDLL)$/%$(MY_VERSION_LINKPOSTFIX) : $(DESTDIRDLL)$/%$(MY_VERSION_DLLPOSTFIX) $(DIRLIST)
	+ln -s $(@:f)$(MY_VERSION_LINKTARGETPOSTFIX) $@
	+ln -s $(@:f)$(MY_VERSION_LINKTARGETPOSTFIX) $(@:db)

$(DESTDIRJAR)$/%.jar : $(BINOUT)$/%.jar $(DIRLIST)
	$(GNUCOPY) -p $(BINOUT)$/$(@:f) $@

$(DESTDIRXML)$/%.xml : $(XMLOUT)$/%.xml $(DIRLIST)
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $? $(MY_TEXTCOPY_TARGETPRE) $@

$(DESTDIRXML)$/module-description.dtd : $(XMLOUT)$/module-description.dtd $(DIRLIST)
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $(XMLOUT)$/module-description.dtd $(MY_TEXTCOPY_TARGETPRE) $@

$(DESTDIRLIB)$/%.lib : $(LIBOUT)$/%.lib $(DIRLIST)
	$(GNUCOPY) -p $(LIBOUT)$/$(@:f) $@

$(DESTDIRSETTINGS)$/%.mk : $(PRJ)$/settings$/%.mk $(DIRLIST)
	+-rm -f $@ >& $(NULLDEV)
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $? $(MY_TEXTCOPY_TARGETPRE) $@

# EXAMPLES CPP RULE
$(DESTDIREXAMPLESCPP)$/% : $(PRJ)$/examples$/cpp$/% 
	+-rm -f $@ >& $(NULLDEV)
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $? $(MY_TEXTCOPY_TARGETPRE) $@

$(DESTDIREXAMPLES)$/README : $(PRJ)$/examples$/README
	$(GNUCOPY) -p $(PRJ)$/examples$/README $@

$(DESTDIRIDL)$/% : $(IDLOUT)$/%
	+-rm -f $@
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $? $(MY_TEXTCOPY_TARGETPRE) $@

$(DESTDIRINC)$/% : $(INCOUT)$/%
	+-rm -f $@
	$(MY_TEXTCOPY) $(MY_TEXTCOPY_SOURCEPRE) $? $(MY_TEXTCOPY_TARGETPRE) $@

zipit .SETDIR=$(DESTDIR)$/.. :
	.IF "$(OS)"=="WNT"
		+zip $(PRODUCT_ZIPPREFIX).zip -ur $(PRODUCT_ZIPPREFIX).zip $(PRODUCT_NAME)
	.ELIF "$(GUI)"=="UNX"
#               UPDATE DOES NOT WORK correctly with unix tar
		+-$(RM) $(PRODUCT_ZIPPREFIX).tar.gz
		tar -cf - $(PRODUCT_ZIPPREFIX) | gzip - > $(PRODUCT_ZIPPREFIX).tar.gz
	.ENDIF


