/*************************************************************************
 *
 *  $RCSfile: about.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: thb $ $Date: 2001/07/09 12:45:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// INCLUDE ---------------------------------------------------------------

#ifndef _TOOLS_RCID_H
#include <tools/rcid.h>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _UCBHELPER_CONTENTBROKER_HXX 
#include <ucbhelper/contentbroker.hxx>
#endif
#ifndef _UCBHELPER_CONTENT_HXX
#include <ucbhelper/content.hxx>
#endif
#ifndef _UCBHELPER_CONFIGURATIONKEYS_HXX_
#include <ucbhelper/configurationkeys.hxx>
#endif
#ifndef _UTL_CONFIGMGR_HXX_
#include <unotools/configmgr.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_BITMAPEX_HXX
#include <vcl/bitmapex.hxx>
#endif
#ifndef _SV_WALL_HXX
#include <vcl/wall.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#include "sip.hrc"

#include "app.hxx"
#include "rscrev.hxx"
#include "about.hrc"
#include "sdresid.hxx"
#include "strings.hrc"


using namespace ::com::sun::star;


class SipAboutDlg : public ModalDialog
{
private:
	OKButton	maOkButton;

public:
	SipAboutDlg( Window* pParent );
};

SipAboutDlg::SipAboutDlg( Window* pParent )
: ModalDialog( pParent, SdResId( DLG_ABOUT ) ),
  maOkButton( this, SdResId( BT_OK ) )
{
	// decide which bitmap to use
	uno::Any aRet = ::utl::ConfigManager::GetDirectConfigProperty( ::utl::ConfigManager::PRODUCTNAME );
	rtl::OUString aTmp;
	aRet >>= aTmp;
	String aProdName(aTmp);

	BitmapEx 	aBitmap;
	SdResId		aResId( BMP_ALT_ABOUT );
	if( STRING_NOTFOUND != aProdName.SearchAscii("StarSuite") &&
		pDeskResMgr->IsAvailable(aResId.SetRT(RSC_BITMAP)) )
	{
		aBitmap = BitmapEx( aResId );			
	}
	else
	{
		aBitmap = BitmapEx( SdResId( BMP_ABOUT ) );
	}

	Size aSize( aBitmap.GetSizePixel() );
	aSize = CalcWindowSize( aSize );
	SetSizePixel( aSize );

	Wallpaper aWallPaper( aBitmap );
	SetBackground( aWallPaper );

	Point aBtnPos;
	Size aBtnSize( maOkButton.GetSizePixel() );

	aBtnPos.X() = aSize.Width() - 6 - aBtnSize.Width();
	aBtnPos.Y() = aSize.Height() - 6 - aBtnSize.Height();
	maOkButton.SetPosPixel(aBtnPos);

	FreeResource();
}

void SipShowAboutDlg( Window* pParent )
{
	SipAboutDlg aDlg( pParent );
	aDlg.Execute();
}

