/*************************************************************************
 *
 *  $RCSfile: fuslshow.cxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: thb $ $Date: 2001/07/09 12:45:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TOOLS_RCID_H
#include <tools/rcid.h>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif
#ifndef _SVDPAGV_HXX //autogen
#include <svx/svdpagv.hxx>
#endif
#ifndef _AEITEM_HXX //autogen
#include <svtools/aeitem.hxx>
#endif
#ifndef _IPENV_HXX //autogen
#include <so3/ipenv.hxx>
#endif
#ifndef _IPCLIENT_HXX //autogen
#include <so3/ipclient.hxx>
#endif
#ifndef _SVDOOLE2_HXX //autogen
#include <svx/svdoole2.hxx>
#endif
#ifndef _SVDITER_HXX //autogen
#include <svx/svditer.hxx>
#endif
#ifndef _SB_SBSTAR_HXX //autogen
#include <basic/sbstar.hxx>
#endif
#ifndef _SVDORECT_HXX //autogen
#include <svx/svdorect.hxx>
#endif
#ifndef _SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif
#ifndef _GOODIES_IMAPOBJ_HXX //autogen
#include <svtools/imapobj.hxx>
#endif
#ifndef _SV_GRAPH_HXX
#include <vcl/graph.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _UCBHELPER_CONTENTBROKER_HXX 
#include <ucbhelper/contentbroker.hxx>
#endif
#ifndef _UCBHELPER_CONTENT_HXX
#include <ucbhelper/content.hxx>
#endif
#ifndef _UCBHELPER_CONFIGURATIONKEYS_HXX_
#include <ucbhelper/configurationkeys.hxx>
#endif
#ifndef _UTL_CONFIGMGR_HXX_
#include <unotools/configmgr.hxx>
#endif

#include <limits.h> 					// LONG_MAX

#define FUSLIDESHOW_INTERN
#include "fuslshow.hxx"
#include <svx/svxids.hrc>
#include <svx/dialogs.hrc>              // fuer SID_REHEARSE_TIMINGS
#include <svx/gallery.hxx>
#include <svx/xoutx.hxx>
#include <sd/sdattr.hxx>
#include <sd/app.hrc>
#include "sdresid.hxx"
#include <sd/anminfo.hxx>
//#include "res_bmp.hrc"
#include "showview.hxx"

#include <sd/sdpage.hxx>
#include "frmview.hxx"
#include "viewshel.hxx"
#include <sd/pres.hxx>
#include "mover.hxx"
#include "fader.hxx"
#include <sd/glob.hrc>
#include "pgjump.hxx"
#include "outlinfo.hxx"
#include <sd/drawdoc.hxx>
#include <sd/cusshow.hxx>
#include "view.hxx"
/// NEU
//#include "optsitem.hxx"

#include "app.hxx"
#include "sip.hrc"

using namespace ::com::sun::star;

#define QUAD_ADVANCEEVENT_TOLERANCE 400 	// quadrierter Tatterkreis-Radius
#define ITEMVALUE(ItemSet,Id,Cast)	((const Cast&)(ItemSet).Get(Id)).GetValue()

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

FuSlideShow::FuSlideShow(SipViewShell*	 pViewSh,
						 WorkWindow*	 pWin,
						 SdDrawDocument* pDoc,
						 const Options&  aOptions	)
		   : pWindow(pWin),
			 pView(NULL),
			 pDoc(pDoc),
			 pViewShell(pViewSh),
			 pWorkWindow(pWin),
			 pShowWindow(NULL),
			 pShowView(NULL),
			 pFader(new Fader(pWin)),
			 pMover(new SdBitmapMover(pWin, this)),
			 rOptions(aOptions),
			 pVDev(NULL),
			 pAnmVDev(NULL),
			 pMskVDev( NULL ),
			 pTimeButton(NULL),
			 pCurAnmList(new List),
			 pNextAnmList(new List),
			 pCurAnimGraphs(new List),
			 pNextAnimGraphs(new List),
			 pCurControls(new List),
			 pNextControls(new List),
			 pLayoutText(NULL),
			 pLayoutClip(NULL),
			 pLayoutBmpEx(NULL),
			 pCompoundText(NULL),
			 pTopLayer(NULL),
			 bFullBckgnd(FALSE),
			 eRandomLayout(presentation::AnimationEffect_NONE),
			 pSound(NULL),
			 nRestorePage(0),
			 nVisibleAffectingObjects(0),
			 bManual(FALSE),
			 bMouseVisible(TRUE),
			 bMouseAsPen(FALSE),
			 bRehearseTimings(FALSE),
			 nPauseTimeout(0),
			 bShowPauseLogo(FALSE),
			 bVDevEmpty(TRUE),
			 nMouseClickSema(0UL),
			 bMouseIsDrawing(FALSE),
			 bAlwaysOnTop(FALSE),
			 bAutoSaveSuppressed(FALSE),
			 bNativeMode(TRUE),
			 bInitShowStatus(FALSE),
			 bLockedPages(FALSE),
             eAnimationMode(ANIMATIONMODE_SHOW),
             nIgnoreInputSmph(1),
			 pTimeButtonBckgnd(NULL),
			 pActualPage(NULL),
			 pClientList(NULL),
			 nParaPos(0L),
			 pDimObject(NULL),
			 pHideObject(NULL),
			 bPlayFull(FALSE),
			 bTimerIntercepted(FALSE),
			 bDocChanged(pDoc->IsChanged()),
			 pMetaFile(NULL),
			 pBckgndRect(NULL),
			 pLayoutClone(NULL),
			 pSlowObjList(NULL),
			 pDrawModeWindows(NULL),
             pOldActiveWindow(NULL),
             bGridVisible(FALSE),
             bFullScreen(TRUE),
             pNewAttr(NULL),
             nMagic(SLIDESHOW_MAGIC),
             bSetOnlineSpelling(FALSE),
			 bTerminated(FALSE),
			 nShellLockCount( 0UL ),
			 nPushCount( 0UL ),
             pOutlInfo(new OutlinerInfo()),
			 nStartShowEvt( 0UL ),
			 nResizeEvt( 0UL ),
			 nMasterPageCacheMode(SDR_MASTERPAGECACHE_FULL),
			 aPenColor( COL_LIGHTGREEN ),
			 bPause(FALSE),
			 bPrepareForPage(FALSE),
			 nCancelThisEvt(0),
			 bDestroyed(FALSE),
			 bReadyForNextInput(TRUE)
{
	pView = new SipView( this, pDoc, NULL );

	if( pViewShell )
		pViewShell->SetView(pView);
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

FuSlideShow::~FuSlideShow()
{
	Destroy( FALSE );
}

// -----------------------------------------------------------------------------

void FuSlideShow::Destroy( BOOL bDelete )
{
	if( !bDestroyed )
	{
		// Falls noch Events in der Queue haengen, diese abwuergen
		if( nStartShowEvt )
			Application::RemoveUserEvent( nStartShowEvt );

		if( nResizeEvt )
			Application::RemoveUserEvent( nResizeEvt );

		if( nCancelThisEvt )
			Application::RemoveUserEvent( nCancelThisEvt );

		nMagic = 0L;
		aTimer.Stop();
		aEscapeTimer.Stop();


		if( pShowWindow && eAnimationMode == ANIMATIONMODE_SHOW )
			pShowWindow->Hide();

		delete pFader;
		delete pMover;

		if( pCurAnmList && pCurAnmList->Count() )
		{
			for( void* pO = pCurAnmList->First(); pO; pO = pCurAnmList->Next() )
			{
				SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( (SdrObject*) pO );
				if( pInfo )
					pInfo->bShow = pInfo->bIsShown = TRUE;
			}
		}
		delete pCurAnmList;

		if( pNextAnmList && pNextAnmList->Count() )
		{
			for( void* pO = pNextAnmList->First(); pO; pO = pNextAnmList->Next() )
			{
				SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( (SdrObject*) pO );
				if( pInfo )
					pInfo->bShow = pInfo->bIsShown = TRUE;
			}
		}
		delete pNextAnmList;

		StopAnimGraphs();
		
		delete pCurAnimGraphs;
		delete pNextAnimGraphs;
		delete pCurControls;
		delete pNextControls;
		delete pMetaFile;
		delete pLayoutClone;
		delete pLayoutClip;
		delete pLayoutBmpEx;
		delete pCompoundText;
		delete pTopLayer;

		ClearSlowObjList();
		delete pSlowObjList;

		DeleteClientList();

		delete pTimeButtonBckgnd;
		delete pVDev;
		delete pAnmVDev;
		delete pMskVDev;
		delete pShowView;
		delete pSound;
		delete pDrawModeWindows;

	/*
		while( nPushCount )
		{
			pShowWindow->Pop();
			nPushCount--;
		}
	*/
	/*
		if ( pViewShell )
		{
	//        SdShowWindow* pActWin = pViewShell->GetActiveWindow();
			if (pActWin)
			{
	//            Size aVisSizePixel = pActWin->GetOutputSizePixel();
	//            Rectangle aVisAreaWin = pActWin->PixelToLogic( Rectangle( Point(0,0), aVisSizePixel) );
	//            pViewShell->VisAreaChanged(aVisAreaWin);
	//			pView->VisAreaChanged(pActWin);
				pActWin->GrabFocus();
			}
		}
	*/
		delete pNewAttr;
		delete pOutlInfo;

		if( pViewShell )
			pViewShell->SetView( NULL );

        pView->DelWin( pShowWindow );
		delete pView;
		delete pShowWindow;

		// Dtor ist durchlaufen
		bTerminated = bDestroyed = TRUE;

		if( bDelete )
			Application::PostUserEvent( LINK( this, FuSlideShow, DestroyHdl ) );
	}
}

// -----------------------------------------------------------------------------

IMPL_LINK( FuSlideShow, DestroyHdl, void*, p )
{
	delete this;
	return 0L;
}

/*************************************************************************
|*
|* Time Out Handler fuer Seitenwechsel
|*
\************************************************************************/

IMPL_LINK( FuSlideShow, PageTimeOutHdl, Timer *, pTimer )
{
	if( nMagic != SLIDESHOW_MAGIC )
		return 0L;

	if( bPause && pTimer )
	{
		pTimer->SetTimeout(50);
		pTimer->Start();
		return 0;
	}

	aAnimPageList.MakePageNumCurrent( aAnimPageList.GetNextPageNum() );
	DoPageFade();

	return 0L;
}

/*************************************************************************
|*
|* Seitenwechsel durchfuehren
|*
\************************************************************************/

void FuSlideShow::DoPageFade()
{
	if( pShowWindow)
		pShowWindow->SetViewShell( pViewShell );

	// Wenn gerade ein Sound vollstaendig abgespielt werden soll, wird die Ausfuehrung dieser
	// Methode blockiert. Der Handler wird nach dem Sound durch SoundHasStoppedHdl nochmal gerufen.
	if( bPlayFull )
	{
		bTimerIntercepted = TRUE;
		return;
	}

//	SfxBindings&	rBind = SFX_BINDINGS();
	const USHORT	nCurPage = aAnimPageList.GetCurrentPageNum();
	BOOL			bAbort = FALSE;

	LockDrawViewShell();

	// die animierten Grafiken stoppen
	StopAnimGraphs();

	RestoreMapMode();

	if( PAGE_NO_END == nCurPage )
		StopShow();
	else if( PAGE_NO_SOFTEND == nCurPage )
		pShowWindow->SetEndMode();
	else if( PAGE_NO_PAUSE == nCurPage )
	{
		if( pDoc->GetSdPageCount( PK_STANDARD ) == 1 )
			bVDevEmpty = TRUE;

		// decide which bitmap to use
		uno::Any aRet = ::utl::ConfigManager::GetDirectConfigProperty( ::utl::ConfigManager::PRODUCTNAME );
		rtl::OUString aTmp;
		aRet >>= aTmp;
		String aProdName(aTmp);
		
		Bitmap	 	aBitmap;
		SdResId		aResId( BMP_ALT_PRES_LOGO );
		if( STRING_NOTFOUND != aProdName.SearchAscii("StarSuite") &&
			pDeskResMgr->IsAvailable(aResId.SetRT(RSC_BITMAP)) )
		{
			aBitmap = Bitmap( aResId );			
		}
		else
		{
			aBitmap = Bitmap( SdResId( BMP_PRES_LOGO ) );
		}
		
		Graphic aGrph( aBitmap );
		if( bShowPauseLogo && nPauseTimeout )
			pShowWindow->SetPauseMode( aAnimPageList.GetRealNextPageNum(), nPauseTimeout, &aGrph );
		else
			pShowWindow->SetPauseMode( aAnimPageList.GetRealNextPageNum(), nPauseTimeout );
	}
	else
	{
		bReadyForNextInput = ( ANIMATIONMODE_SHOW != eAnimationMode );

		SdPage* pCurPage = pDoc->GetSdPage( nCurPage, PK_STANDARD );
		BOOL	bNavigatorIsVisibleInShow = FALSE;

		// Information ueber abzublendendes Objekt zuruecksetzen
		pDimObject = pHideObject = pLayoutText = NULL;

		delete pLayoutClone;
		pLayoutClone = NULL;

		delete pCompoundText;
		pCompoundText = NULL;

		pOutlInfo->Clear();

		// wenn noch nichts im virtuellen Device ist
		if( bVDevEmpty || ( aAnimPageList.GetPreparedPageNum() != nCurPage ) )
		{
			bIVDsFound = FALSE;
			nVisibleAffectingObjects = 0;
			PrepareForPage( pCurPage, TRUE );
		}

		// ShowStati fuer Masterpage-Objekte an dieser Stelle immer neu initialisieren,
		// da im ::PrepareForPage immer die alten Stati restauriert werden muessen,
		// da dort ggf. nur die naechste Seite _vorbereitet_ wird
        SdrObjListIter aMasterIter( *pCurPage->GetMasterPage( 0 ), IM_FLAT );
		for( SdrObject* pMasterO = aMasterIter.Next(); pMasterO; pMasterO = aMasterIter.Next() )
		{
            SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pMasterO );
            if( pInfo )
				InitShowStatus( pInfo );
		}

		// warten bis Seite fertig ist, dann ueberblenden
		while( !pShowView->IsRedrawReady() ) {}

		// Ueberblendeffekt einstellen
		Point	aUpperLeft( pCurPage->GetLftBorder(), pCurPage->GetUppBorder());
		Point	aLowerRight( pCurPage->GetSize().Width() - pCurPage->GetRgtBorder(), pCurPage->GetSize().Height() - pCurPage->GetLwrBorder());
		Size	aPixSize(pShowWindow->PixelToLogic( Size( 1, 1 ) ) );

		// damit die rechte und untere Borderlinie nicht sichtbar wird
		// (eigentlich muesste das Hintergrundrechteck ein Pixel hoeher und
		// breiter gezeichnet werden, aber dann wird es an anderen Stellen
		// nicht mehr erkannt, also muss die Show es hier wieder geradebiegen)
		aUpperLeft = pShowWindow->PixelToLogic( pShowWindow->LogicToPixel( aUpperLeft ) );
		aLowerRight = pShowWindow->PixelToLogic( pShowWindow->LogicToPixel( aLowerRight ) );
		aLowerRight.X() -= aPixSize.Width();
		aLowerRight.Y() -= aPixSize.Height();

		Rectangle aRect( aUpperLeft, aLowerRight );

		pFader->SetSource( aRect );
		pFader->SetTarget( aRect );
		pFader->SetEffect( pCurPage->GetFadeEffect() );
		pFader->SetSpeed( pCurPage->GetFadeSpeed() );
		pFader->SetNewVirtualDevice( pVDev );

		// falls noch ein Sound spielt
		pSound->Stop();
		pSound->SetSoundName( String() );

		// Sound beim Ueberblenden
		if( pCurPage->IsSoundOn() )
			StartSound( pCurPage->GetSoundFile() );

		// aktuelle Seite setzen ...
		pActualPage = pCurPage;

		// Seite in der DrawView anzeigen, alle dabei anfallenden Paints
		// unterdruecken
		pView->AllowPresPaint(FALSE);
		pView->HideAllPages();
		pView->ShowPage( pCurPage, Point() );

		SdrPageView*	pPageView2 = pView->GetPageView( pActualPage );
//	    SdViewShell*	pViewSh = GetDrawViewShellForShow();

		pShowWindow->Update();

		// Client-Liste loeschen und neu anlegen
		DeleteClientList();
		pClientList = new List;

		// falls der Benutzer den Bildschirm vollgeschmiert hat ...
		if( bMouseAsPen )
		{
			PolyPolygon aClip;
			Rectangle	aScreen(pShowWindow->PixelToLogic( Point() ), pShowWindow->GetOutputSize() );
			Rectangle	aInner(pShowWindow->LogicToPixel(aRect));

			// jeweils ein Pixel nach aussen
			aRect.Left() -= 1;
			aRect.Top() -= 1;
			aRect.Right() += 1;
			aRect.Bottom() += 1;
			aInner = pShowWindow->PixelToLogic(aInner);
			aClip.Insert(aScreen);
			aClip.Insert(aInner);
			pShowWindow->SetClipRegion(aClip);
			Color aBlackColor( COL_BLACK );
			pShowWindow->SetFillColor( aBlackColor );
			pShowWindow->SetLineColor();
			pShowWindow->DrawRect(aScreen);
			pShowWindow->SetClipRegion();
		}

		// Seiten ueberblenden, da zwischendurch Paints hereinkommen koennen, die das bisher dargestellte
		// uebermalen, wird der Hintergrund waehrend des Fadeeffektes temporaer transparent gemacht
		const Wallpaper aOldWorkBack( pWorkWindow->GetBackground() );
		const Wallpaper aOldShowBack( pShowWindow->GetBackground() );

		pWorkWindow->SetBackground();
		pShowWindow->SetBackground();

		BOOL bFade = pFader->Fade();
		RestoreMapMode();

		// remember the time this page faded in
		nFadeInTime = Time::GetSystemTicks();

        // im Reschedule des Effekts zerstoert?
        if( nMagic != SLIDESHOW_MAGIC )
		{
			bReadyForNextInput = TRUE;
			return;
		}

		pWorkWindow->SetBackground( aOldWorkBack );
		pShowWindow->SetBackground( aOldShowBack );

		// jetzt wieder erlaubt
		pView->AllowPresPaint(TRUE);

		if( !bFade )
		{
			// Resize during fade, force repaint now!
			pShowWindow->Invalidate();
			USHORT nForce = 101;
			while( nForce-- )
				Application::Reschedule();

		    // im Reschedule des Effekts zerstoert?
	        if( nMagic != SLIDESHOW_MAGIC )
				return;
		}

		// falls ein Animationsobjekt initial sichtbar ist, aber per
		// ClickAction verschwinden soll, den reinen Hintergrund ins
		// VDev zeichnen
		if( bIVDsFound )
			RepaintVDev( pActualPage, TRUE );

		// im virtuellen Device ist jetzt nicht mehr die (vermutlich) nachste Seite
		bVDevEmpty = TRUE;

		// aus dem Zeichenmodus raus
		if( bMouseAsPen )
			bMouseIsDrawing = FALSE;

		if( !bAbort )
		{
			// die Liste der Animationsobjekte der vorbereiteten Seite wird zur aktuellen Animationsliste,
			// die ehemals aktuelle Liste wird beim Vorbereiten der naechsten Seite benutzt
			List* pTempList = pCurAnmList;
			pCurAnmList	= pNextAnmList;
			pNextAnmList = pTempList;

			// ebenso fuer die Listen der animierten Grafiken
			pTempList = pCurAnimGraphs;
			pCurAnimGraphs = pNextAnimGraphs;
			pNextAnimGraphs = pTempList;

			pTempList = pCurControls;
			pCurControls = pNextControls;
			pNextControls = pTempList;

			// Falls nichts mehr animiert wird, kann die vorraussichtlich
			// naechste Seite aufbereitet werden (folgende Seite)
			const USHORT nNextPage = aAnimPageList.CalcNextPageNum( TRUE );

			if( nNextPage < PAGE_NO_FIRSTDEF && nNextPage != nCurPage && 
				!pCurAnmList->Count() && !bIVDsFound )
			{
				pShowView->HideAllPages();
                PrepareForPage( pDoc->GetSdPage( nNextPage, PK_STANDARD ), TRUE );
				bVDevEmpty = FALSE;
			}

            // fuer das korrekte connecten braucht der SFx das echte ShowWindow und keinen NULL-Pointer
            if( eAnimationMode == ANIMATIONMODE_SHOW )
            {
//				pViewShell->SetActiveWindow( pShowWindow );
                ShowPlugIns();
            }

			// animierte Objektem die nicht per Effekt gestartet werden, jetzt und hier starten
			ShowAnimGraphs( TRUE );
			ShowControls();

			// bei automatischem Diawechsel oder Zeitnahme muss die Objektanimation automatisch laufen
			if( ( ( pActualPage->GetPresChange() != PRESCHANGE_MANUAL ) && !bManual ) || bRehearseTimings )
				aTimer.SetTimeoutHdl( LINK( this, FuSlideShow, ObjectTimeOutHdl ) );
			else
				aTimer.SetTimeoutHdl( LINK( this, FuSlideShow, ReadyForNextInputHdl ) );

			aTimer.SetTimeout( 20 );
			aTimer.Start();
		}
		else
		{
			bReadyForNextInput = TRUE;
			StopShow();
		}
	}

	UnlockDrawViewShell( FALSE );
}

/*************************************************************************
|*
|* Time Out Handler fuer die Zeitanzeige des Buttons
|*
\************************************************************************/

IMPL_LINK( FuSlideShow, TimeButtonTimeOutHdl, Timer *, pTimer )
{
	return 0;
}

/*************************************************************************
|*
|* Click Handler fuer den Zeitnahmebutton
|*
\************************************************************************/

IMPL_LINK( FuSlideShow, TimeButtonHdl, Button *, pButton )
{
	if( nMagic != SLIDESHOW_MAGIC )
		return 0L;

	Time aNow;

	aNow -= aSlideVisibleSince;

	const ULONG	nSeconds = aNow.GetSec() + aNow.GetMin() * 60 + aNow.GetHour() * 3600;
	SdPage*		pPage = pDoc->GetSdPage( aAnimPageList.GetCurrentPageNum(), PK_STANDARD );

	pPage->SetTime( nSeconds );
	pPage->SetPresChange( PRESCHANGE_AUTO );
	pShowWindow->GrabFocus();
	aAnimPageList.MakePageNumCurrent( aAnimPageList.GetNextPageNum() );
	DoPageFade();

	return 0L;
}

/*************************************************************************
|*
|* die Show starten (startet die eigentliche Show asynchron)
|*
\************************************************************************/

void FuSlideShow::StartShow()
{
	// aktuelle Fenster ausblenden
    if( eAnimationMode == ANIMATIONMODE_SHOW )
		//TODO:???		( (SdDrawViewShell*) pViewShell )->PreparePresentation();

	// evtl. schon vorhandenes Event herausnehmen
	if( nStartShowEvt )
		Application::RemoveUserEvent( nStartShowEvt );

	// neues Event erzeugen und merken
	nStartShowEvt = Application::PostUserEvent( LINK( this, FuSlideShow, StartShowHdl ) );
}

/*************************************************************************
|*
|* die eigentliche Show starten
|*
\************************************************************************/

#define SetTriStateOption( dest, tri, doc ) \
	if( tri == STATE_DONTKNOW ) \
		dest = doc; \
	else \
		dest = tri == STATE_CHECK?TRUE:FALSE;

IMPL_LINK( FuSlideShow, StartShowHdl, void*, p )
{
	if( nMagic != SLIDESHOW_MAGIC )
		return 0L;

	// Event wird abgearbeitet
	nStartShowEvt = 0UL;

	SdPage* pStartPage = pViewShell ? pViewShell->GetActualPage() : NULL;
//    Window* pParent = Application::GetAppWindow();
    Size	aWinSizePix;
    BOOL	bAll = TRUE;
	BOOL	bAbort = FALSE;

	// Einstellungen vom Doc oder Options holen

	bAll = pDoc->GetPresAll();
	SetTriStateOption( bMouseVisible, rOptions.GetMouseVisible(), pDoc->GetPresMouseVisible() );
	SetTriStateOption( bMouseAsPen, rOptions.GetMouseAsPen(), pDoc->GetPresMouseAsPen() );
	SetTriStateOption( bLockedPages, rOptions.GetLockedPages(), !pDoc->GetPresLockedPages() );
	SetTriStateOption( bAlwaysOnTop, rOptions.GetAlwaysOnTop(), pDoc->GetPresAlwaysOnTop() );
	SetTriStateOption( bFullScreen, rOptions.GetFullScreen(), pDoc->GetPresFullScreen() );
	SetTriStateOption( bAnimationAllowed, rOptions.GetAnimationAllowed(), pDoc->IsAnimationAllowed() );
	bLockedPages = !bLockedPages;

	nPauseTimeout = rOptions.GetPauseTimeout() == 0 ? pDoc->GetPresPause() : rOptions.GetPauseTimeout();
	SetTriStateOption( bShowPauseLogo, rOptions.GetShowPauseLogo(), pDoc->IsPresShowLogo() );

	aAnimPageList.SetEndlessMode( rOptions.GetEndless() == STATE_DONTKNOW ? pDoc->GetPresEndless() : rOptions.GetEndless() == STATE_CHECK );
	aAnimPageList.SetPauseMode( rOptions.GetPauseTimeout() != 0 );
	aAnimPageList.SetSoftendMode( TRUE );
	
	switch( rOptions.GetPresChange() )
	{
		case 1:		// manual
			bManual = TRUE;
			break;

		case 2:		// semiautomatic	
			bManual = TRUE;
			SetPresChange( PRESCHANGE_SEMIAUTO );
			break;

		case 3:		// automatic
			bManual = FALSE;
			SetPresChange( PRESCHANGE_AUTO, rOptions.GetPageTimeout() );
			break;

		default:	// as defined in document	
			bManual = pDoc->GetPresManual();
			break;
	};

	// Seitenliste aufbauen
	CreatePageList( bAll, FALSE, pDoc->GetPresPage() );

    // ItemSet ausgewertet: und tschues
    delete pNewAttr;
    pNewAttr = NULL;

//	pParent = &pViewShell->GetViewFrame()->GetWindow();
	pShowWindow = new SdShowWindow( pWorkWindow, this );
	pViewShell->SetActiveWindow( pShowWindow );

	pFader->SetWindow( pShowWindow );
	pMover->SetWindow( pShowWindow );
	pView->AllowPresPaint(FALSE);
    aPencil = Pointer( POINTER_PEN );
	pVDev = new VirtualDevice( *pShowWindow );
	pAnmVDev = new VirtualDevice( *pShowWindow );
	pSound = new Sound;
	pDrawModeWindows = new List;
	pWorkWindow->SetBackground( Color( COL_BLACK ) );
	pShowWindow->SetBackground( Color( COL_BLACK ) );

	// MasterPage-Caching ausschalten (z.B. das der DrawView)
    if( eAnimationMode == ANIMATIONMODE_SHOW )
//        pViewShell->GetView()->ReleaseMasterPagePaintCache();

    if( bFullScreen )
    {
        // damit bei fensterlnden Debuggern Fehlersuche noch moeglich ist

#ifdef DEBUG
        aWinSizePix.Width() = 640;
        aWinSizePix.Height() = 480;
        pWorkWindow->SetSizePixel(aWinSizePix);
#else
	    pWorkWindow->StartPresentationMode( TRUE, bAlwaysOnTop ? PRESENTATION_HIDEALLAPPS : 0 );
        aWinSizePix = pWorkWindow->GetSizePixel();
#endif
    }
    else if (eAnimationMode != ANIMATIONMODE_SHOW)
        aWinSizePix = pShowWindow->GetOutputSizePixel();
    else
        aWinSizePix = pWorkWindow->GetOutputSizePixel();

    pWorkWindow->Show(); 
	pWorkWindow->ToTop();

    if( aWinSizePix.Width() && aWinSizePix.Height() )
	{
		// Resize synchron ausfuehren,
		// daher direkt den Handler rufen;
		// aNewSizePix wird normalerweise im
		// ::Resize gesetzt, daher hier setzen
		aNewSize = aWinSizePix;
		ResizeHdl( NULL );
	}

	mMasterMapModeWin = pShowWindow->GetMapMode();
	mMasterMapModeDev = pVDev->GetMapMode();

	pShowWindow->Erase();

	if( bAbort )
	{
		HandleError( STR_NOT_ENOUGH_MEMORY );
		StopShow();
	}
	else
	{
        pShowView = new ShowView( pDoc, pVDev, NULL, pShowWindow );

		// Daten der ShowView in die DrawView schreiben
		SetPaintModes( pShowView, pView, NULL, NULL );

		// erst nach diesem Uebertragen der Einstellungen Animationen in der
		// ShowView abschalten (die Animationen, die NICHT Animationsobjekt
		// sind, werden nach der Seitenueberblendung per ShowAnimGraphs() gestartet)
		pShowView->SetAnimationEnabled(FALSE);

        // in einer normalen Praesentation sollen die AnimatedGIFs nicht von
        // allein starten, in einer Preview aber doch
		pView->SetAnimationEnabled( eAnimationMode != ANIMATIONMODE_SHOW );

        // Raster ausschalten
        pView->SetGridVisible( FALSE );

		// ein Trick, um Invalidate()-Aufrufe wirkungslos zu machen
		// (Ursache der Aufrufe: Scrolling im Fader)
		pShowWindow->SetBackground();

		aTimer.SetTimeoutHdl( LINK( this,FuSlideShow, PageTimeOutHdl ) );

		if ( bMouseAsPen )
		{
			aOldPointer = pShowWindow->GetPointer();
			pShowWindow->SetPointer( aPencil );
		}

		pView->AddWin( pShowWindow );

		pShowWindow->Update();

        // das Fenster der Diashow ist erschienen: Input- und Paint-Handler
		// aktivieren
		if( nIgnoreInputSmph )
			nIgnoreInputSmph--;

        pView->AllowPresPaint(TRUE);

		// Den PageTimeOutHdl ASYNCHRON aufrufen, damit das SetWindow(NULL)
		// (s.o.) noch wirkt, wenn der SFx dem Fenster ein Show() schickt.
		// Im PageTimeOutHdl() wird dem SFx dann wieder vor ShowPlugIns()
		// das richtige Fenster (pShowWindow) gesetzt.
		aTimer.SetTimeoutHdl(LINK(this, FuSlideShow, PageTimeOutHdl));
		aTimer.SetTimeout( 50 );      // 50 Millisekunden
		aTimer.Start();

		aEscapeTimer.SetTimeoutHdl( LINK( this, FuSlideShow, EscapeHdl ) );
		aEscapeTimer.SetTimeout( 500 );
	}

	if( eAnimationMode == ANIMATIONMODE_SHOW )
		pShowWindow->GrabFocus();

	pShowWindow->ShowPointer( bMouseVisible );

	return 0L;
}

void FuSlideShow::RestartShow()
{
	aTimer.Stop();
	aEscapeTimer.Stop();

	// evtl. schon vorhandenes Event herausnehmen
	if( nStartShowEvt )
		Application::RemoveUserEvent( nStartShowEvt );

	// neues Event erzeugen und merken
	nStartShowEvt = Application::PostUserEvent( LINK( this, FuSlideShow, RestartShowHdl ) );
}

IMPL_LINK( FuSlideShow, RestartShowHdl, void*, p )
{
	if( nMagic != SLIDESHOW_MAGIC )
		return 0L;

	// Event wird abgearbeitet
	nStartShowEvt = 0UL;

	CreatePageList( pDoc->GetPresAll(), FALSE, pDoc->GetPresPage() );

	JumpToPage( aAnimPageList.GetNextPageNum() );
	
	return 0L;
}

void FuSlideShow::SetPresChange( PresChange eChange, UINT32 nNewTime /* = 0 */ )
{
	int nPageCnt = pDoc->GetSdPageCount(PK_STANDARD);

	for ( int i = 0; i < nPageCnt; i++)
	{
		SdPage* pPage = pDoc->GetSdPage(i, PK_STANDARD);

		if (pPage)
		{
			pPage->SetPresChange( eChange );
			if( nNewTime > 0 )
				pPage->SetTime( nNewTime );
		}
	}
}

/*************************************************************************
|*
|* die Show beenden, dabei wird die gesamte Funktion beendet
|*
\************************************************************************/

void FuSlideShow::StopShow()
{
	// falls Objekte fuer die Show geaendert wurden,
	// diese Aenderungen jetzt wieder rueckgaengig machen
	for( SdChangedObj* pChg = (SdChangedObj*) aChangedList.First(); pChg; pChg = (SdChangedObj*) aChangedList.Next() )
	{
		if( pChg->pObject && !pChg->bDeleted )
		{
			pChg->pObject->RemoveListener( *pChg );

			if( pChg->bPosChanged )
				pChg->pObject->NbcMove( Size( -pChg->aMove.Width(), -pChg->aMove.Height() ) );

/* PathObject wieder sichtbar machen
			if( pChg->bLayerChanged )
				pChg->pObject->NbcSetLayer( pChg->nLayer );
*/
		}

		delete pChg;
	}
	aChangedList.Clear();				 

	// waehrend des Beendens koennen keine Ereignisse bearbeitet werden
	nIgnoreInputSmph++;

	// Raster ggf. einschalten
	pView->SetGridVisible(bGridVisible);

	if (bMouseAsPen)
		pShowWindow->SetPointer( aOldPointer );

	pShowWindow->ShowPointer( TRUE );

	pView->UnmarkAll();
	aTimer.Stop();
	DeleteClientList();

    // damit Resize()-Aufrufe ab jetzt kein zeitintensives PrepareForPage() rufen
    pActualPage = NULL;

	// Sound nicht mehr blockieren, damit er auf dem Diatisch gespielt
	// werden kann
	if( pSound )
	{
		pSound->Stop();
		pSound->SetSoundName( String() );
	}

	// der DrawView das Praesentationfenster wegnehmen und ihr dafuer ihre alten Fenster wiedergeben
	pView->DelWin( pShowWindow );


#ifndef DEBUG
    if( bFullScreen )
    {
	    pWorkWindow->StartPresentationMode( FALSE, bAlwaysOnTop ? PRESENTATION_HIDEALLAPPS : 0 );
    }
	else
#endif
	{
		pWorkWindow->Hide();

	}

    if( eAnimationMode == ANIMATIONMODE_SHOW )
    {
        // die Funktion asynchron beenden (nicht in der Bearbeitung des MouseButtonUp-Events)
		if( nCancelThisEvt == 0 )
			nCancelThisEvt = Application::PostUserEvent( STATIC_LINK( this,FuSlideShow, CancelThis ), pViewShell );

		// falls diese Show nicht als Preview laeuft, muessen die
		// Sichtbarkeitsstati aller Animationsobjekte der aktuellen Seite
		// auf 'sichtbar' gesetzt werden
		SdPage*	pPage = pViewShell->GetActualPage();
        SdrObjListIter	aMasterIter( *pPage->GetMasterPage( 0 ), IM_FLAT );
        SdrObjListIter	aIter( *pPage, IM_FLAT );

		for( SdrObject* pMasterO = aMasterIter.Next(); pMasterO; pMasterO = aMasterIter.Next() )
		{
            SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pMasterO );
            if( pInfo )
                pInfo->bShow = pInfo->bIsShown = TRUE;
		}

		for( SdrObject* pO = aIter.Next(); pO; pO = aIter.Next() )
		{
            SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pO );
            if( pInfo )
                pInfo->bShow = pInfo->bIsShown = TRUE;
		}
    }
}

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

BOOL FuSlideShow::MouseButtonDown(const MouseEvent& rMEvt)
{
	BOOL bResult = FALSE;

	nMouseClickSema++;

	if( !bReadyForNextInput )
		bResult = TRUE;
	else if (!IsInputLocked() && pActualPage && ( ANIMATIONMODE_SHOW == eAnimationMode ) )
	{
		BOOL bDone = FALSE;

		LockDrawViewShell();

		// Position umrechnen vom ShowWindow auf Seitenkoordinaten und merken
		Point aPos = pShowWindow->PixelToLogic(rMEvt.GetPosPixel());
		aDownPos = aPos;

		if( ( pActualPage->GetPresChange() == PRESCHANGE_MANUAL ) || bManual )
		{
			SdrObject* pObj = NULL;

			SdrPageView* pDummy  = NULL;
            pView->PickObj(aPos, pObj, pDummy, SDRSEARCH_PICKMACRO);
		}

		if (!bDone)
		{
			if (bMouseAsPen && rMEvt.IsLeft() && ( 1 == nMouseClickSema ) )
			{
				bMouseIsDrawing = TRUE;
				pShowWindow->SetLineColor( aPenColor );
				aLastPos = aPos;
			}

			bResult = bDone = TRUE;
		}

		UnlockDrawViewShell( FALSE );
	}

	return bResult;
}

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

BOOL FuSlideShow::MouseMove(const MouseEvent& rMEvt)
{
	BOOL bResult = FALSE;

	if( !bReadyForNextInput )
		bResult = TRUE;
	else if (!IsInputLocked() && pActualPage && ( ANIMATIONMODE_SHOW == eAnimationMode ) )
	{

		Point	aPos = pShowWindow->PixelToLogic(rMEvt.GetPosPixel());
		BOOL	bDone = FALSE;

		LockDrawViewShell();

		if ( ( pActualPage->GetPresChange() == PRESCHANGE_MANUAL ) || bManual )
		{
			SdrObject* pObj = NULL;

			// MacroObjekt getroffen? (Interessiert
			// uns aber nur, wenn die Maus nicht gerade malt)
			if (!bMouseIsDrawing)
			{
				SdrPageView* pDummy  = NULL;
                pView->PickObj(aPos, pObj, pDummy, SDRSEARCH_PICKMACRO);
			}
		}

		if (!bDone)
		{
			if (rMEvt.GetButtons() == MOUSE_LEFT && bMouseIsDrawing &&
				aLastPos.X() != LONG_MAX && aLastPos.Y() != LONG_MAX)
			{
				pShowWindow->DrawLine(aLastPos, aPos);
				aLastPos = aPos;
			}

			bResult = bDone = TRUE;
		}

		// Mauszeiger umschalten, wenn er ueber einem Objekt mit ClickAction
		// oder einem Control steht
		if (bMouseVisible)
		{
			BOOL bHand = FALSE;

			// Objekt mit ClickAction?
			SdrObject* pObject = OverObject(aPos);
			if (pObject && HasAction(pObject) ||
				pObject && pDoc->GetHitIMapObject(pObject, aPos, *pShowWindow))
			{
				bHand = TRUE;
			}
			else
			{
				//	MacroObjekt getroffen?
				SdrPageView* pDummy = NULL;
                pView->PickObj(aPos, pObject, pDummy, SDRSEARCH_PICKMACRO);

                if (pObject)
					bHand = TRUE;
			}

			Pointer aPtr;

			if (bHand)
				aPtr = Pointer( POINTER_REFHAND );
			else if ( bMouseAsPen )
				aPtr = aPencil;
			else
				aPtr = Pointer( POINTER_ARROW );

			if (pShowWindow->GetPointer() != aPtr)
				pShowWindow->SetPointer(aPtr);
		}

		UnlockDrawViewShell( FALSE );
	}
	return bResult;
}

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

BOOL FuSlideShow::MouseButtonUp(const MouseEvent& rMEvt)
{
	BOOL				bResult = FALSE;

	if( nMouseClickSema )
		nMouseClickSema--;

	if( !bReadyForNextInput )
		bResult = TRUE;
	else if (!IsInputLocked() && pActualPage && ( ANIMATIONMODE_SHOW == eAnimationMode ) )
	{
		Point	aPos( pShowWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
		BOOL	bDone = FALSE;
		BOOL	bTryToPrepare = FALSE;	// Seitenvorbereitung versuchen

		LockDrawViewShell();

		// Maus im Zeichenmodus?
		if( !nMouseClickSema && bMouseIsDrawing )
		{
			bMouseIsDrawing = FALSE;

			if( aPos != aDownPos )
				bResult = bDone = TRUE;
		}

		if(!nMouseClickSema && bMouseIsDrawing )
		{
			bMouseIsDrawing = FALSE;
			bResult = bDone = TRUE;
		}

		// Control getroffen?
		if ( !bDone && ( ( pActualPage->GetPresChange() == PRESCHANGE_MANUAL ) || bManual ) )
		{
			SdrObject* pObj = NULL;

			//	MacroObjekt getroffen?
			SdrPageView* pDummy = NULL;
            pView->PickObj(aPos, pObj, pDummy, SDRSEARCH_PICKMACRO);
		}


		/****************************************************************
		|* Objekt mit ImageMap getroffen?
		\***************************************************************/
		SdrObject* pHitObject = OverObject(aPos);
		if (pHitObject)
		{
			IMapObject* pIMapObject = pDoc->GetHitIMapObject(pHitObject, aPos,
															 *pShowWindow);
			if (pIMapObject)
			{
				String aURL(pIMapObject->GetURL());

				// nur Spruenge zu Seiten oder Objekten ausfuehren
				BOOL        bMasterPage;
                USHORT	    nPgNum = pDoc->GetPageByName(aURL, bMasterPage);
				SdrObject*  pObj   = NULL;
				if (nPgNum == SDRPAGE_NOTFOUND)
				{
					// Ist das Bookmark ein Objekt?
					pObj = pDoc->GetObj(aURL);
					if (pObj)
						nPgNum = pObj->GetPage()->GetPageNum();
				}

				if (nPgNum != SDRPAGE_NOTFOUND)
				{
					// convert to SdPageNum
					USHORT nSdPgNum = (nPgNum - 1)/2;

					JumpToPage( nSdPgNum );
					bResult = bDone = TRUE;
				}
			}
		}


		/****************************************************************
		|* Objektaktion ausfuehren?
		\***************************************************************/
		SdrObject* pActionObject = OverObject(aPos);

		if (!bDone && aPos == aDownPos && pActionObject && HasAction(pActionObject))
		{
			bDone = TRUE;

			// rechter Mausklick auf Objekt mit Aktion wird "verschluckt",
			// sonst wechselt womoeglich das Dia
			if (rMEvt.IsLeft())
				bResult = PerformAction(pActionObject);
			else
				bResult = FALSE;

			bTryToPrepare = TRUE;
		}

		/****************************************************************
		|* OLE-Objekt getroffen?
		\***************************************************************/
		if (!bDone &&
			aPos == aDownPos && rMEvt.IsLeft() &&
			( ( pActualPage->GetPresChange() == PRESCHANGE_MANUAL ) || bManual ) )
		{
			SdrObject* pObject = NULL;

			// Position umrechnen vom ShowWindow auf Seitenkoordinaten
			Point aPosOnPage = aPos - aPageOrigin;

            SdrPageView* pDummy = NULL;
            pView->PickObj(aPosOnPage, pObject, pDummy);

			// OLE-Objekt getroffen?
            if (pObject && pObject->GetObjInventor() == SdrInventor &&
                           pObject->GetObjIdentifier() == OBJ_OLE2)
			{
				if( DoVerb(pObject, 0) )
					bResult = bDone = TRUE;
			}
		}

		/****************************************************************
		|* Objekt abblenden?
		\***************************************************************/
		if (!bDone && pDimObject && IsAdvanceEvent(aPos, aDownPos) && rMEvt.IsLeft())
		{
			// Gliederungsabsatz
			if(pDimObject->GetObjInventor() == SdrInventor &&
			   pDimObject->GetObjIdentifier() == OBJ_OUTLINETEXT)
			{
				DimLayoutParagraph();
				nDimPos = nParaPos;
			}
			else
				Dim((SdrAttrObj*)pDimObject, aDimRect.TopLeft(), aDimColor);

			// Ist das Objekt durch die Abblendung fuer die Darstellung zu
			// langsam geworden? Wenn ja, dann eine Ersatzdarstellung erzeugen.
			if( IsSlowObj( (SdrAttrObj*) pDimObject ) )
			{
				SdSlowObjRecord* pRec = GetSlowObjRecord((SdrAttrObj*)pDimObject);
				
				if( pRec )
				{
					pSlowObjList->Remove( (void*) pRec );
					delete pRec;
				}
				
				// falls das Objekt bis jetzt kein SlowObj war: Start- und Endlabel im Metafile aktualisieren
				if( CreateSlowObjRecord( (SdrAttrObj*) pDimObject ) && !pRec )
				{
					pMetaFile->ReplaceMarker( OBJ_START( pDimObject, FALSE ), OBJ_START( pDimObject, TRUE ) );
					pMetaFile->ReplaceMarker( OBJ_END( pDimObject, FALSE ), OBJ_END( pDimObject, TRUE ) );
				}
			}
			pDimObject = NULL;
			bResult = bDone = bTryToPrepare = TRUE;
		}

		/****************************************************************
		|* Objekt verstecken?
		\***************************************************************/
		if( !bDone && pHideObject && IsAdvanceEvent(aPos, aDownPos) && rMEvt.IsLeft() )
		{
			HideOrVanishObject( pHideObject, TRUE );
			pHideObject = NULL;
			bResult = bDone = bTryToPrepare = TRUE;
		}

		/****************************************************************
		|* Objektanimation?
		\***************************************************************/
		if( !bDone && IsAdvanceEvent( aPos, aDownPos ) && rMEvt.IsLeft() && pCurAnmList->Count() > 0 )
		{
			SdrObject* pObject = (SdrObject*) pCurAnmList->First();
			SdAnimationInfo* pInfo = pDoc->GetAnimationInfo(pObject);

			// Object verstecken ueber Effekt?
			if( presentation::AnimationEffect_HIDE == pInfo->eEffect )
				HideOrVanishObject( pObject, TRUE );
			else
			{
				// ansonsten einblenden ueber Effekt
				pInfo->bShow = TRUE;
				AnimateObject();
				pInfo->bIsShown = TRUE;

				if( AffectsOwnPage( pObject ) )
					nVisibleAffectingObjects++;
			}

			bResult = bDone = bTryToPrepare = TRUE;
		}

		/****************************************************************
		|* Diawechsel?
		\***************************************************************/
		if( !bDone && IsAdvanceEvent( aPos, aDownPos ) && !bLockedPages )
		{
			JumpToPage( aAnimPageList.CalcNextPageNum( !rMEvt.IsRight() ) );
			bResult = bDone = TRUE;
		}

		/****************************************************************
		|* Falls noch nicht geschehen und alle Animationen gelaufen sind:
		|* die vermutlich naechste Seite im virtuellen Device vorbereiten
		\***************************************************************/

		if( bTryToPrepare && bVDevEmpty && !pCurAnmList->Count() &&
			!pDimObject && !pHideObject && !nVisibleAffectingObjects )
		{
			// remember the time we finished with animations
			nFadeInTime = Time::GetSystemTicks();

			const USHORT nNextPage = aAnimPageList.CalcNextPageNum( TRUE );

			if( nNextPage != aAnimPageList.GetCurrentPageNum() )
			{
				pShowView->HideAllPages();
				PrepareForPage( pDoc->GetSdPage( nNextPage, PK_STANDARD ), TRUE );
				bVDevEmpty = FALSE;
			}
		}

		UnlockDrawViewShell( FALSE );
	}
	
	return bResult;
}

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/


BOOL FuSlideShow::KeyInput(const KeyEvent& rKEvt)
{
	BOOL				bReturn = FALSE;

	if( !bReadyForNextInput )
		bReturn = TRUE;
	else if( !IsInputLocked() && pActualPage )
	{
		// ggfs. an aktuelle Funktion weiterleiten
		USHORT nPage = 0;
		USHORT nPageCount = pDoc->GetSdPageCount(PK_STANDARD);
		BOOL   bTrySlideChange = FALSE;

		LockDrawViewShell();

		switch( rKEvt.GetKeyCode().GetCode() )
		{
			// Show abbrechen
			case KEY_ESCAPE:
			{
				bReturn = TRUE;
				JumpToPage( PAGE_NO_END );
			}
			break;

			// Leertaste: naechste Objektanimation bzw. Diawechsel
			case KEY_SPACE:
			{
				bReturn = TRUE;

				// abblenden?
				if (pDimObject)
				{
					// Gliederungsabsatz
					if(pDimObject->GetObjInventor() == SdrInventor &&
					   pDimObject->GetObjIdentifier() == OBJ_OUTLINETEXT)
					{
						DimLayoutParagraph();
						nDimPos = nParaPos;
					}
					else
						Dim((SdrAttrObj*)pDimObject, aDimRect.TopLeft(), aDimColor);

					// Ist das Objekt durch die Abblendung fuer die Darstellung
					// zu langsam geworden? Wenn ja, dann eine
					// Ersatzdarstellung erzeugen.
					if( IsSlowObj( (SdrAttrObj*) pDimObject ) )
					{
						SdSlowObjRecord* pRec = GetSlowObjRecord( (SdrAttrObj*) pDimObject );
						
						if( pRec )
						{
                            pSlowObjList->Remove((void*)pRec);
							delete pRec;
						}
						
						// falls das Objekt bis jetzt kein SlowObj war, Start- und Endlabel im Metafile aktualisieren
						if( CreateSlowObjRecord( (SdrAttrObj*) pDimObject ) && !pRec )
						{
							pMetaFile->ReplaceMarker( OBJ_START( pDimObject, FALSE ), OBJ_START( pDimObject, TRUE ) );
							pMetaFile->ReplaceMarker( OBJ_END( pDimObject, FALSE ), OBJ_END( pDimObject, TRUE ) );
						}
					}

					pDimObject = NULL;
				}
				else if( pHideObject )
				{
					HideOrVanishObject( pHideObject, TRUE );
					pHideObject = NULL;
				}
				else if (pCurAnmList->Count() > 0)
				{
					// gibt's was zu animieren?
					SdrObject* pObject = (SdrObject*)pCurAnmList->First();
					SdAnimationInfo* pInfo = pDoc->GetAnimationInfo(pObject);

					// Object verstecken ueber Effekt?
					if( presentation::AnimationEffect_HIDE == pInfo->eEffect )
						HideOrVanishObject( pObject, TRUE );
					else
					{
						// ansonsten einblenden ueber Effekt
						pInfo->bShow = TRUE;
						AnimateObject();
						pInfo->bIsShown = TRUE;
					}
				}
				else
				{
					// Diawechsel
					nPage = aAnimPageList.CalcNextPageNum( TRUE );
					bTrySlideChange = TRUE;
				}
			}
			break;

			// Puffer auswerten
			case KEY_RETURN:
			{
				USHORT nPageCount = pDoc->GetSdPageCount( PK_STANDARD );

				bReturn = TRUE;

				// check for numeric
				sal_Bool bNumeric;
				const sal_Int32 nStrLen = aCharBuffer.Len();
				if( nStrLen == 0 || nStrLen > 4 )
				{
					bNumeric = sal_False;
				}
				else
				{
					for( sal_Int32 nIndex = 0; nIndex < nStrLen; nIndex++ )
					{
						if( aCharBuffer.GetChar(nIndex) < sal_Unicode('0') ||
							aCharBuffer.GetChar(nIndex) > sal_Unicode('9') )
						{
							bNumeric = sal_False;
							break;
						}
					}
				}

				if( bNumeric )
					nPage = (USHORT)aCharBuffer.ToInt32() - 1;

				// if its not a valig page, just skip to the next page
				if( !bNumeric || !aAnimPageList.IsPageNumIncluded( nPage ) )
					nPage = aAnimPageList.CalcNextPageNum( TRUE );

				aCharBuffer.Erase();
				bTrySlideChange = TRUE;
			}
			break;

			// Ziffer: in den Puffer schreiben
			case KEY_0:
			case KEY_1:
			case KEY_2:
			case KEY_3:
			case KEY_4:
			case KEY_5:
			case KEY_6:
			case KEY_7:
			case KEY_8:
			case KEY_9:
			{
				bReturn 	 = TRUE;
				aCharBuffer += rKEvt.GetCharCode();
			}
			break;

			case KEY_PAGEUP:
			case KEY_LEFT:
			{
				bReturn = TRUE;
				nPage = aAnimPageList.CalcNextPageNum( FALSE );
				bTrySlideChange = TRUE;
			}
			break;

			case KEY_PAGEDOWN:
			case KEY_RIGHT:
			{
				bReturn = TRUE;
				nPage = aAnimPageList.CalcNextPageNum( TRUE );
				bTrySlideChange = TRUE;
			}
			break;

			case KEY_HOME:
			{
				bReturn = TRUE;
				nPage = aAnimPageList.GetFirstPageNum();
				bTrySlideChange = TRUE;
			}
			break;

			case KEY_END:
			{
				bReturn = TRUE;
				nPage = aAnimPageList.GetLastPageNum();
				bTrySlideChange = TRUE;
			}
			break;

			default:
			break;
		}

		if( bTrySlideChange )
			JumpToPage( nPage );

		UnlockDrawViewShell( FALSE );
	}
	else if ( rKEvt.GetKeyCode().GetCode() == KEY_ESCAPE )
		aEscapeTimer.Start();

	return bReturn;
}

/*************************************************************************
|*
|* Funktion aktivieren
|*
\************************************************************************/

void FuSlideShow::Activate()
{
    // wenn es kein ShowWindow gibt, wurde im Dialog 'Abbrechen' gewaehlt;
    // dann brauchen wir hier nichts tun
    if( pShowWindow && eAnimationMode == ANIMATIONMODE_SHOW )
        pShowWindow->GrabFocus();
}

/*************************************************************************
|*
|* Funktion deaktivieren
|*
\************************************************************************/

void FuSlideShow::Deactivate()
{
}

/*************************************************************************
|*
|* Diese Funktion beenden. Dies darf nicht innerhalb des MouseButtonUp-
|* Handlers geschehen, da SV sonst Flags am nicht mehr vorhandenen Fenster
|* setzen will.
|*
\************************************************************************/

IMPL_STATIC_LINK( FuSlideShow, CancelThis, void*, pViewShell )
{
/*
	( (SdDrawViewShell*) pViewShell )->GetViewFrame()->
		GetDispatcher()->Execute( SID_PRESENTATION_END,
								  SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_RECORD );
*/
	( (SipViewShell*) pViewShell)->StopSlideShow();
	return 0L;
}


/*************************************************************************
|*
|* Paint-Event
|*
\************************************************************************/

void FuSlideShow::Paint(const Rectangle& rRect, Window* pWin)
{
}


/*************************************************************************
|*
|* zu einer bestimmten Seite springen
|*
\************************************************************************/

void FuSlideShow::JumpToPage( USHORT nNewPage )
{
	aTimer.Stop();

	if( nNewPage != aAnimPageList.GetCurrentPageNum() )
	{
		if( !aAnimPageList.IsPageNumIncluded( nNewPage ) && ( nNewPage < PAGE_NO_FIRSTDEF ) )
			nNewPage = aAnimPageList.GetLastPageNum();
	}
	else
		bVDevEmpty = TRUE;

	aAnimPageList.MakePageNumCurrent( nNewPage );
	DoPageFade();

}

/*************************************************************************
|*
|* Time Out Handler fuer automatische Objektanimation
|*
\************************************************************************/

IMPL_LINK( FuSlideShow, ObjectTimeOutHdl, Timer *, pTimer )
{
	if( nMagic != SLIDESHOW_MAGIC )
		return 0L;

	bReadyForNextInput = TRUE;
	aTimer.Stop();

	if( bPause && pTimer )
	{
		pTimer->SetTimeout(50);
		pTimer->Start();
		return 0;
	}

	if( bNativeMode )
	{
		// gibt's noch was zu animieren oder abzublenden?
		// dann noch einen Event schicken
		if( pCurAnmList->Count() > 0 || pDimObject || pHideObject )
		{
			// wir schicken uns zwei Event
			static Point aDefPoint;
			MouseEvent aMEvt(aDefPoint, 1, 0, MOUSE_LEFT, 0);
			MouseButtonDown(aMEvt);
			MouseButtonUp(aMEvt);

			// und dann nochmal versuchen
			aTimer.SetTimeout(50);		 // 50 Millisekunden
			aTimer.SetTimeoutHdl(LINK(this,FuSlideShow, ObjectTimeOutHdl));
			aTimer.Start();
		}
		else if( pActualPage->GetPresChange() == PRESCHANGE_AUTO )
		{
			ULONG nPrepareTime = Time::GetSystemTicks() - nFadeInTime;
			ULONG nTime = pActualPage->GetTime() * 1000;
			if( nTime <= nPrepareTime )
					nTime = 100;
			else
					nTime -= nPrepareTime;

			aTimer.SetTimeout( nTime );
			aTimer.SetTimeoutHdl( LINK( this,FuSlideShow, PageTimeOutHdl ) );
			aTimer.Start();
		}
	}

	return 0L;
}

// -----------------------------------------------------------------------------

IMPL_LINK( FuSlideShow, ReadyForNextInputHdl, void*, p )
{
   	aTimer.Stop();
	bReadyForNextInput = TRUE;

	return 0L;
}

/*************************************************************************
|*
|* IsAdvanceEvent: stellt fest, ob die Orte von MouseButtonDown und -Up
|*				   nahe genug beieinander liegen, um in der Show weiterzumachen
|*
\************************************************************************/

BOOL FuSlideShow::IsAdvanceEvent(const Point& rDown, const Point& rUp) const
{
	const Point aDown( pShowWindow->LogicToPixel(rDown) );
	const Point aUp( pShowWindow->LogicToPixel(rUp) );
	BOOL		bResult;

	// wenn die Maus malen darf, muss auf dem gleichen Pixel geklickt werden
	// (sonst wird ja gemalt)
	if (bMouseAsPen)
		bResult = aDown == aUp;

	// wenn nicht, goennen wir unseren aelteren Usern einen Tatterkreis
	else
	{
		long nXQuad = aDown.X() - aUp.X();
		nXQuad *= nXQuad;
		long nYQuad = aDown.Y() - aUp.Y();
		nYQuad *= nYQuad;
		bResult = (nXQuad + nYQuad) < QUAD_ADVANCEEVENT_TOLERANCE;
	}
	return bResult;
}

/*************************************************************************
|*
|* Verb eines OLE-Objektes ausfuehren
|*
\************************************************************************/

BOOL FuSlideShow::DoVerb(SdrObject* pObject, USHORT nVerb)
{
//	DBG_ERROR("DoVerb funktioniert noch nicht");
	return FALSE;
/*
	DBG_ASSERT( pObject, "kein Objekt");

	// koennte ja auch ein Metafile sein
	SdrOle2Obj* pOleObject = PTR_CAST(SdrOle2Obj, pObject);
	BOOL		bRet = FALSE;

	if (pOleObject)
	{
		pViewShell->ActivateObject(pOleObject, nVerb);
		bRet = TRUE;
		return bRet;
	}

	return bRet;
*/
}

/*************************************************************************
|*
|* Command-event
|*
\************************************************************************/

BOOL FuSlideShow::Command(const CommandEvent& rCEvt)
{
	return FALSE;
}

/*************************************************************************
|*
|* Help-event
|*
\************************************************************************/

BOOL FuSlideShow::RequestHelp(const HelpEvent& rHEvt)
{
	return FALSE;
}


/*************************************************************************
|*
|* Request verarbeiten
|*
\************************************************************************/

void FuSlideShow::ReceiveRequest(SfxRequest& rReq)
{
}

void FuSlideShow::SetMouseVisible( BOOL bVisible /* = TRUE */ )
{
	bMouseVisible = bVisible;
	pShowWindow->ShowPointer(bVisible);
 }

void FuSlideShow::SetMouseAsPen( BOOL bAsPen /* = TRUE */ )
{
	if( bAsPen != bMouseAsPen )
	{
		if( !bMouseAsPen )
		{
			aOldPointer = pShowWindow->GetPointer();
			pShowWindow->SetPointer( aPencil );
		}
		else
		{
			pShowWindow->SetPointer( aOldPointer );
		}
		bMouseAsPen = bAsPen;
		bMouseIsDrawing = FALSE;
	}
}

void FuSlideShow::Pause()
{
	DBG_ASSERT( !IsInputLocked(), "pause while in effect!" );
	DBG_ASSERT( !bPause, "paused twice?" );
	bPause = TRUE;

	if( pShowWindow )
		pShowWindow->Push();
}

void FuSlideShow::Restart()
{
	DBG_ASSERT( bPause, "restart without pause?" );
	bPause = FALSE;

	if( pShowWindow )
		pShowWindow->Pop();
}

