/*************************************************************************
 *
 *  $RCSfile: options.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: thb $ $Date: 2001/05/29 14:48:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIP_OPTIONS_
#define _SIP_OPTIONS_

#ifndef _SV_WINTYPES_HXX		// autogen because of TriState
#include <vcl/wintypes.hxx>
#endif
#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif

using namespace rtl;
using namespace utl;
using namespace com::sun::star::uno;

class Options : public ConfigItem
{
	OUString	m_aPresFile;	
	UINT32		m_nPresChange;
	UINT32		m_nPageTimeout;
	
	TriState	m_eEndless;
	UINT32		m_nPauseTimeout;
	TriState	m_eShowPauseLogo;

	TriState	m_eMouseVisible;
	TriState	m_eMouseAsPen;
	TriState	m_eAnimationAllowed;
	TriState	m_eLockedPages;
	TriState	m_eAlwaysOnTop;
	TriState	m_eFullScreen;

	const BOOL	m_bPersistent;
	BOOL		m_bModified;

	// disable copy and assignment	
	Options( const Options& );
	Options& operator = ( const Options & );

protected:
	BOOL			IsModified() const { return m_bModified; }
	void			SetModified( BOOL bVal );
	BOOL			Load();
	BOOL			Save();

	Sequence< OUString >	GetPropertyNames() const;

public:
	Options(BOOL bPersistent=TRUE);
	virtual ~Options();

	// ConfigItem
	virtual void	Commit();

	const OUString&	GetPresFile() const { return m_aPresFile; }
	void			SetPresFile(const OUString& aPresFile) { if( m_aPresFile != aPresFile ) SetModified( TRUE ); m_aPresFile = aPresFile; }
	UINT32		GetPresChange() const { return m_nPresChange; }
	void		SetPresChange(UINT32 nPresChange) { 	if( m_nPresChange != nPresChange ) SetModified( TRUE );	m_nPresChange = nPresChange; }
	UINT32		GetPageTimeout() const { return m_nPageTimeout; }
	void		SetPageTimeout(UINT32 nPageTimeout) { if( m_nPageTimeout != nPageTimeout ) SetModified( TRUE ); m_nPageTimeout = nPageTimeout; }
	TriState	GetEndless() const { return m_eEndless; }
	void		SetEndless(TriState eEndless) { if( m_eEndless != eEndless ) SetModified( TRUE ); m_eEndless = eEndless; }
	UINT32		GetPauseTimeout() const { return m_nPauseTimeout; }
	void		SetPauseTimeout(UINT32 nPauseTimeout) { if( m_nPauseTimeout != nPauseTimeout ) SetModified( TRUE ); m_nPauseTimeout = nPauseTimeout; }
	TriState	GetShowPauseLogo() const { return m_eShowPauseLogo; }
	void		SetShowPauseLogo(TriState eShowPauseLogo) { if( m_eShowPauseLogo != eShowPauseLogo ) SetModified( TRUE ); m_eShowPauseLogo = eShowPauseLogo; }
	TriState	GetMouseVisible() const { return m_eMouseVisible; }
	void		SetMouseVisible(TriState eMouseVisible) { if( m_eMouseVisible != eMouseVisible ) SetModified( TRUE ); m_eMouseVisible = eMouseVisible; }
	TriState	GetMouseAsPen() const { return m_eMouseAsPen; }
	void		SetMouseAsPen(TriState eMouseAsPen) { if( m_eMouseAsPen != eMouseAsPen ) SetModified( TRUE ); m_eMouseAsPen = eMouseAsPen; }
	TriState	GetAnimationAllowed() const { return m_eAnimationAllowed; }
	void		SetAnimationAllowed(TriState eAnimationAllowed) { if( m_eAnimationAllowed != eAnimationAllowed ) SetModified( TRUE ); m_eAnimationAllowed = eAnimationAllowed; }
	TriState	GetLockedPages() const { return m_eLockedPages; }
	void		SetLockedPages(TriState eLockedPages) { if( m_eLockedPages != eLockedPages ) SetModified( TRUE ); m_eLockedPages = eLockedPages; }
	TriState	GetAlwaysOnTop() const { return m_eAlwaysOnTop; }
	void		SetAlwaysOnTop(TriState eAlwaysOnTop) { if( m_eAlwaysOnTop != eAlwaysOnTop ) SetModified( TRUE ); m_eAlwaysOnTop = eAlwaysOnTop; }
	TriState	GetFullScreen() const { return m_eFullScreen; }
	void		SetFullScreen(TriState eFullScreen) { if( m_eFullScreen != eFullScreen ) SetModified( TRUE ); m_eFullScreen = eFullScreen; }

};

#endif // _SIP_OPTIONS_

