#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.8 $
#
#   last change: $Author: sb $ $Date: 2001/07/27 13:51:19 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ = ..$/..$/..
PRJINC = ..$/..
PRJNAME = ucb
TARGET = ucprmt
TARGET_VERSION = 1
ENABLE_EXCEPTIONS = true
NO_BSYMBOLIC = true
USE_DEFFILE = true

.INCLUDE: settings.mk

SLOFILES = \
    $(SLO)$/rapcommandenvironment.obj \
    $(SLO)$/rapproxyprovider.obj \
    $(SLO)$/rmtconn.obj \
    $(SLO)$/rmtcont.obj \
    $(SLO)$/rmtimap.obj \
    $(SLO)$/rmtlid.obj \
    $(SLO)$/rmtpacc.obj \
    $(SLO)$/rmtpclst.obj \
    $(SLO)$/rmtprov.obj \
    $(SLO)$/rmtserv.obj \
    $(SLO)$/rmtuuid.obj

LIB1TARGET = $(SLB)$/_$(TARGET).lib
LIB1OBJFILES = $(SLOFILES)

SHL1TARGET = $(TARGET)$(TARGET_VERSION)
SHL1DEF = $(MISC)$/$(SHL1TARGET).def
SHL1LIBS = \
    $(LIB1TARGET) \
    $(SLB)$/regexp.lib
SHL1STDLIBS = \
    $(CPPUHELPERLIB) \
    $(CPPULIB) \
    $(SALLIB) \
    $(SALHELPERLIB) \
    $(UCBHELPERLIB) \
    $(VOSLIB)
SHL1DEPN = \
    $(L)$/icppuhelper.lib \
    $(L)$/icppu.lib \
    $(L)$/isal.lib \
    $(L)$/isalhelper.lib \
    $(L)$/iucbhelper.lib \
    $(L)$/ivos.lib

DEF1NAME = $(SHL1TARGET)
DEF1DES = Remote Access UCP
DEF1EXPORTFILE = exports.dxp

# Make symbol renaming match library name for Mac OS X:
.IF "$(OS)" == "MACOSX"
SYMBOLPREFIX = $(TARGET)$(TARGET_VERSION)
.ENDIF # OS, MACOSX

.IF "$(UCB_RAP_OFFLINE)" != ""

ENVCFLAGS += -DUCB_RAP_OFFLINE

UNOUCRRDB = \
    $(PRJ)$/..$/drafts$/$(ROUT)$/ucr$/csssync.db \
    $(SOLARBINDIR)$/applicat.rdb
UNOUCRDEP = $(UNOUCRRDB)
UNOUCROUT = $(OUT)$/inc
UNOTYPES = \
    com.sun.star.sync.SynchronizeCommandArgument \
    com.sun.star.sync.XDBAdapter \
    com.sun.star.sync.XPersistentStorageFactory \
    com.sun.star.sync.XSyncAdapter

SLOFILES += \
    $(SLO)$/rapofflinecommandinfo.obj \
    $(SLO)$/rapofflinecommandmap.obj \
    $(SLO)$/rapofflinecommandprocessor.obj \
    $(SLO)$/rapofflinecontent.obj \
    $(SLO)$/rapofflinecontenttypedata.obj \
    $(SLO)$/rapofflinedbadapter.obj \
    $(SLO)$/rapofflinedynamicresultset.obj \
    $(SLO)$/rapofflinefilestream.obj \
    $(SLO)$/rapofflineinteractionrequest.obj \
    $(SLO)$/rapofflinepersistentstoragefactory.obj \
    $(SLO)$/rapofflinepropertyvalueset.obj \
    $(SLO)$/rapofflineprovider.obj \
    $(SLO)$/rapofflineresultsetdatasupplier.obj \
    $(SLO)$/rapofflinestorage.obj \
    $(SLO)$/rapofflinestoragedatastream.obj \
    $(SLO)$/rapofflinestorageimpl.obj \
    $(SLO)$/rapofflinestoragenode.obj \
    $(SLO)$/rapofflinestoragestream.obj

SHL1STDLIBS += $(STORELIB)
SHL1DEPN += $(L)$/istore.lib

.ENDIF # UCB_RAP_OFFLINE

.INCLUDE: target.mk
