/*************************************************************************
 *
 *  $RCSfile: wrkwin.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: ssa $ $Date: 2001/07/31 08:17:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_WRKWIN_HXX
#define _SV_WRKWIN_HXX

#ifndef _SV_SV_H
#include <sv.h>
#endif
#ifndef _SV_SYSWIN_HXX
#include <syswin.hxx>
#endif

namespace com { namespace sun { namespace star { namespace uno { class Any; }}}}
struct SystemParentData;

// ----------------------
// - WorkWindow - Types -
// ----------------------

// Presentation Flags
#define PRESENTATION_HIDEALLAPPS	((USHORT)0x0001)
#define PRESENTATION_NOFULLSCREEN	((USHORT)0x0002)
#define PRESENTATION_NOAUTOSHOW 	((USHORT)0x0004)
#ifndef NOOLDSV
#define PRESENTATION_NOTFULLSCREEN	PRESENTATION_NOFULLSCREEN
#define PRESENTATION_NOTAUTOSHOW	PRESENTATION_NOAUTOSHOW
#endif

// ----------------------
// - Icon - Types -
// ----------------------

#define ICON_DEFAULT                    0
#define ICON_SO_DEFAULT 				1
#define ICON_TEXT_DOCUMENT				2
#define ICON_TEXT_TEMPLATE				3
#define ICON_SPREADSHEET_DOCUMENT		4
#define ICON_SPREADSHEET_TEMPLATE		5
#define ICON_DRAWING_DOCUMENT			6
#define ICON_DRAWING_TEMPLATE			7
#define ICON_PRESENTATION_DOCUMENT		8
#define ICON_PRESENTATION_TEMPLATE		9
#define ICON_PRESENTATION_COMPRESSED	10
#define ICON_GLOBAL_DOCUMENT			11
#define ICON_HTML_DOCUMENT				12
#define ICON_CHART_DOCUMENT				13
#define ICON_DATABASE_DOCUMENT			14
#define ICON_MATH_DOCUMENT				15
#define ICON_TEMPLATE					16
#define ICON_MACROLIBRARY				17
#define ICON_PLAYER                     100
#define ICON_SETUP						500

// --------------
// - WorkWindow -
// --------------

class WorkWindow : public SystemWindow
{
private:
	USHORT			mnIcon;
	USHORT			mnPresentationFlags;
	BOOL			mbPresentationMode:1,
					mbPresentationVisible:1,
					mbPresentationFull:1,
					mbFullScreenMode:1,
					mbSysChild:1,
					mbDummy1:1,
					mbDummy2:1,
					mbDummy3:1,
					mbDummy4:1,
					mbDummy5:1,
					mbDummy6:1,
					mbDummy7:1;

#ifdef _SV_WRKWIN_CXX
	void			ImplInitData();
	void			ImplInit( Window* pParent, WinBits nStyle, const ::com::sun::star::uno::Any& aSystemWorkWindowToken );
#endif

protected:
					WorkWindow( WindowType nType );
	void			ImplInit( Window* pParent, WinBits nStyle, SystemParentData* pSystemParentData = NULL );
	void			ImplLoadRes( const ResId& rResId );

public:
					WorkWindow( Window* pParent, const ResId& rResId );
					WorkWindow( Window* pParent, WinBits nStyle = WB_STDWORK );
					WorkWindow( Window* pParent, const ::com::sun::star::uno::Any& aSystemWorkWindowToken, WinBits nStyle = WB_STDWORK );
					WorkWindow( SystemParentData* pParent ); // Not in the REMOTE-Version
					~WorkWindow();

	void			SetIcon( USHORT nIcon );
	USHORT			GetIcon() const { return mnIcon; }

	void			SetWindowState( const ByteString& rStr );
	ByteString		GetWindowState() const;

	void			ShowFullScreenMode( BOOL bFullScreenMode = TRUE );
	void			EndFullScreenMode() { ShowFullScreenMode( FALSE ); }
	BOOL			IsFullScreenMode() const { return mbFullScreenMode; }

	void			StartPresentationMode( BOOL bPresentation = TRUE, USHORT nFlags = 0 );
	void			EndPresentationMode() {  StartPresentationMode( FALSE ); }
	BOOL			IsPresentationMode() const { return mbPresentationMode; }

	BOOL			IsMinimized() const;

#ifndef NOOLDSV
	void			Minimize();
	void			Maximize();
	void			Restore();

	BOOL			IsMaximized() const;

	void			SetOptOutputSizePixel( const Size& ) {}
	Size			GetOptOutputSizePixel() const { return Size(); }
#endif
};

#endif // _SV_WRKWIN_HXX
