*** orig/dmake/dbug/malloc/mlc_chk.c	Sat Sep  9 18:36:36 2000
--- modified/dmake/dbug/malloc/mlc_chk.c	Sat Sep  9 18:36:36 2000
***************
*** 1,38 ****
  /*
   * (c) Copyright 1990 Conor P. Cahill (uunet!virtech!cpcahil).  
   * You may copy, distribute, and use this software as long as this
   * copyright statement is not removed.
   */
  
  #include <stdio.h>
  #include "malloc.h"
  #include "debug.h"
  
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: mlc_chk.c,v 1.1.1.1 1997/07/15 16:02:26 dvadura Exp $";
  #endif
  
  extern struct mlist	  malloc_start;
  extern struct mlist	* malloc_end;
  extern char		* malloc_data_start;
  extern char		* malloc_data_end;
  
  /*
   * Function:	malloc_in_arena()
   *
   * Purpose:	to verify address is within malloc arena.
   *
   * Arguments:	ptr	- pointer to verify
   *
   * Returns:	TRUE	- if pointer is within malloc area
   *		FALSE	- otherwise
   *
   * Narrative:
   *   IF pointer is >= malloc area start AND <= malloc area end
   *      return TRUE
   *   ELSE
   *      return FALSE
   *
   * Mod History:	
   *   90/01/24	cpcahil		Initial revision.
--- 1,38 ----
  /*
   * (c) Copyright 1990 Conor P. Cahill (uunet!virtech!cpcahil).  
   * You may copy, distribute, and use this software as long as this
   * copyright statement is not removed.
   */
  
  #include <stdio.h>
  #include "malloc.h"
  #include "debug.h"
  
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: mlc_chk.c,v 1.1.1.1 1997/09/22 14:51:11 hjs Exp $";
  #endif
  
  extern struct mlist	  malloc_start;
  extern struct mlist	* malloc_end;
  extern char		* malloc_data_start;
  extern char		* malloc_data_end;
  
  /*
   * Function:	malloc_in_arena()
   *
   * Purpose:	to verify address is within malloc arena.
   *
   * Arguments:	ptr	- pointer to verify
   *
   * Returns:	TRUE	- if pointer is within malloc area
   *		FALSE	- otherwise
   *
   * Narrative:
   *   IF pointer is >= malloc area start AND <= malloc area end
   *      return TRUE
   *   ELSE
   *      return FALSE
   *
   * Mod History:	
   *   90/01/24	cpcahil		Initial revision.
***************
*** 234,283 ****
--- 234,286 ----
  	
  	/*
   	 * Now we have a valid malloc block that contains the indicated
  	 * pointer.  We must verify that it is withing the requested block
  	 * size (as opposed to the real block size which is rounded up to
  	 * allow for correct alignment).
  	 */
  
  	DEBUG4(60,"Checking  0x%x-0x%x, 0x%x-0x%x",
  			ptr, ptr+len, mptr->data, mptr->data+mptr->r_size);
  	
  	if( (ptr < mptr->data) || ((ptr+len) > (mptr->data+mptr->r_size)) )
  	{
  		DEBUG4(0,"pointer not within region 0x%x-0x%x, 0x%x-0x%x",
  			ptr, ptr+len, mptr->data, mptr->data+mptr->r_size);
  
  		malloc_errno = M_CODE_OUTOF_BOUNDS;
  		malloc_warning(func);
  	}
  
  	return;
  }
  
  /*
   * $Log: mlc_chk.c,v $
+  * Revision 1.1.1.1  1997/09/22 14:51:11  hjs
+  * dmake 4.1 orginal sourcen
+  *
   * Revision 1.1.1.1  1997/07/15 16:02:26  dvadura
   * dmake gold 4.1.00 initial import
   *
   * Revision 1.1.1.1  1996/10/27 07:30:14  dvadura
   * Dmake 4.1 Initial Import
   *
   * Revision 1.1.1.1  1996/10/24 05:33:14  dvadura
   * Initial import for final release of dmake 4.1
   *
   * Revision 1.1  1994/10/06  17:43:15  dvadura
   * dmake Release Version 4.0, Initial revision
   *
   * Revision 1.1  1994/10/06  03:45:24  dvadura
   * dmake Release Version 4.0, Initial revision
   *
   * Revision 1.1  1992/01/24  03:29:09  dvadura
   * dmake Version 3.8, Initial revision
   *
   * Revision 1.5  90/08/29  22:23:48  cpcahil
   * added new function to check on strings up to a specified length 
   * and used it within several strn* functions.
   * 
   * Revision 1.4  90/05/11  00:13:09  cpcahil
   * added copyright statment
   * 
