*** orig/sql.h	Thu Sep 21 16:34:13 2000
--- modified/sql.h	Thu Sep 21 16:34:13 2000
***************
*** 1,66 ****
! /**************************************************
!  * sql.h
!  *
!  * These should be consistent with the MS version.
!  *
!  **************************************************/
! #ifndef __SQL_H
! #define __SQL_H
! 
! /****************************
!  * default to 3.51 declare something else before here and you get a whole new ball of wax
!  ***************************/
  #ifndef ODBCVER
! #define ODBCVER 0x0351
  #endif
  
  #include "sqltypes.h"
  
  #ifdef __cplusplus
! extern "C" {
! #endif
  
! /****************************
!  * some ret values
!  ***************************/
  #define SQL_NULL_DATA             (-1)
  #define SQL_DATA_AT_EXEC          (-2)
  #define SQL_SUCCESS                0
  #define SQL_SUCCESS_WITH_INFO      1
  #if (ODBCVER >= 0x0300)
  #define SQL_NO_DATA              100
  #endif
  #define SQL_ERROR                 (-1)
  #define SQL_INVALID_HANDLE        (-2)
  #define SQL_STILL_EXECUTING        2
  #define SQL_NEED_DATA             99
  #define SQL_SUCCEEDED(rc) (((rc)&(~1))==0)
  
! /****************************
!  * use these to indicate string termination to some function
!  ***************************/
  #define SQL_NTS                   (-3)
  #define SQL_NTSL                  (-3L)
  
  /* maximum message length */
  #define SQL_MAX_MESSAGE_LENGTH   512
  
  /* date/time length constants */
  #if (ODBCVER >= 0x0300)
  #define SQL_DATE_LEN           10
  #define SQL_TIME_LEN            8  /* add P+1 if precision is nonzero */
  #define SQL_TIMESTAMP_LEN      19  /* add P+1 if precision is nonzero */
  #endif
  
  /* handle type identifiers */
  #if (ODBCVER >= 0x0300)
  #define SQL_HANDLE_ENV             1
  #define SQL_HANDLE_DBC             2
  #define SQL_HANDLE_STMT            3
  #define SQL_HANDLE_DESC            4
  #endif
  
  /* environment attribute */
  #if (ODBCVER >= 0x0300)
  #define SQL_ATTR_OUTPUT_NTS    10001
  #endif
--- 1,82 ----
! /*****************************************************************
! ** SQL.H - This is the the main include for ODBC Core functions.
! **
! ** preconditions:
! **      #include "windows.h"
! **
! ** (C) Copyright 1990 - 1996 By Microsoft Corp.
! **
! **      Updated 5/12/93 for 2.00 specification
! **      Updated 5/23/94 for 2.01 specification
! **      Updated 11/10/94 for 2.10 specification
! **      Updated 04/10/95 for 2.50 specification
! **      Updated 6/6/95  for 3.00 specification
! *********************************************************************/
! 
! 
! #ifndef __SQL
! #define __SQL
! 
! /*
! * ODBCVER  ODBC version number (0x0300).   To exclude
! *          definitions introduced in version 3.0 (or above)
! *          #define ODBCVER 0x0250 before #including <sql.h>
! */
  #ifndef ODBCVER
! #define ODBCVER 0x0300
  #endif
  
+ #ifndef __SQLTYPES
  #include "sqltypes.h"
+ #endif
  
  #ifdef __cplusplus
! extern "C" { 			/* Assume C declarations for C++   */
! #endif  /* __cplusplus */
  
! /* special length/indicator values */
  #define SQL_NULL_DATA             (-1)
  #define SQL_DATA_AT_EXEC          (-2)
+ 
+ 
+ /* return values from functions */
  #define SQL_SUCCESS                0
  #define SQL_SUCCESS_WITH_INFO      1
  #if (ODBCVER >= 0x0300)
  #define SQL_NO_DATA              100
  #endif
  #define SQL_ERROR                 (-1)
  #define SQL_INVALID_HANDLE        (-2)
+ 
  #define SQL_STILL_EXECUTING        2
  #define SQL_NEED_DATA             99
+ 
+ /* test for SQL_SUCCESS or SQL_SUCCESS_WITH_INFO */
  #define SQL_SUCCEEDED(rc) (((rc)&(~1))==0)
  
! /* flags for null-terminated string */
  #define SQL_NTS                   (-3)
  #define SQL_NTSL                  (-3L)
  
  /* maximum message length */
  #define SQL_MAX_MESSAGE_LENGTH   512
  
  /* date/time length constants */
  #if (ODBCVER >= 0x0300)
  #define SQL_DATE_LEN           10
  #define SQL_TIME_LEN            8  /* add P+1 if precision is nonzero */
  #define SQL_TIMESTAMP_LEN      19  /* add P+1 if precision is nonzero */
  #endif
  
  /* handle type identifiers */
  #if (ODBCVER >= 0x0300)
  #define SQL_HANDLE_ENV             1
  #define SQL_HANDLE_DBC             2
  #define SQL_HANDLE_STMT            3
  #define SQL_HANDLE_DESC            4
  #endif
  
  /* environment attribute */
  #if (ODBCVER >= 0x0300)
  #define SQL_ATTR_OUTPUT_NTS    10001
  #endif
***************
*** 101,171 ****
  #define SQL_DESC_DATA_PTR               1010
  #define SQL_DESC_NAME                   1011
  #define SQL_DESC_UNNAMED                1012
  #define SQL_DESC_OCTET_LENGTH           1013
  #define SQL_DESC_ALLOC_TYPE             1099
  #endif
  
  /* identifiers of fields in the diagnostics area */
  #if (ODBCVER >= 0x0300)
  #define SQL_DIAG_RETURNCODE        1
  #define SQL_DIAG_NUMBER            2
  #define SQL_DIAG_ROW_COUNT         3
  #define SQL_DIAG_SQLSTATE          4
  #define SQL_DIAG_NATIVE            5
  #define SQL_DIAG_MESSAGE_TEXT      6
  #define SQL_DIAG_DYNAMIC_FUNCTION  7
  #define SQL_DIAG_CLASS_ORIGIN      8
  #define SQL_DIAG_SUBCLASS_ORIGIN   9
  #define SQL_DIAG_CONNECTION_NAME  10
  #define SQL_DIAG_SERVER_NAME      11
  #define SQL_DIAG_DYNAMIC_FUNCTION_CODE 12
  #endif
  
  /* dynamic function codes */
  #if (ODBCVER >= 0x0300)
- #define SQL_DIAG_ALTER_DOMAIN			3
  #define SQL_DIAG_ALTER_TABLE            4
- #define SQL_DIAG_CALL					7
- #define SQL_DIAG_CREATE_ASSERTION		6
- #define SQL_DIAG_CREATE_CHARACTER_SET	8
- #define SQL_DIAG_CREATE_COLLATION		10
- #define SQL_DIAG_CREATE_DOMAIN			23
  #define SQL_DIAG_CREATE_INDEX          (-1)
- #define SQL_DIAG_CREATE_SCHEMA			64
  #define SQL_DIAG_CREATE_TABLE          77
- #define SQL_DIAG_CREATE_TRANSLATION		79
  #define SQL_DIAG_CREATE_VIEW           84
  #define SQL_DIAG_DELETE_WHERE          19
- #define	SQL_DIAG_DROP_ASSERTION			24
- #define	SQL_DIAG_DROP_CHARACTER_SET		25
- #define	SQL_DIAG_DROP_COLLATION			26
- #define	SQL_DIAG_DROP_DOMAIN			27
  #define SQL_DIAG_DROP_INDEX            (-2)
- #define SQL_DIAG_DROP_SCHEMA			31
  #define SQL_DIAG_DROP_TABLE            32
- #define SQL_DIAG_DROP_TRANSLATION      33
  #define SQL_DIAG_DROP_VIEW             36
  #define SQL_DIAG_DYNAMIC_DELETE_CURSOR 38
  #define SQL_DIAG_DYNAMIC_UPDATE_CURSOR 81
  #define SQL_DIAG_GRANT                 48
  #define SQL_DIAG_INSERT                50
  #define SQL_DIAG_REVOKE                59
  #define SQL_DIAG_SELECT_CURSOR         85
  #define SQL_DIAG_UNKNOWN_STATEMENT      0
  #define SQL_DIAG_UPDATE_WHERE          82
  #endif  /* ODBCVER >= 0x0300 */
  
  /* SQL data type codes */
  #define	SQL_UNKNOWN_TYPE	0
  #define SQL_CHAR            1
  #define SQL_NUMERIC         2
  #define SQL_DECIMAL         3
  #define SQL_INTEGER         4
  #define SQL_SMALLINT        5
  #define SQL_FLOAT           6
  #define SQL_REAL            7
  #define SQL_DOUBLE          8
  #if (ODBCVER >= 0x0300)
  #define SQL_DATETIME        9
  #endif
  #define SQL_VARCHAR        12
--- 117,173 ----
***************
*** 226,277 ****
   */
  #if (ODBCVER >= 0x0300)
  #define SQL_PRED_NONE     0
  #define SQL_PRED_CHAR     1
  #define SQL_PRED_BASIC    2
  #endif
  
  /* values of UNNAMED field in descriptor */
  #if (ODBCVER >= 0x0300)
  #define SQL_NAMED           0
  #define SQL_UNNAMED         1
  #endif
  
  /* values of ALLOC_TYPE field in descriptor */
  #if (ODBCVER >= 0x0300)
  #define SQL_DESC_ALLOC_AUTO 1
  #define SQL_DESC_ALLOC_USER 2
  #endif
  
  /* FreeStmt() options */
  #define SQL_CLOSE           0
  #define SQL_DROP            1
  #define SQL_UNBIND          2
  #define SQL_RESET_PARAMS    3
  
! /* Codes used for FetchOrientation in SQLFetchScroll(),
!    and in SQLDataSources()
  */
  #define SQL_FETCH_NEXT      1
  #define SQL_FETCH_FIRST     2
  
  /* Other codes used for FetchOrientation in SQLFetchScroll() */
  #define SQL_FETCH_LAST      3
  #define SQL_FETCH_PRIOR     4
  #define SQL_FETCH_ABSOLUTE  5
  #define SQL_FETCH_RELATIVE  6
  
  /* SQLEndTran() options */
  #define SQL_COMMIT          0
  #define SQL_ROLLBACK        1
  
  /* null handles returned by SQLAllocHandle() */
  #define SQL_NULL_HENV       0
  #define SQL_NULL_HDBC       0
  #define SQL_NULL_HSTMT      0
  #if (ODBCVER >= 0x0300)
  #define SQL_NULL_HDESC      0
  #endif
  
  /* null handle used in place of parent handle when allocating HENV */
  #if (ODBCVER >= 0x0300)
  #define SQL_NULL_HANDLE     0L
--- 228,279 ----
   */
  #if (ODBCVER >= 0x0300)
  #define SQL_PRED_NONE     0
  #define SQL_PRED_CHAR     1
  #define SQL_PRED_BASIC    2
  #endif
  
  /* values of UNNAMED field in descriptor */
  #if (ODBCVER >= 0x0300)
  #define SQL_NAMED           0
  #define SQL_UNNAMED         1
  #endif
  
  /* values of ALLOC_TYPE field in descriptor */
  #if (ODBCVER >= 0x0300)
  #define SQL_DESC_ALLOC_AUTO 1
  #define SQL_DESC_ALLOC_USER 2
  #endif
  
  /* FreeStmt() options */
  #define SQL_CLOSE           0
  #define SQL_DROP            1
  #define SQL_UNBIND          2
  #define SQL_RESET_PARAMS    3
  
! /* Codes used for FetchOrientation in SQLFetchScroll(), 
!    and in SQLDataSources() 
  */
  #define SQL_FETCH_NEXT      1
  #define SQL_FETCH_FIRST     2
  
  /* Other codes used for FetchOrientation in SQLFetchScroll() */
  #define SQL_FETCH_LAST      3
  #define SQL_FETCH_PRIOR     4
  #define SQL_FETCH_ABSOLUTE  5
  #define SQL_FETCH_RELATIVE  6
  
  /* SQLEndTran() options */
  #define SQL_COMMIT          0
  #define SQL_ROLLBACK        1
  
  /* null handles returned by SQLAllocHandle() */
  #define SQL_NULL_HENV       0
  #define SQL_NULL_HDBC       0
  #define SQL_NULL_HSTMT      0
  #if (ODBCVER >= 0x0300)
  #define SQL_NULL_HDESC      0
  #endif
  
  /* null handle used in place of parent handle when allocating HENV */
  #if (ODBCVER >= 0x0300)
  #define SQL_NULL_HANDLE     0L
***************
*** 540,817 ****
  #define SQL_SCCO_LOCK                       0x00000002L
  #define SQL_SCCO_OPT_ROWVER                 0x00000004L
  #define SQL_SCCO_OPT_VALUES                 0x00000008L
  
  /* SQL_TXN_CAPABLE values */
  #define SQL_TC_NONE                         0
  #define SQL_TC_DML                          1
  #define SQL_TC_ALL                          2
  #define SQL_TC_DDL_COMMIT                   3
  #define SQL_TC_DDL_IGNORE                   4
  
  /* SQL_TXN_ISOLATION_OPTION bitmasks */
  #define SQL_TXN_READ_UNCOMMITTED            0x00000001L
  #define SQL_TRANSACTION_READ_UNCOMMITTED	SQL_TXN_READ_UNCOMMITTED
  #define SQL_TXN_READ_COMMITTED              0x00000002L
  #define SQL_TRANSACTION_READ_COMMITTED		SQL_TXN_READ_COMMITTED
  #define SQL_TXN_REPEATABLE_READ             0x00000004L
  #define SQL_TRANSACTION_REPEATABLE_READ		SQL_TXN_REPEATABLE_READ
  #define SQL_TXN_SERIALIZABLE                0x00000008L
  #define SQL_TRANSACTION_SERIALIZABLE		SQL_TXN_SERIALIZABLE
  
  /* SQL_NULL_COLLATION values */
  #define SQL_NC_HIGH                         0
  #define SQL_NC_LOW                          1
  
! SQLRETURN   SQLAllocConnect(SQLHENV EnvironmentHandle,
             SQLHDBC *ConnectionHandle);
  
! SQLRETURN   SQLAllocEnv(SQLHENV *EnvironmentHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLAllocHandle(SQLSMALLINT HandleType,
             SQLHANDLE InputHandle, SQLHANDLE *OutputHandle);
  #endif
  
! SQLRETURN   SQLAllocStmt(SQLHDBC ConnectionHandle,
             SQLHSTMT *StatementHandle);
  
! SQLRETURN   SQLBindCol(SQLHSTMT StatementHandle,
! 		   SQLUSMALLINT ColumnNumber, SQLSMALLINT TargetType,
! 		   SQLPOINTER TargetValue, SQLINTEGER BufferLength,
  	   	   SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLBindParam(SQLHSTMT StatementHandle,
             SQLUSMALLINT ParameterNumber, SQLSMALLINT ValueType,
             SQLSMALLINT ParameterType, SQLUINTEGER LengthPrecision,
             SQLSMALLINT ParameterScale, SQLPOINTER ParameterValue,
             SQLINTEGER *StrLen_or_Ind);
  #endif
  
! SQLRETURN   SQLCancel(SQLHSTMT StatementHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLCloseCursor(SQLHSTMT StatementHandle);
  
! SQLRETURN   SQLColAttribute (SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLUSMALLINT FieldIdentifier,
             SQLPOINTER CharacterAttribute, SQLSMALLINT BufferLength,
             SQLSMALLINT *StringLength, SQLPOINTER NumericAttribute);
  #endif
  
  
! SQLRETURN   SQLColumns(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLCHAR *ColumnName, SQLSMALLINT NameLength4);
  
  
! SQLRETURN   SQLConnect(SQLHDBC ConnectionHandle,
             SQLCHAR *ServerName, SQLSMALLINT NameLength1,
             SQLCHAR *UserName, SQLSMALLINT NameLength2,
             SQLCHAR *Authentication, SQLSMALLINT NameLength3);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLCopyDesc(SQLHDESC SourceDescHandle,
             SQLHDESC TargetDescHandle);
  #endif
  
! SQLRETURN   SQLDataSources(SQLHENV EnvironmentHandle,
             SQLUSMALLINT Direction, SQLCHAR *ServerName,
             SQLSMALLINT BufferLength1, SQLSMALLINT *NameLength1,
             SQLCHAR *Description, SQLSMALLINT BufferLength2,
             SQLSMALLINT *NameLength2);
  
! SQLRETURN   SQLDescribeCol(SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLCHAR *ColumnName,
             SQLSMALLINT BufferLength, SQLSMALLINT *NameLength,
             SQLSMALLINT *DataType, SQLUINTEGER *ColumnSize,
             SQLSMALLINT *DecimalDigits, SQLSMALLINT *Nullable);
  
! SQLRETURN   SQLDisconnect(SQLHDBC ConnectionHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLEndTran(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT CompletionType);
  #endif
  
! SQLRETURN   SQLError(SQLHENV EnvironmentHandle,
             SQLHDBC ConnectionHandle, SQLHSTMT StatementHandle,
             SQLCHAR *Sqlstate, SQLINTEGER *NativeError,
             SQLCHAR *MessageText, SQLSMALLINT BufferLength,
             SQLSMALLINT *TextLength);
  
! SQLRETURN   SQLExecDirect(SQLHSTMT StatementHandle,
             SQLCHAR *StatementText, SQLINTEGER TextLength);
  
! SQLRETURN   SQLExecute(SQLHSTMT StatementHandle);
  
! SQLRETURN   SQLFetch(SQLHSTMT StatementHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLFetchScroll(SQLHSTMT StatementHandle,
             SQLSMALLINT FetchOrientation, SQLINTEGER FetchOffset);
  #endif
  
! SQLRETURN   SQLFreeConnect(SQLHDBC ConnectionHandle);
  
! SQLRETURN   SQLFreeEnv(SQLHENV EnvironmentHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLFreeHandle(SQLSMALLINT HandleType, SQLHANDLE Handle);
  #endif
  
! SQLRETURN   SQLFreeStmt(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLGetConnectAttr(SQLHDBC ConnectionHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif
  
! SQLRETURN   SQLGetConnectOption(SQLHDBC ConnectionHandle,
             SQLUSMALLINT Option, SQLPOINTER Value);
  
! SQLRETURN   SQLGetCursorName(SQLHSTMT StatementHandle,
             SQLCHAR *CursorName, SQLSMALLINT BufferLength,
             SQLSMALLINT *NameLength);
  
! SQLRETURN   SQLGetData(SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLSMALLINT TargetType,
             SQLPOINTER TargetValue, SQLINTEGER BufferLength,
             SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLGetDescField(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT FieldIdentifier,
             SQLPOINTER Value, SQLINTEGER BufferLength,
             SQLINTEGER *StringLength);
  
! SQLRETURN   SQLGetDescRec(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLCHAR *Name,
             SQLSMALLINT BufferLength, SQLSMALLINT *StringLength,
!            SQLSMALLINT *Type, SQLSMALLINT *SubType,
!            SQLINTEGER *Length, SQLSMALLINT *Precision,
             SQLSMALLINT *Scale, SQLSMALLINT *Nullable);
  
! SQLRETURN   SQLGetDiagField(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT RecNumber, SQLSMALLINT DiagIdentifier,
             SQLPOINTER DiagInfo, SQLSMALLINT BufferLength,
             SQLSMALLINT *StringLength);
  
! SQLRETURN   SQLGetDiagRec(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT RecNumber, SQLCHAR *Sqlstate,
             SQLINTEGER *NativeError, SQLCHAR *MessageText,
             SQLSMALLINT BufferLength, SQLSMALLINT *TextLength);
  
! SQLRETURN   SQLGetEnvAttr(SQLHENV EnvironmentHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif  /* ODBCVER >= 0x0300 */
  
! SQLRETURN   SQLGetFunctions(SQLHDBC ConnectionHandle,
             SQLUSMALLINT FunctionId, SQLUSMALLINT *Supported);
  
! SQLRETURN   SQLGetInfo(SQLHDBC ConnectionHandle,
             SQLUSMALLINT InfoType, SQLPOINTER InfoValue,
             SQLSMALLINT BufferLength, SQLSMALLINT *StringLength);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLGetStmtAttr(SQLHSTMT StatementHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif  /* ODBCVER >= 0x0300 */
  
! SQLRETURN   SQLGetStmtOption(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option, SQLPOINTER Value);
  
! SQLRETURN   SQLGetTypeInfo(SQLHSTMT StatementHandle,
             SQLSMALLINT DataType);
  
! SQLRETURN   SQLNumResultCols(SQLHSTMT StatementHandle,
             SQLSMALLINT *ColumnCount);
  
! SQLRETURN   SQLParamData(SQLHSTMT StatementHandle,
             SQLPOINTER *Value);
  
! SQLRETURN   SQLPrepare(SQLHSTMT StatementHandle,
             SQLCHAR *StatementText, SQLINTEGER TextLength);
  
! SQLRETURN   SQLPutData(SQLHSTMT StatementHandle,
             SQLPOINTER Data, SQLINTEGER StrLen_or_Ind);
  
! SQLRETURN   SQLRowCount(SQLHSTMT StatementHandle,
  	   SQLINTEGER *RowCount);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLSetConnectAttr(SQLHDBC ConnectionHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif /* ODBCVER >= 0x0300 */
  
! SQLRETURN   SQLSetConnectOption(SQLHDBC ConnectionHandle,
             SQLUSMALLINT Option, SQLUINTEGER Value);
  
! SQLRETURN   SQLSetCursorName(SQLHSTMT StatementHandle,
             SQLCHAR *CursorName, SQLSMALLINT NameLength);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLSetDescField(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT FieldIdentifier,
             SQLPOINTER Value, SQLINTEGER BufferLength);
  
! SQLRETURN   SQLSetDescRec(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT Type,
             SQLSMALLINT SubType, SQLINTEGER Length,
             SQLSMALLINT Precision, SQLSMALLINT Scale,
             SQLPOINTER Data, SQLINTEGER *StringLength,
             SQLINTEGER *Indicator);
  
! SQLRETURN   SQLSetEnvAttr(SQLHENV EnvironmentHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif /* ODBCVER >= 0x0300 */
  
! SQLRETURN   SQLSetParam(SQLHSTMT StatementHandle,
             SQLUSMALLINT ParameterNumber, SQLSMALLINT ValueType,
             SQLSMALLINT ParameterType, SQLUINTEGER LengthPrecision,
             SQLSMALLINT ParameterScale, SQLPOINTER ParameterValue,
             SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN   SQLSetStmtAttr(SQLHSTMT StatementHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif
  
! SQLRETURN   SQLSetStmtOption(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option, SQLUINTEGER Value);
  
! SQLRETURN   SQLSpecialColumns(SQLHSTMT StatementHandle,
             SQLUSMALLINT IdentifierType, SQLCHAR *CatalogName,
             SQLSMALLINT NameLength1, SQLCHAR *SchemaName,
             SQLSMALLINT NameLength2, SQLCHAR *TableName,
             SQLSMALLINT NameLength3, SQLUSMALLINT Scope,
             SQLUSMALLINT Nullable);
  
! SQLRETURN   SQLStatistics(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLUSMALLINT Unique, SQLUSMALLINT Reserved);
  
! SQLRETURN   SQLTables(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLCHAR *TableType, SQLSMALLINT NameLength4);
  
! SQLRETURN   SQLTransact(SQLHENV EnvironmentHandle,
             SQLHDBC ConnectionHandle, SQLUSMALLINT CompletionType);
  
  #ifdef __cplusplus
! }
! #endif
! #endif	
--- 542,823 ----
  #define SQL_SCCO_LOCK                       0x00000002L
  #define SQL_SCCO_OPT_ROWVER                 0x00000004L
  #define SQL_SCCO_OPT_VALUES                 0x00000008L
  
  /* SQL_TXN_CAPABLE values */
  #define SQL_TC_NONE                         0
  #define SQL_TC_DML                          1
  #define SQL_TC_ALL                          2
  #define SQL_TC_DDL_COMMIT                   3
  #define SQL_TC_DDL_IGNORE                   4
  
  /* SQL_TXN_ISOLATION_OPTION bitmasks */
  #define SQL_TXN_READ_UNCOMMITTED            0x00000001L
  #define SQL_TRANSACTION_READ_UNCOMMITTED	SQL_TXN_READ_UNCOMMITTED
  #define SQL_TXN_READ_COMMITTED              0x00000002L
  #define SQL_TRANSACTION_READ_COMMITTED		SQL_TXN_READ_COMMITTED
  #define SQL_TXN_REPEATABLE_READ             0x00000004L
  #define SQL_TRANSACTION_REPEATABLE_READ		SQL_TXN_REPEATABLE_READ
  #define SQL_TXN_SERIALIZABLE                0x00000008L
  #define SQL_TRANSACTION_SERIALIZABLE		SQL_TXN_SERIALIZABLE
  
  /* SQL_NULL_COLLATION values */
  #define SQL_NC_HIGH                         0
  #define SQL_NC_LOW                          1
  
! #ifndef RC_INVOKED
! 
! SQLRETURN  SQL_API SQLAllocConnect(SQLHENV EnvironmentHandle,
             SQLHDBC *ConnectionHandle);
  
! SQLRETURN  SQL_API SQLAllocEnv(SQLHENV *EnvironmentHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLAllocHandle(SQLSMALLINT HandleType,
             SQLHANDLE InputHandle, SQLHANDLE *OutputHandle);
  #endif
  
! SQLRETURN  SQL_API SQLAllocStmt(SQLHDBC ConnectionHandle,
             SQLHSTMT *StatementHandle);
  
! SQLRETURN  SQL_API SQLBindCol(SQLHSTMT StatementHandle, 
! 		   SQLUSMALLINT ColumnNumber, SQLSMALLINT TargetType, 
! 		   SQLPOINTER TargetValue, SQLINTEGER BufferLength, 
  	   	   SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLBindParam(SQLHSTMT StatementHandle,
             SQLUSMALLINT ParameterNumber, SQLSMALLINT ValueType,
             SQLSMALLINT ParameterType, SQLUINTEGER LengthPrecision,
             SQLSMALLINT ParameterScale, SQLPOINTER ParameterValue,
             SQLINTEGER *StrLen_or_Ind);
  #endif
  
! SQLRETURN  SQL_API SQLCancel(SQLHSTMT StatementHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLCloseCursor(SQLHSTMT StatementHandle);
  
! SQLRETURN  SQL_API SQLColAttribute (SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLUSMALLINT FieldIdentifier,
             SQLPOINTER CharacterAttribute, SQLSMALLINT BufferLength,
             SQLSMALLINT *StringLength, SQLPOINTER NumericAttribute);
  #endif
  
  
! SQLRETURN  SQL_API SQLColumns(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLCHAR *ColumnName, SQLSMALLINT NameLength4);
  
  
! SQLRETURN  SQL_API SQLConnect(SQLHDBC ConnectionHandle,
             SQLCHAR *ServerName, SQLSMALLINT NameLength1,
             SQLCHAR *UserName, SQLSMALLINT NameLength2,
             SQLCHAR *Authentication, SQLSMALLINT NameLength3);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLCopyDesc(SQLHDESC SourceDescHandle,
             SQLHDESC TargetDescHandle);
  #endif
  
! SQLRETURN  SQL_API SQLDataSources(SQLHENV EnvironmentHandle,
             SQLUSMALLINT Direction, SQLCHAR *ServerName,
             SQLSMALLINT BufferLength1, SQLSMALLINT *NameLength1,
             SQLCHAR *Description, SQLSMALLINT BufferLength2,
             SQLSMALLINT *NameLength2);
  
! SQLRETURN  SQL_API SQLDescribeCol(SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLCHAR *ColumnName,
             SQLSMALLINT BufferLength, SQLSMALLINT *NameLength,
             SQLSMALLINT *DataType, SQLUINTEGER *ColumnSize,
             SQLSMALLINT *DecimalDigits, SQLSMALLINT *Nullable);
  
! SQLRETURN  SQL_API SQLDisconnect(SQLHDBC ConnectionHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLEndTran(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT CompletionType);
  #endif
  
! SQLRETURN  SQL_API SQLError(SQLHENV EnvironmentHandle,
             SQLHDBC ConnectionHandle, SQLHSTMT StatementHandle,
             SQLCHAR *Sqlstate, SQLINTEGER *NativeError,
             SQLCHAR *MessageText, SQLSMALLINT BufferLength,
             SQLSMALLINT *TextLength);
  
! SQLRETURN  SQL_API SQLExecDirect(SQLHSTMT StatementHandle,
             SQLCHAR *StatementText, SQLINTEGER TextLength);
  
! SQLRETURN  SQL_API SQLExecute(SQLHSTMT StatementHandle);
  
! SQLRETURN  SQL_API SQLFetch(SQLHSTMT StatementHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLFetchScroll(SQLHSTMT StatementHandle,
             SQLSMALLINT FetchOrientation, SQLINTEGER FetchOffset);
  #endif
  
! SQLRETURN  SQL_API SQLFreeConnect(SQLHDBC ConnectionHandle);
  
! SQLRETURN  SQL_API SQLFreeEnv(SQLHENV EnvironmentHandle);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLFreeHandle(SQLSMALLINT HandleType, SQLHANDLE Handle);
  #endif
  
! SQLRETURN  SQL_API SQLFreeStmt(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLGetConnectAttr(SQLHDBC ConnectionHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif
  
! SQLRETURN  SQL_API SQLGetConnectOption(SQLHDBC ConnectionHandle,
             SQLUSMALLINT Option, SQLPOINTER Value);
  
! SQLRETURN  SQL_API SQLGetCursorName(SQLHSTMT StatementHandle,
             SQLCHAR *CursorName, SQLSMALLINT BufferLength,
             SQLSMALLINT *NameLength);
  
! SQLRETURN  SQL_API SQLGetData(SQLHSTMT StatementHandle,
             SQLUSMALLINT ColumnNumber, SQLSMALLINT TargetType,
             SQLPOINTER TargetValue, SQLINTEGER BufferLength,
             SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLGetDescField(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT FieldIdentifier,
             SQLPOINTER Value, SQLINTEGER BufferLength,
             SQLINTEGER *StringLength);
  
! SQLRETURN  SQL_API SQLGetDescRec(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLCHAR *Name,
             SQLSMALLINT BufferLength, SQLSMALLINT *StringLength,
!            SQLSMALLINT *Type, SQLSMALLINT *SubType, 
!            SQLINTEGER *Length, SQLSMALLINT *Precision, 
             SQLSMALLINT *Scale, SQLSMALLINT *Nullable);
  
! SQLRETURN  SQL_API SQLGetDiagField(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT RecNumber, SQLSMALLINT DiagIdentifier,
             SQLPOINTER DiagInfo, SQLSMALLINT BufferLength,
             SQLSMALLINT *StringLength);
  
! SQLRETURN  SQL_API SQLGetDiagRec(SQLSMALLINT HandleType, SQLHANDLE Handle,
             SQLSMALLINT RecNumber, SQLCHAR *Sqlstate,
             SQLINTEGER *NativeError, SQLCHAR *MessageText,
             SQLSMALLINT BufferLength, SQLSMALLINT *TextLength);
  
! SQLRETURN  SQL_API SQLGetEnvAttr(SQLHENV EnvironmentHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif  /* ODBCVER >= 0x0300 */
  
! SQLRETURN  SQL_API SQLGetFunctions(SQLHDBC ConnectionHandle,
             SQLUSMALLINT FunctionId, SQLUSMALLINT *Supported);
  
! SQLRETURN  SQL_API SQLGetInfo(SQLHDBC ConnectionHandle,
             SQLUSMALLINT InfoType, SQLPOINTER InfoValue,
             SQLSMALLINT BufferLength, SQLSMALLINT *StringLength);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLGetStmtAttr(SQLHSTMT StatementHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER BufferLength, SQLINTEGER *StringLength);
  #endif  /* ODBCVER >= 0x0300 */
  
! SQLRETURN  SQL_API SQLGetStmtOption(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option, SQLPOINTER Value);
  
! SQLRETURN  SQL_API SQLGetTypeInfo(SQLHSTMT StatementHandle,
             SQLSMALLINT DataType);
  
! SQLRETURN  SQL_API SQLNumResultCols(SQLHSTMT StatementHandle,
             SQLSMALLINT *ColumnCount);
  
! SQLRETURN  SQL_API SQLParamData(SQLHSTMT StatementHandle,
             SQLPOINTER *Value);
  
! SQLRETURN  SQL_API SQLPrepare(SQLHSTMT StatementHandle,
             SQLCHAR *StatementText, SQLINTEGER TextLength);
  
! SQLRETURN  SQL_API SQLPutData(SQLHSTMT StatementHandle,
             SQLPOINTER Data, SQLINTEGER StrLen_or_Ind);
  
! SQLRETURN  SQL_API SQLRowCount(SQLHSTMT StatementHandle, 
  	   SQLINTEGER *RowCount);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLSetConnectAttr(SQLHDBC ConnectionHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif /* ODBCVER >= 0x0300 */
  
! SQLRETURN  SQL_API SQLSetConnectOption(SQLHDBC ConnectionHandle,
             SQLUSMALLINT Option, SQLUINTEGER Value);
  
! SQLRETURN  SQL_API SQLSetCursorName(SQLHSTMT StatementHandle,
             SQLCHAR *CursorName, SQLSMALLINT NameLength);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLSetDescField(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT FieldIdentifier,
             SQLPOINTER Value, SQLINTEGER BufferLength);
  
! SQLRETURN  SQL_API SQLSetDescRec(SQLHDESC DescriptorHandle,
             SQLSMALLINT RecNumber, SQLSMALLINT Type,
             SQLSMALLINT SubType, SQLINTEGER Length,
             SQLSMALLINT Precision, SQLSMALLINT Scale,
             SQLPOINTER Data, SQLINTEGER *StringLength,
             SQLINTEGER *Indicator);
  
! SQLRETURN  SQL_API SQLSetEnvAttr(SQLHENV EnvironmentHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif /* ODBCVER >= 0x0300 */
  
! SQLRETURN  SQL_API SQLSetParam(SQLHSTMT StatementHandle,
             SQLUSMALLINT ParameterNumber, SQLSMALLINT ValueType,
             SQLSMALLINT ParameterType, SQLUINTEGER LengthPrecision,
             SQLSMALLINT ParameterScale, SQLPOINTER ParameterValue,
             SQLINTEGER *StrLen_or_Ind);
  
  #if (ODBCVER >= 0x0300)
! SQLRETURN  SQL_API SQLSetStmtAttr(SQLHSTMT StatementHandle,
             SQLINTEGER Attribute, SQLPOINTER Value,
             SQLINTEGER StringLength);
  #endif
  
! SQLRETURN  SQL_API SQLSetStmtOption(SQLHSTMT StatementHandle,
             SQLUSMALLINT Option, SQLUINTEGER Value);
  
! SQLRETURN  SQL_API SQLSpecialColumns(SQLHSTMT StatementHandle,
             SQLUSMALLINT IdentifierType, SQLCHAR *CatalogName,
             SQLSMALLINT NameLength1, SQLCHAR *SchemaName,
             SQLSMALLINT NameLength2, SQLCHAR *TableName,
             SQLSMALLINT NameLength3, SQLUSMALLINT Scope,
             SQLUSMALLINT Nullable);
  
! SQLRETURN  SQL_API SQLStatistics(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLUSMALLINT Unique, SQLUSMALLINT Reserved);
  
! SQLRETURN  SQL_API SQLTables(SQLHSTMT StatementHandle,
             SQLCHAR *CatalogName, SQLSMALLINT NameLength1,
             SQLCHAR *SchemaName, SQLSMALLINT NameLength2,
             SQLCHAR *TableName, SQLSMALLINT NameLength3,
             SQLCHAR *TableType, SQLSMALLINT NameLength4);
  
! SQLRETURN  SQL_API SQLTransact(SQLHENV EnvironmentHandle,
             SQLHDBC ConnectionHandle, SQLUSMALLINT CompletionType);
  
+ #endif  /* RC_INVOKED */
+ 
  #ifdef __cplusplus
! }                                    /* End of extern "C" { */
! #endif  /* __cplusplus */
! #endif	/* #ifndef __SQL */
