*** orig/zlib-1.1.3/deflate.h	Sat Aug 26 22:17:46 2000
--- modified/zlib-1.1.3/deflate.h	Sat Aug 26 22:17:46 2000
***************
*** 1,36 ****
  /* deflate.h -- internal compression state
!  * Copyright (C) 1995-1998 Jean-loup Gailly
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
  /* WARNING: this file should *not* be used by applications. It is
     part of the implementation of the compression library and is
     subject to change. Applications should only use zlib.h.
   */
  
! /* @(#) $Id$ */
  
  #ifndef _DEFLATE_H
  #define _DEFLATE_H
  
  #include "zutil.h"
  
  /* ===========================================================================
   * Internal compression state.
   */
  
  #define LENGTH_CODES 29
  /* number of length codes, not counting the special END_BLOCK code */
  
  #define LITERALS  256
  /* number of literal bytes 0..255 */
  
  #define L_CODES (LITERALS+1+LENGTH_CODES)
  /* number of Literal or Length codes, including the END_BLOCK code */
  
  #define D_CODES   30
  /* number of distance codes */
  
  #define BL_CODES  19
  /* number of codes used to transfer the bit lengths */
  
--- 1,36 ----
  /* deflate.h -- internal compression state
!  * Copyright (C) 1995-1996 Jean-loup Gailly
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
  /* WARNING: this file should *not* be used by applications. It is
     part of the implementation of the compression library and is
     subject to change. Applications should only use zlib.h.
   */
  
! /* $Id: deflate.h,v 1.1 2000/06/28 16:53:59 sj Exp $ */
  
  #ifndef _DEFLATE_H
  #define _DEFLATE_H
  
  #include "zutil.h"
  
  /* ===========================================================================
   * Internal compression state.
   */
  
  #define LENGTH_CODES 29
  /* number of length codes, not counting the special END_BLOCK code */
  
  #define LITERALS  256
  /* number of literal bytes 0..255 */
  
  #define L_CODES (LITERALS+1+LENGTH_CODES)
  /* number of Literal or Length codes, including the END_BLOCK code */
  
  #define D_CODES   30
  /* number of distance codes */
  
  #define BL_CODES  19
  /* number of codes used to transfer the bit lengths */
  
***************
*** 61,111 ****
  #define Freq fc.freq
  #define Code fc.code
  #define Dad  dl.dad
  #define Len  dl.len
  
  typedef struct static_tree_desc_s  static_tree_desc;
  
  typedef struct tree_desc_s {
      ct_data *dyn_tree;           /* the dynamic tree */
      int     max_code;            /* largest code with non zero frequency */
      static_tree_desc *stat_desc; /* the corresponding static tree */
  } FAR tree_desc;
  
  typedef ush Pos;
  typedef Pos FAR Posf;
  typedef unsigned IPos;
  
  /* A Pos is an index in the character window. We use short instead of int to
   * save space in the various tables. IPos is used only for parameter passing.
   */
  
  typedef struct internal_state {
      z_streamp strm;      /* pointer back to this zlib stream */
      int   status;        /* as the name implies */
      Bytef *pending_buf;  /* output still pending */
-     ulg   pending_buf_size; /* size of pending_buf */
      Bytef *pending_out;  /* next pending byte to output to the stream */
      int   pending;       /* nb of bytes in the pending buffer */
      int   noheader;      /* suppress zlib header and adler32 */
      Byte  data_type;     /* UNKNOWN, BINARY or ASCII */
      Byte  method;        /* STORED (for zip only) or DEFLATED */
      int   last_flush;    /* value of flush param for previous deflate call */
  
                  /* used by deflate.c: */
  
      uInt  w_size;        /* LZ77 window size (32K by default) */
      uInt  w_bits;        /* log2(w_size)  (8..16) */
      uInt  w_mask;        /* w_size - 1 */
  
      Bytef *window;
      /* Sliding window. Input bytes are read into the second half of the window,
       * and move to the first half later to keep a dictionary of at least wSize
       * bytes. With this organization, matches are limited to a distance of
       * wSize-MAX_MATCH bytes, but this ensures that IO is always
       * performed with a length multiple of the block size. Also, it limits
       * the window size to 64K, which is quite useful on MSDOS.
       * To do: use the user input buffer as sliding window.
       */
  
      ulg window_size;
      /* Actual size of window: 2*wSize, except when the user input buffer
--- 61,110 ----
***************
*** 208,318 ****
       *     data is still in the window so we can still emit a stored block even
       *     when input comes from standard input.  (This can also be done for
       *     all blocks if lit_bufsize is not greater than 32K.)
       *   - if compression is not successful for a file smaller than 64K, we can
       *     even emit a stored file instead of a stored block (saving 5 bytes).
       *     This is applicable only for zip (not gzip or zlib).
       *   - creating new Huffman trees less frequently may not provide fast
       *     adaptation to changes in the input data statistics. (Take for
       *     example a binary file with poorly compressible code followed by
       *     a highly compressible string table.) Smaller buffer sizes give
       *     fast adaptation but have of course the overhead of transmitting
       *     trees more frequently.
       *   - I can't count above 4
       */
  
      uInt last_lit;      /* running index in l_buf */
  
      ushf *d_buf;
      /* Buffer for distances. To simplify the code, d_buf and l_buf have
       * the same number of elements. To use different lengths, an extra flag
       * array would be necessary.
       */
  
      ulg opt_len;        /* bit length of current block with optimal trees */
      ulg static_len;     /* bit length of current block with static trees */
      uInt matches;       /* number of string matches in current block */
      int last_eob_len;   /* bit length of EOB code for last block */
  
  #ifdef DEBUG
!     ulg compressed_len; /* total bit length of compressed file mod 2^32 */
!     ulg bits_sent;      /* bit length of compressed data sent mod 2^32 */
  #endif
  
      ush bi_buf;
      /* Output buffer. bits are inserted starting at the bottom (least
       * significant bits).
       */
      int bi_valid;
      /* Number of valid bits in bi_buf.  All bits above the last valid bit
       * are always zero.
       */
  
  } FAR deflate_state;
  
  /* Output a byte on the stream.
   * IN assertion: there is enough room in pending_buf.
   */
  #define put_byte(s, c) {s->pending_buf[s->pending++] = (c);}
  
  
  #define MIN_LOOKAHEAD (MAX_MATCH+MIN_MATCH+1)
  /* Minimum amount of lookahead, except at the end of the input file.
   * See deflate.c for comments about the MIN_MATCH+1.
   */
  
  #define MAX_DIST(s)  ((s)->w_size-MIN_LOOKAHEAD)
  /* In order to simplify the code, particularly on 16 bit machines, match
   * distances are limited to MAX_DIST instead of WSIZE.
   */
  
          /* in trees.c */
  void _tr_init         OF((deflate_state *s));
  int  _tr_tally        OF((deflate_state *s, unsigned dist, unsigned lc));
! void _tr_flush_block  OF((deflate_state *s, charf *buf, ulg stored_len,
  			  int eof));
  void _tr_align        OF((deflate_state *s));
  void _tr_stored_block OF((deflate_state *s, charf *buf, ulg stored_len,
                            int eof));
- 
- #define d_code(dist) \
-    ((dist) < 256 ? _dist_code[dist] : _dist_code[256+((dist)>>7)])
- /* Mapping from a distance to a distance code. dist is the distance - 1 and
-  * must not have side effects. _dist_code[256] and _dist_code[257] are never
-  * used.
-  */
- 
- #ifndef DEBUG
- /* Inline versions of _tr_tally for speed: */
- 
- #if defined(GEN_TREES_H) || !defined(STDC)
-   extern uch _length_code[];
-   extern uch _dist_code[];
- #else
-   extern const uch _length_code[];
-   extern const uch _dist_code[];
- #endif
- 
- # define _tr_tally_lit(s, c, flush) \
-   { uch cc = (c); \
-     s->d_buf[s->last_lit] = 0; \
-     s->l_buf[s->last_lit++] = cc; \
-     s->dyn_ltree[cc].Freq++; \
-     flush = (s->last_lit == s->lit_bufsize-1); \
-    }
- # define _tr_tally_dist(s, distance, length, flush) \
-   { uch len = (length); \
-     ush dist = (distance); \
-     s->d_buf[s->last_lit] = dist; \
-     s->l_buf[s->last_lit++] = len; \
-     dist--; \
-     s->dyn_ltree[_length_code[len]+LITERALS+1].Freq++; \
-     s->dyn_dtree[d_code(dist)].Freq++; \
-     flush = (s->last_lit == s->lit_bufsize-1); \
-   }
- #else
- # define _tr_tally_lit(s, c, flush) flush = _tr_tally(s, 0, c)
- # define _tr_tally_dist(s, distance, length, flush) \
-               flush = _tr_tally(s, distance, length) 
- #endif
- 
  #endif
--- 207,275 ----
       *     data is still in the window so we can still emit a stored block even
       *     when input comes from standard input.  (This can also be done for
       *     all blocks if lit_bufsize is not greater than 32K.)
       *   - if compression is not successful for a file smaller than 64K, we can
       *     even emit a stored file instead of a stored block (saving 5 bytes).
       *     This is applicable only for zip (not gzip or zlib).
       *   - creating new Huffman trees less frequently may not provide fast
       *     adaptation to changes in the input data statistics. (Take for
       *     example a binary file with poorly compressible code followed by
       *     a highly compressible string table.) Smaller buffer sizes give
       *     fast adaptation but have of course the overhead of transmitting
       *     trees more frequently.
       *   - I can't count above 4
       */
  
      uInt last_lit;      /* running index in l_buf */
  
      ushf *d_buf;
      /* Buffer for distances. To simplify the code, d_buf and l_buf have
       * the same number of elements. To use different lengths, an extra flag
       * array would be necessary.
       */
  
      ulg opt_len;        /* bit length of current block with optimal trees */
      ulg static_len;     /* bit length of current block with static trees */
+     ulg compressed_len; /* total bit length of compressed file */
      uInt matches;       /* number of string matches in current block */
      int last_eob_len;   /* bit length of EOB code for last block */
  
  #ifdef DEBUG
!     ulg bits_sent;      /* bit length of the compressed data */
  #endif
  
      ush bi_buf;
      /* Output buffer. bits are inserted starting at the bottom (least
       * significant bits).
       */
      int bi_valid;
      /* Number of valid bits in bi_buf.  All bits above the last valid bit
       * are always zero.
       */
  
  } FAR deflate_state;
  
  /* Output a byte on the stream.
   * IN assertion: there is enough room in pending_buf.
   */
  #define put_byte(s, c) {s->pending_buf[s->pending++] = (c);}
  
  
  #define MIN_LOOKAHEAD (MAX_MATCH+MIN_MATCH+1)
  /* Minimum amount of lookahead, except at the end of the input file.
   * See deflate.c for comments about the MIN_MATCH+1.
   */
  
  #define MAX_DIST(s)  ((s)->w_size-MIN_LOOKAHEAD)
  /* In order to simplify the code, particularly on 16 bit machines, match
   * distances are limited to MAX_DIST instead of WSIZE.
   */
  
          /* in trees.c */
  void _tr_init         OF((deflate_state *s));
  int  _tr_tally        OF((deflate_state *s, unsigned dist, unsigned lc));
! ulg  _tr_flush_block  OF((deflate_state *s, charf *buf, ulg stored_len,
  			  int eof));
  void _tr_align        OF((deflate_state *s));
  void _tr_stored_block OF((deflate_state *s, charf *buf, ulg stored_len,
                            int eof));
  #endif
